/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;


import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;
import org.xquark.extractor.xfunctions.*;

public interface GenSqlVisitor {

    public SqlExpression visit(Attribute arg) throws SqlWrapperException;

    public SqlExpression visit(AttributeExpression arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpArithmetic arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpBoolean arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpCompare arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpCompareAny arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpDifference arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpIntersect arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpMerge arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpOuterJoin arg) throws SqlWrapperException;

    public SqlExpression visit(BinOpUnion arg) throws SqlWrapperException;

	public SqlExpression visit(ConstantTempTable arg) throws SqlWrapperException;

    public SqlExpression visit(DummyTable arg) throws SqlWrapperException;

    public SqlExpression visit(ExternalVariable arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpExists arg) throws SqlWrapperException;

    public SqlExpression visit(FunAggregate arg) throws SqlWrapperException;

    public SqlExpression visit(IfThenElse arg) throws SqlWrapperException;

    public SqlExpression visit(Join arg) throws SqlWrapperException;

    public SqlExpression visit(LitBoolean arg) throws SqlWrapperException;

    public SqlExpression visit(LitDate arg) throws SqlWrapperException;

    public SqlExpression visit(LitDouble arg) throws SqlWrapperException;

    public SqlExpression visit(LitFloat arg) throws SqlWrapperException;

    public SqlExpression visit(LitDecimal arg) throws SqlWrapperException;

    public SqlExpression visit(LitInteger arg) throws SqlWrapperException;
    
    public SqlExpression visit(LitList arg) throws SqlWrapperException;

    public SqlExpression visit(LitNull arg) throws SqlWrapperException;

    public SqlExpression visit(LitString arg) throws SqlWrapperException;

    public SqlExpression visit(OuterJoinPredicate arg) throws SqlWrapperException;

    public SqlExpression visit(RenameItem arg) throws SqlWrapperException;

    public SqlExpression visit(RenameRelation arg) throws SqlWrapperException;

    public SqlExpression visit(SortSpecification arg) throws SqlWrapperException;

    public SqlExpression visit(TupleExpression arg) throws SqlWrapperException;

    public SqlExpression visit(Table arg) throws SqlWrapperException;

    public SqlExpression visit(TempValue arg) throws SqlWrapperException;

    public SqlExpression visit(TempTable arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpAggregate arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpGroup arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpIsNull arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpMinus arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpNot arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpProject arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpRestrict arg) throws SqlWrapperException;

    public SqlExpression visit(UnOpSort arg) throws SqlWrapperException;

    public SqlExpression visit(AfCast arg) throws SqlWrapperException;

    public SqlExpression visit(AfTrim arg) throws SqlWrapperException;

    public SqlExpression visit(XfCast arg) throws SqlWrapperException;

    public SqlExpression visit(XfAbs arg) throws SqlWrapperException;

    public SqlExpression visit(XfCeiling arg) throws SqlWrapperException;

    public SqlExpression visit(XfConcat arg) throws SqlWrapperException;

    public SqlExpression visit(XfContains arg) throws SqlWrapperException;

    public SqlExpression visit(XfCurrentDateTime arg) throws SqlWrapperException;

    public SqlExpression visit(XfGetCenturyFromDate arg) throws SqlWrapperException;

    public SqlExpression visit(XfGetHourFromTime arg) throws SqlWrapperException;

    public SqlExpression visit(XfGetMinutesFromtime arg) throws SqlWrapperException;

    public SqlExpression visit(XfGetSecondsFromtime arg) throws SqlWrapperException;

    public SqlExpression visit(XfDate arg) throws SqlWrapperException;

    public SqlExpression visit(XfDateTime arg) throws SqlWrapperException;

    public SqlExpression visit(XfEndsWith arg) throws SqlWrapperException;

    public SqlExpression visit(XfFloor arg) throws SqlWrapperException;

    public SqlExpression visit(XfLowerCase arg) throws SqlWrapperException;

    public SqlExpression visit(XfRound arg) throws SqlWrapperException;

    public SqlExpression visit(XfStartsWith arg) throws SqlWrapperException;

    public SqlExpression visit(XfStringLength arg) throws SqlWrapperException;

    public SqlExpression visit(XfSubString arg) throws SqlWrapperException;

    public SqlExpression visit(XfTime arg) throws SqlWrapperException;

    public SqlExpression visit(XfUpperCase arg) throws SqlWrapperException;

}
