/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;

import org.xquark.extractor.common.Debug;
import org.xquark.extractor.sql.SqlExpression;

public class PseudoExpression extends Expression {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

	CollectionName _collectionName = null;

	public PseudoExpression() {
	}

	public void setCollectionName(CollectionName collectionName)
	{
		_collectionName = collectionName;
	}

	public CollectionName getCollectionName()
	{
		return _collectionName;
	}

	public List getOperands()
	{
		return null;
	}

	public SqlExpression accept(GenSqlVisitor visitor) throws org.xquark.extractor.common.SqlWrapperException {
		Debug.assertTrue(false, "internal logic error");
		return null;
	}
	public void accept(AlgebraVisitor visitor) throws org.xquark.extractor.common.SqlWrapperException {
		Debug.assertTrue(false, "internal logic error");
	}
	
	/**
	 * @see Expression#deepEquals(Object)
	 */
	public boolean deepEquals(Object o)
	{
		if (o instanceof PseudoExpression)
		{
			PseudoExpression cast = (PseudoExpression)o;
			return	 _collectionName.equals(cast.getCollectionName());
		}
		return false;
	}
}
