/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.ArrayList;
import java.util.List;

public class RemoveProjectVoteVisitor extends DefaultSimpleVisitor {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName = "$Name:  $";

	private List _opposerList = new ArrayList();

    public RemoveProjectVoteVisitor() {
    }

	public void reinit() {
		_opposerList.clear();
	}

	public List getOpposerList() {
		return _opposerList;
	}

	public void visit(FunAggregate arg) {
		int operator = arg.getOperator();
		if (FunAggregate.COUNT == operator) {
			Expression operand = arg.getOperand();
			if (operand instanceof AttributeExpression) {
				if (((AttributeExpression)operand).getAttribute().equals("*")) {
					_opposerList.add(arg);
				}
			}
		}
	}

	/* the visit will end when enconter a relational algebra node */
	public void visit(UnaryAlgebra arg) {
	}

	public void visit(BinaryAlgebra arg) {
	}

	public void visit(BinOpOuterJoin arg) {
	}

	public void visit(Join arg) {
	}
}
