/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.algebra;

import java.util.List;
import java.util.Set;

public abstract class UnaryAlgebra extends UnaryOperator implements Relation
{

    private static final String RCSRevision = "$Revision: 1.5 $";
    private static final String RCSName     = "$Name:  $";


	protected List _keys = null;

    public UnaryAlgebra() {}

    public UnaryAlgebra(Expression operand)
    {
        super (operand);
    }

    public List getParameterList()	// TODO: check use
    {
        return null;
    }

    public Set providedTableInstances(){
        /* default implementation for group, sort, restrict .
        aggregate project should overide this implementation */
        return visibleTableInstances();
    }

    public Set visibleTableInstances() {
        return ((Relation)getOperand()).providedTableInstances();
    }
    
	public AttributeExpression findNonNullAttribute() {
		return ((Relation)getOperand()).findNonNullAttribute();
	}

    public Mapper getMapper() {
		return _mapper == null ? getOperand().getMapper() : _mapper;
	}

    abstract public List getKeys();

	public void setKeys(List keys) {
		_keys = keys;
	}


    public List nameTest(String name)
    {
        // this default implementation is for UnOpRestrict,UnOpSort,UnOpGroup,RenameRelation.
        // UnOpProject, UnOpAggregate should override this function.
        Relation  oprnd = (Relation)getOperand();
         return oprnd.nameTest(name);
    }
}
