/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.metadata;

import org.xquark.extractor.runtime.Selection;

public class Schema extends NamedNode {

	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name:  $";


	String targetNamespace = null;
    int elementFormDefault = Selection.UNQUALIFIED;

	/**
	 * @param name
	 * @roseuid 3B278EF1023D
	 */
	public Schema(String name) { super(name); }

	/**
	 * @roseuid 3B278EF1021F
	 */
	public Schema() {	}

	public String getTargetNamespace() { return targetNamespace; }

	public void setTargetNamespace(String targetNamespace) {
		this.targetNamespace = targetNamespace;
	}

	public int getElementFormDefault() { return elementFormDefault; }

	public void setElementFormDefault(int elementFormDefault) {
		this.elementFormDefault = elementFormDefault;
	}

	public String pprint() {
		StringBuffer    retVal = new StringBuffer();
		String newLine = System.getProperty("line.separator");
		retVal.append("========== Schema : ");
		retVal.append(_name);
		retVal.append(" ====================");
		retVal.append(newLine);
		for (int i = 0; i < _children.size(); i++) {
			retVal.append(((NamedNode)_children.get(i)).pprint());
			retVal.append(newLine);
		}
		return retVal.toString();
	}
}

