/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.progress.sql;

import java.util.List;

import org.xquark.extractor.common.Debug;
import org.xquark.extractor.sql.Context;
import org.xquark.extractor.sql.SqlExpression;

public class SfConcat extends org.xquark.extractor.sql.SfConcat {
	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName = "$Name:  $";

	public SfConcat() {
		super();
	}

	public SfConcat(List arguments) {
		super(arguments);
	}

	public String toSql(Context context) {
		//Trace.enter(this, "toSql(Context context)");

		StringBuffer retVal = new StringBuffer();
		List args = getArguments();
		Debug.assertTrue(1 < args.size(), "1<args.size()");

		for (int i = 0; i < args.size(); i++) {
			SqlExpression item = (SqlExpression) args.get(i);
			retVal.append(item.toSql(context));
			retVal.append(" + ");
		}
		retVal.delete(retVal.length() - 3, retVal.length() - 1);

		//Trace.exit(this, "toSql(Context context)");
		return retVal.toString();
	}
}
