/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


public class SqlBinOpCompareAny extends SqlBinaryOperator
{
	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName     = "$Name:  $";
	protected int _operator;

	/**
	@param operator
	@param leftOperator
	@param rightOperator
	@param leftOperand
	@param rightOperand
	@roseuid 3BD177D402A7
	 */
	public SqlBinOpCompareAny(int operator, SqlExpression leftOperand, SqlExpression rightOperand)
	{
		super (  leftOperand,  rightOperand );
		setOperator ( operator ) ;
	}

	/**
	@roseuid 3BD177D40274
	 */
	public SqlBinOpCompareAny()
	{

	}

	/**
	Access method for the _operator property.
	@return   the current value of the _operator property
	@roseuid 3BD177D50059
	 */
	public int getOperator()
	{
		return _operator;
	}

	/**
	Sets the value of the _operator property.
	@param aOperator the new value of the _operator property
	@roseuid 3BD177D50095
	 */
	public void setOperator(int aOperator)
	{
		_operator = aOperator;
	}

	/**
	@return String
	@roseuid 3BD177D50117
	 */
	public String toSql(Context context)
	{
		//Trace.enter(this,"toSql(Context context)");

		String      retVal  ;

		retVal = "" ;
		retVal = " ( "+getLeftOperand().toSql(context)+ " ) " ;
		retVal += " " + COMPOPSSTRINGS [_operator] + " ANY " ;
		if (getRightOperand() instanceof SqlLitList) {
			retVal += getRightOperand().toSql(context);
		}
		else {
			retVal += " ( "+getRightOperand().toSql(context)+ " ) " ;
		}

		//Trace.exit(this,"toSql",retVal);
		return retVal ;
	}
}
