/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


public class SqlFunAggregate extends SqlUnaryOperator
{

	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name:  $";

    private boolean _distinct;
    private int _operator;

    /**
    @param operator
    @param operand
    @param distinct
    @roseuid 3BD177EE03B2
     */
    public SqlFunAggregate(int operator, SqlExpression operand, boolean distinct)
    {

        super ( operand );
        setDistinct (distinct );
        setOperator (operator) ;
    }

    /**
    @roseuid 3BD177EE0376
     */
    public SqlFunAggregate()
    {

    }

    /**
    @return boolean
    @roseuid 3BD177EF0147
     */
    public boolean getDistinct()
    {
        return _distinct ;
    }

    /**
    @param distinct
    @roseuid 3BD177EF018D
     */
    public void setDistinct(boolean distinct)
    {
        _distinct = distinct ;
    }

    /**
    @param operator
    @roseuid 3BD177EF0237
     */
    public void setOperator(int operator)
    {
        _operator = operator ;
    }

    /**
    @return int
    @roseuid 3BD177EF02C3
     */
    public int getOperator()
    {
        return _operator ;
    }

    /**
    @return String
    @roseuid 3BD177EF02F5
     */
    public String toSql(Context context)
    {
        //Trace.enter(this,"toSql(Context context)");
//
        StringBuffer retVal = new StringBuffer();

        retVal.append( AGGREGATEOPS[_operator]);
        retVal.append("(");
        if ( _distinct )
        {
            retVal.append("DISTINCT ");
        }
        retVal.append(getOperand().toSql(context));
        retVal.append(")");

        //Trace.exit(this,"toSql(Context context)");
//
        return retVal.toString() ;
    }
}
