/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class SqlJoin extends SqlExpression
{
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

	protected List _relationList;

    public SqlJoin()
    {
    	_relationList = new ArrayList();
    }

    public SqlJoin(List operandList)
    {
		setOperandList(operandList);
    }

	public List getOperandList()
	{
		return _relationList;
	}

	public void setOperandList(List operandList)
	{
		_relationList = operandList;
	}
	
	public void addOperand(SqlExpression operand) {
		_relationList.add(operand);
	}
	
    public String toSql (Context context)
    {
        //Trace.enter(this,"toSql(Context context)");

        StringBuffer retVal = new StringBuffer();

		Iterator it = _relationList.iterator();
		while (it.hasNext()) {
			SqlExpression relation = (SqlExpression)it.next();

			if (relation instanceof SqlSelect) {
				retVal.append('(');
				retVal.append(relation.toSql(context));
				retVal.append(')');
			}
			else {
				retVal.append(relation.toSql(context));
			}
			retVal.append(", ");	// NOTE: not needed anymore since a SqlJoin node exists
		}
		retVal.setLength(retVal.length() - 2);

        //Trace.exit(this,"toSql(Context context)");
        return retVal.toString();
    }
}
