/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sql;


public abstract class SqlUnaryOperator extends SqlExpression
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";

    protected SqlExpression _operand;

    /**
    @param operand
    @roseuid 3BD17804011F
     */
    public SqlUnaryOperator(SqlExpression operand)
    {
        setOperand (operand );
    }

    /**
    @roseuid 3BD1780400E3
     */
    public SqlUnaryOperator()
    {

    }

    /**
    Access method for the _operand property.

    @return   the current value of the _operand property
     */
    public SqlExpression getOperand()
    {
     return _operand;
    }

    /**
    Sets the value of the _operand property.

    @param aOperand the new value of the _operand property
     */
    public void setOperand(SqlExpression aOperand)
    {
        _operand = aOperand;
    }

}
