/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sybase;

import java.sql.Types;

import org.xquark.extractor.common.MessageLibrary;
import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.jdbc.typing.DbType;

public class TypeMapper {
	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName = "$Name:  $";

	public static String mapType(DbType type) {
		StringBuffer retVal = new StringBuffer();

		int typeCode = type.getJDBCType();
        switch (typeCode) {
//            case Types.ARRAY:
//                retVal.append("ARRAY");
//                break;
//            case Types.BIGINT:
//                retVal.append("BIGINT");
//                break;
//            case Types.BINARY:
//                retVal.append("BINARY");
//                break;
            case Types.BIT://
                retVal.append("BIT");
                break;
//            case Types.BLOB:
//                retVal.append("BLOB");
//                break;
            case Types.CHAR:
                retVal.append("NCHAR");
                break;
//            case Types.CLOB:
//                retVal.append("CLOB");
//                break;
            case Types.DATE:
                retVal.append("DATETIME");
                break;
            case Types.DECIMAL:
                retVal.append("DECIMAL");
                break;
//            case Types.DISTINCT:
//                retVal.append("DISTINCT");
//                break;
            case Types.DOUBLE: //
                retVal.append("DOUBLE");
                break;
            case Types.FLOAT://
                retVal.append("REAL");
                break;
            case Types.INTEGER://
                retVal.append("INTEGER");
                break;
//            case Types.JAVA_OBJECT:
//                retVal.append("JAVA_OBJECT");
//                break;
//            case Types.LONGVARBINARY:
//                retVal.append("LONGVARBINARY");
//                break;
//            case Types.LONGVARCHAR:
//                retVal.append("LONGVARCHAR");
//                break;
//            case Types.NULL:
//                retVal.append("NULL");
//                break;
//            case Types.NUMERIC:
//                retVal.append("NUMERIC");
//                break;
            case Types.REAL: //
                retVal.append("REAL");
                break;
            case Types.SMALLINT:   //
                retVal.append("SMALLINT");
                break;
//            case Types.STRUCT:
//                retVal.append("STRUCT");
//                break;
            case Types.TIME:
                retVal.append("DATETIME");
                break;
            case Types.TIMESTAMP://
                retVal.append("TIMESTAMP");
                break;
            case Types.TINYINT: //
                retVal.append("TINYINT");
                break;
//            case Types.VARBINARY:
//                retVal.append("VARBINARY");
//                break;
            case Types.VARCHAR:
                retVal.append("NVARCHAR");
                break;
            default:
				throw new SqlWrapperException(MessageLibrary.getMessage("T_N_SUP_TYPE", type.name()));
//                break;
        }

		if (Types.CHAR == typeCode || Types.VARCHAR== typeCode || Types.DECIMAL == typeCode) {
			retVal.append('(');
			retVal.append(Long.toString(type.getLength()));
		}
		if (Types.CHAR == typeCode || Types.VARCHAR == typeCode) {
			retVal.append(')');
		}
		else if (Types.DECIMAL == typeCode) {
			retVal.append(", ");
			retVal.append(Integer.toString(type.getScale()));
			retVal.append(')');
		}
		return retVal.toString();
	}

}
