/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.sybase.sql;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Iterator;
import java.util.List;

import org.xquark.extractor.sql.Context;
import org.xquark.extractor.sql.SqlExpression;

public class SqlCreateTable extends org.xquark.extractor.sql.SqlExpression {
	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName = "$Name:  $";

	private org.xquark.extractor.sql.SqlTable _tableName;
	protected List _attrDefList;

	public SqlCreateTable() {

	}

	public org.xquark.extractor.sql.SqlTable getTableName() {
		return _tableName;
	}

	public void setTableName(org.xquark.extractor.sql.SqlTable tableName) {
		_tableName = tableName;
	}

	public List getAttrDefList() {
		return _attrDefList;
	}

	public void setAttrDefList(List attrDefList) {
		_attrDefList = attrDefList;
	}

	public void addAttributeDefination(SqlAttributeDefinition attrDef) {

	}

	public ResultSet Execute(Statement statement) throws SQLException {
		ResultSet retResultSet = null;
		List prcedents = getPrecedents();
		if (null != prcedents) {
			Iterator iter = prcedents.iterator();
			while (iter.hasNext()) {
				((SqlExpression) iter.next()).Execute(statement);
			}
		}
		String query = this.toSql(new Context());
		try {
			statement.executeUpdate(query);
		} catch (SQLException ex) {
			if (true /** @todo the table  exists alreay */
				) {
				clean(statement);
				statement.executeUpdate(query);
			}
		}

		return retResultSet;
	}

	public String toSql(Context context) {
		StringBuffer retVal = new StringBuffer();

		retVal.append("CREATE TABLE ");
		retVal.append(getTableName().toSql(context));
		retVal.append(" (");

		SqlAttributeDefinition attrDef = null;
		for (int i = 0; i < getAttrDefList().size(); i++) {
			attrDef = (SqlAttributeDefinition) getAttrDefList().get(i);
			retVal.append(attrDef.toSql(context));
			if (i != getAttrDefList().size() - 1) {
				retVal.append(" , ");
			}
		}
		retVal.append(")");

		return retVal.toString();
	}

	protected void clean(Statement statement) throws SQLException {
		statement.execute("DROP TABLE " + getTableName().toSql());
	}
}
