/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.extractor.xfunctions;

import org.xquark.extractor.algebra.Expression;
import org.xquark.extractor.sql.SqlExpression;
/**
6.4.4 xf:get-hour-from-time
xf:get-hour-from-time(time? $srcval) => integer?
Returns an integer representing the hour identified in the value of $srcval. The hour value ranges
from 0 to 23, inclusive. If $srcval is the empty sequence, returns the empty sequence.
6.4.4.1 Examples
xf:get-hour-from-time(xf:dateTime("11:23:00")) returns 11 .
 */
public final class XfGetHourFromTime extends Xfunction_Integer
{

	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName     = "$Name:  $";


    /**
    @roseuid 3BD185B1035D
     */
    public XfGetHourFromTime()
    {
         super("XfGetHourFromTime");
    }

    public XfGetHourFromTime(Expression arg0)
    {
        super("XfGetHourFromTime");
        setArgument(0, arg0);
    }

    public SqlExpression accept(org.xquark.extractor.algebra.GenSqlVisitor visitor)
    {
        return visitor.visit(this);
    }

    public void accept(org.xquark.extractor.algebra.AlgebraVisitor visitor)
    {
        visitor.visit(this);
    }
}
