(:
List the item number and description of the item(s) that 
received the largest number of bids, and the number of bids it (or they) received.
:)

declare function local:bid_summary()
as element()*
{
    for $i in distinct-values(collection("bids")/*:bids/itemno)
    let $b := collection("bids")/*:bids[itemno = $i]
    return
        <bid_count>
            <itemno>{ $i }</itemno>
            <nbids>{ count($b) }</nbids>
        </bid_count>
};

<result>
 {
    let $bid_counts := local:bid_summary(),
        $maxbids := max($bid_counts/nbids)
    for $item in collection("items")/*:items,
        $bc in $bid_counts
    where $bc/nbids =  $maxbids and $item/itemno = $bc/itemno
    return
        <popular_item>
            { $item/itemno }
            { $item/description }
            <bid_count>{ $bc/nbids/text() }</bid_count>
        </popular_item>
 }
</result> 

