(:
List the item number and description of the item(s) that received the highest bid ever recorded, and the amount of that bid.
:)
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd"

let $highbid := max(doc("bids.xml")/bid:bids/bid_tuple/bid)
return
    <result>
      {
        for $item in collection("items")/*:items,
            $b in doc("bids.xml")/bid:bids/bid_tuple[itemno = $item/itemno]
        where $b/bid = $highbid
        return
            <expensive_item>
                { $item/itemno }
                { $item/description }
                <high_bid>{ $highbid }</high_bid>
            </expensive_item>
      }
    </result>

