module namespace ns = "http://www.xquark.org/XQuery/Samples/viewDefs";
import schema namespace vt = "http://www.xquark.org/XQuery/Samples/viewTypes" at "view.xsd";
import schema namespace bid = "http://www.xquark.org/XQuery/use-cases/bids" at "bids.xsd";

declare function ns:users() as element(vt:user)* {
	for $u in collection("users")/*:users
	order by $u/userid
	return
		<vt:user id="{$u/userid}">
			<vt:name>{ data($u/name) }</vt:name>  
			<vt:rating>{ data($u/rating) }</vt:rating>
			<vt:items>
				{
					for $i in collection("items")/*:items
					where $i/offered_by = $u/userid
					return
						<vt:item id="{$i/itemno}">
							<vt:description>{ data($i/description) }</vt:description>
							<vt:auction>
								<vt:start>{ data($i/start_date) }</vt:start>
								<vt:end>{ data($i/end_date) }</vt:end>
								<vt:reservePrice>{ data($i/reserve_price) }</vt:reservePrice>
							</vt:auction>
							<vt:bids>
								{ 
									for $b in doc("bids.xml")/bid:bids/bid_tuple
									where $b/itemno = $i/itemno
									order by $b/bid_date
									return  
										<vt:bid userid="{$b/userid}">
											<vt:value>{ data($b/bid) }</vt:value>
											<vt:date>{ data($b/bid_date) }</vt:date>
										</vt:bid>
								}
							</vt:bids>
						</vt:item>
				}
			</vt:items>
		</vt:user>
};
