/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.mediator.algebra;

import org.xquark.mediator.plan.ExecutionPlan;
import org.xquark.mediator.plan.Operator;
import org.xquark.mediator.runtime.MediatorException;
import org.xquark.xquery.parser.Variable;

public class AlgVar extends Algebra {
    // **********************************************************************
    // * VERSIONING
    // **********************************************************************
    private static final String RCSRevision = "$Revision: 1.4 $";
    private static final String RCSName = "$Name:  $";
    // **********************************************************************
    // * CLASS VARIABLES
    // **********************************************************************
    /**
     * references on dependencies (type DepNode)
     */
    //private DepNode dependency = null ;

    // ************************************************************************
    // * INITIALIZATION
    // ************************************************************************
    /**
     *
     * @param typevisitor
     * @param expression
     * @param var
     * @param parent
     */
    public AlgVar(Variable addvar, Variable var, AlgebraManager depmanager, boolean islet) {
        super(addvar, var, depmanager, islet) ;
        //dependency = depmanager.getMapNode(addvar);
		this.addDependSourceVariable(addvar);
        //paths = depmanager.getPathsfromVar(var);
        /*
        ArrayList tmplist = dependency.getPaths();
        if (tmplist != null) if (paths == null) paths = tmplist; else paths.addAll(tmplist);
        */
    }
    
    /**
     *
     * @param typevisitor
     * @param expression
     * @param var
     * @param parent
     * @param dependency
     */
    /*
    public DepVar(TypeVisitor typevisitor, XQueryExpression expression, Variable var, DepManager DepManager, Dep dependency) {
        super(typevisitor, expression, var, parent) ;
        this.dependency = dependency ;
        dependency.setReferencer(this) ;
    }
    */
    
    // ******************************************************************
    // * INFORMATION
    // ******************************************************************
    
    // ******************************************************************
    // * METHODS
    // ******************************************************************
    
//	public void ParentHasIdentifier() {
//		hasIdentifier = true;
//	}

    // ******************************************************************
    // * CREATE EXECUTION PLAN
    // ******************************************************************
    /**
     *
     * @param plan
     * @return
     */
    public Operator createOperator(ExecutionPlan plan) throws MediatorException {
        if (true) throw new MediatorException("createAlgebra not supported in DepVar");
        return null;
    }

    public Object clone() throws CloneNotSupportedException {
        return (AlgVar)super.clone();
    }

    public void execute(ExecutionPlan plan) throws MediatorException {
    }
    
    // ******************************************************************
    // * DEBUGGING
    // ******************************************************************

}
