/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2004 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.mediator.plan;

import org.xquark.mediator.runtime.MediatorException;

public class OperatorRunnable implements Runnable {

	protected ResultSet resultset = null;
	protected Operator operator = null;
	protected DynamicContext ctx = null;
	protected MediatorException me = null;

	public OperatorRunnable(Operator operator, DynamicContext ctx) {
		this.operator = operator;
		this.ctx = ctx;		
	}
	
	public ResultSet getResultSet() throws MediatorException{
		if (me != null) {
			throw me;
		}
		return resultset;
	}

	public void setResultSet(ResultSet resultset) {
		this.resultset = resultset;
	}

	public Operator getOperator() {
		return operator;
	}
	
	public DynamicContext getContext() {
		return ctx;
	}


	public void run() {
		try {
			me = null;
			resultset = operator.executeQuery(ctx);
		} catch (MediatorException me) {
			this.me = me;
		}		
	}


}
