/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2004 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.mediator.runtime;

import java.util.ArrayList;

import org.xquark.xml.xdbc.XMLDBCException;
import org.xquark.xml.xdbc.XMLStatement;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryExpression;
import org.xquark.xquery.xdbc.XDBCResultSetInterface;
import org.xquark.xquery.xdbc.XResultSetImpl;


public class MediatorResultSet extends XResultSetImpl {

	boolean isClosed = false;
	/**
	 * @param xdbcResulSet
	 * @param reconstructExpression
	 * @param varList
	 * @param statement
	 * @throws XQueryException
	 */
	public MediatorResultSet(XDBCResultSetInterface xdbcResulSet, XQueryExpression reconstructExpression, ArrayList varList, XMLStatement statement) throws XQueryException {
		super(xdbcResulSet, reconstructExpression, varList, statement);
	}


	public void close() throws XMLDBCException {
		if (!isClosed) {
			isClosed = true;
			super.close();
			((MediatorStatement)statement).closePreparedStatements();
		}
	}
}
