/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */
package org.xquark.jdbc.typing;

/**
 * AbstractConnection factory.
 *
 * <p>This object holds database vendor specificities routing.</p>
 */
public interface DBMSConstants
{
    String RCSRevision = "$Revision: 1.1 $";
    String RCSName     = "$Name:  $";

    ///////////////////////////////////////////////////////////////
    //                      RDBMS Constants
    ///////////////////////////////////////////////////////////////
    short JDBC1 = 0;
    short JDBC2 = 1;
    short ORACLE = 2;
    short ORACLE8I = 3;
    short ORACLE8 = 4;
    short ORACLELITE = 5;
    short TIMESTEN = 6;
    short TIMESTEN40 = 7;
    short SYBASE = 8;
    short SYBASE_ASE_11_9 = 9;
	short SQL_SERVER = 10;
	short SQL_SERVER_2000 = 11;
	short MYSQL = 12;
	short MYSQL323 = 13;

    String ORACLE_FILE = "Oracle8i.xml";
    String TIMESTEN_FILE = "TimesTen.xml";
    String SYBASE_FILE = "SybaseASE.xml";
	String SQL_SERVER_FILE = "MSSQLServer.xml";
	String MYSQL_FILE = "MySQL.xml";

	/* used for rdbms like Sybase that do not store trailing blanks and do differantiate null from empty (oracle) */
	String STRING_DELIMITOR = "\u0000";
	int STRING_DELIMITOR_LENGTH = 1;
	String NIL_TRUE_VALUE = "t";
	String NIL_FALSE_VALUE = "f";
}
