/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

/*
 * AnnotationHandler.java
 *
 * Created on 3 janvier 2001, 13:48
 */

package org.xquark.schema.loader;

import org.xquark.schema.SchemaConstants;
import org.xquark.util.DefaultElementHandler;
import org.xquark.util.ElementHandler;

class AnnotationHandler extends DefaultElementHandler 
       implements SchemaConstants 
{
	private static final String RCSRevision = "$Revision: 1.1 $"; 
	private static final String RCSName     = "$Name:  $";
    private Loader loader = null;
		
		AnnotationHandler() {
    }
    
    public ElementHandler startElement(String namespaceURI, String localName, org.xml.sax.Attributes atts) throws org.xml.sax.SAXException
    {
        if ( namespaceURI.equals(XMLSCHEMA_URI) ) {
            if (localName.equals(APPINFO_TAG)) return this;
            
            if (localName.equals(DOCUMENTATION_TAG)) return this;
        }
        
        return this;
    }
}
    
