/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xml.xdbc;

/**
 * This class describes a XMLDBC (Xml DataBase Connectivity) exception for various use in XMLDBC API.<BR>
 * This is an exception used when you try to set the value of an object, a property or a feature with bad value
 * or if it
 * is not allowed.<BR>
 * There is no speific exception code in this class.<BR><BR>
 * CAUTION: This XMLDBC API is a proposal!<BR>
 */
public class XMLDBCNotSupportedException extends XMLDBCException {
 


    //*************************** Constructor declaration:

    /**
     * Constructor with error code.
     * @param code the code featuring the kind of error (see constants).
     */
    public XMLDBCNotSupportedException(int code) {
        super(code);
    }

    /**
     * Constructor with message.
     * @param msg a message to describe the exception.
     */
    public XMLDBCNotSupportedException(java.lang.String msg) {
        super(msg);
    }

    /**
     * Constructor with error code and message.
     * @param code the code featuring the kind of error (see constants).
     * @param msg a message to describe the exception.
     */
    public XMLDBCNotSupportedException(int code, java.lang.String msg) {
        super(code, msg);
    }

    /**
     * Constructor with message and underlying exception.
     * @param msg a message to describe the exception.
     * @param exception the underlying exception (or error).
     */
    public XMLDBCNotSupportedException(java.lang.String msg, java.lang.Throwable exception) {
        super(msg, exception);
    }

    /**
     * Constructor with error code, message and underlying exception.
     * @param code the code featuring the kind of error (see constants).
     * @param msg a message to describe the exception.
     * @param exception the underlying exception (or error).
     */
    public XMLDBCNotSupportedException(int code, java.lang.String msg, java.lang.Throwable exception) {
        super(code, msg, exception);
    }
}
