/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xpath;


public class NodeKind {


	/**
	 * The <code>NOKIND_TEST</code> kind contains a document test.
	 */
	static public final byte NONE = 0x00;

	/**
	 * The <code>ANYKIND_TEST</code> kind contains an any kind test.
	 */
	static public final byte NODE = 0x01;

	/**
	 * The <code>DOCUMENT_TEST</code> kind contains a document test.
	 */
	static public final byte DOCUMENT = 0x02;

	/**
	 * The <code>ATTRIBUTE_TEST</code> kind contains a attribute test.
	 */
	static public final byte ATTRIBUTE = 0x03;

	/**
	 * The <code>PI_TEST</code> kind contains a processing instruction test.
	 */
	static public final byte PI = 0x04;

	/**
	 * The <code>COMMENT_TEST</code> kind contains a comment test.
	 */
	static public final byte COMMENT = 0x05;

	/**
	 * The <code>TEXT_TEST</code> kind contains a text test.
	 */
	static public final byte TEXT = 0x06;

	/**
	 * The <code>ELEMENT_TEST</code> kind contains a element test.
	 */
	static public final byte NAMESPACE = 0x07;

	/**
	 * The <code>ELEMENT_TEST</code> kind contains a element test.
	 */
	static public final byte ELEMENT = 0x08;

	/**
	 * The string values of the different nodetest types
	 */
	static public final  String[] NODEKINDSTRINGS = {
		"",
		"node",
		"document-node",
		"attribute",
		"processing-instruction",
		"comment",
		"text",
		"namespace",
		"element"
	};


}
