/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xpath.datamodel;

import org.xquark.schema.Declaration;
import org.xquark.schema.Type;

public interface TypedDOM {
    public static final String RCSRevision = "$Revision: 1.1 $";
    public static final String RCSName = "$Name:  $";

    public void setType(Type type);

    public Type getType();

    public void setTypedValue(Object typedValue);

    public Object getTypedValue();

    public Object getExtendedTypedValue();

    public void setDeclaration(Declaration elementDeclaration);

    public Declaration getDeclaration();

    public void setNormalizedStringValue(String normalizedStringValue);

    public String getNormalizedStringValue();
}
