/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xpath.datamodel;

import org.w3c.dom.*;
import org.xquark.schema.Declaration;
import org.xquark.schema.SimpleType;
import org.xquark.schema.Type;
import org.xquark.xpath.datamodel.xerces.dom.DocumentImpl;

public class TypedDocumentImpl extends DocumentImpl implements TypedDocument {
    private static final String RCSRevision = "$Revision: 1.2 $";
    private static final String RCSName = "$Name:  $";

    public TypedDocumentImpl() {
        super();
    }

    //    public TypedDocument(boolean grammarAccess) {
    //        super(grammarAccess);
    //    }
    //
    //    public TypedDocument(DocumentType doctype) {
    //        super(doctype);
    //    }
    //
    //    public TypedDocument(DocumentType doctype, boolean grammarAccess) {
    //        super(doctype, grammarAccess);
    //    }
    //
    public Element createElementNS(String namespaceURI, String qualifiedName) {
        return new TypedElementImpl(this, namespaceURI, qualifiedName);
    }

    public Attr createAttributeNS(String namespaceURI, String qualifiedName) {
        return new TypedAttributeImpl(this, namespaceURI, qualifiedName);
    }

    public Text createTextNode(String data) {
        return new TypedValueImpl(this, data);
    }

    public TypedValue createTypedValue(Object typedValue, SimpleType simpleType) {
        TypedValue retVal = new TypedValueImpl(this, (simpleType==null)?null:simpleType.toXMLString(typedValue,null));
        retVal.setType(simpleType);
        retVal.setTypedValue(typedValue);

        return retVal;
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#setType(org.xquark.schema.Type)
     */
    public void setType(Type type) {
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#getType()
     */
    public Type getType() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#setTypedValue(java.lang.Object)
     */
    public void setTypedValue(Object typedValue) {
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#getTypedValue()
     */
    public Object getTypedValue() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#getExtendedTypedValue()
     */
    public Object getExtendedTypedValue() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#setDeclaration(org.xquark.schema.Declaration)
     */
    public void setDeclaration(Declaration elementDeclaration) {
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#getDeclaration()
     */
    public Declaration getDeclaration() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#setNormalizedStringValue(java.lang.String)
     */
    public void setNormalizedStringValue(String normalizedStringValue) {
    }

    /* (non-Javadoc)
     * @see org.xquark.xpath.datamodel.TypedDOM#getNormalizedStringValue()
     */
    public String getNormalizedStringValue() {
        return null;
    }

    //
    //    public Element getElementById(String elementId) {
    //        if(elementId == null) {
    //            return null;
    //        } else {
    //            return getElementById(elementId, this);
    //        }
    //    }
    //
    //    protected Element getElementById(String elementId, Node root) {
    //        Node child = root.getFirstChild();
    //        while(child != null) {
    //            if(child instanceof TypedElement) {
    //                NamedNodeMap attributes = ((TypedElement)child).getAttributes();
    //                for(int i=0;i<attributes.getLength();i++) {
    //                    if(attributes.item(i) instanceof TypedAttribute && ((TypedAttribute)attributes.item(i)).isTypeID()) {
    //                        if(elementId.equals(attributes.item(i).getNodeValue())) {
    //                            return (Element)child;
    //                        }
    //                    }
    //                }
    //            }
    //            if(child.getNodeType() == Node.ELEMENT_NODE) {
    //                Element search = this.getElementById(elementId,child);
    //                if(search != null) {
    //                    return search;
    //                }
    //            }
    //            child = child.getNextSibling();
    //        }
    //        return null;
    //    }
}
