/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.metadata;

import java.util.ArrayList;
import java.util.Hashtable;

// ***************************************************************************
// * Class 'MetaPath'
// ***************************************************************************

public class MetaPath {
	// **********************************************************************
	// * Constant
	// **********************************************************************
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName = "$Name:  $";

	// **********************************************************************
	// * Fields
	// **********************************************************************
	private ArrayList locations = null;
	private Hashtable paths = null;

	// **********************************************************************
	// * Constructor
	// **********************************************************************

	/**
	 * Construct the class MetaPath
	 *
	 * @param
	 */
	public MetaPath() {
		locations = new ArrayList();
		paths = new Hashtable();
	}

	// **********************************************************************
	// * Methods
	// **********************************************************************
	/**
	 * 
	 *
	 * @param
	 *
	 * @return
	 */
	public void add(ArrayList vecpath, String collectionname, String namespace, String wrappername) {
		String[] location = addLocation(collectionname, namespace, wrappername);
		for (int i = 0; i < vecpath.size(); i++) {
			String path = (String) vecpath.get(i);
			addPath(path, location);
		}

	}

	private String[] addLocation(String collectionname, String namespace, String wrappername) {
		String[] location = new String[3];
		location[0] = collectionname;
		location[1] = namespace;
		location[2] = wrappername;
		return location;
	}

	private void addPath(String path, String[] location) {
		paths.put(path, location);
	}

	// **********************************************************************
	// * Destructor
	// **********************************************************************

	/**
	 * Dereference allocated object which will be further be destroy
	 * by the garbage collector.
	 */
	protected void finalize() throws Throwable {
	}
}
