/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.parser;

/*
[146]    SchemaImport    ::=    <"import" "schema"> SchemaPrefix? StringLiteral <"at" StringLiteral>? 
[147]    SchemaPrefix    ::=    ("namespace" NCName "=") | (<"default" "element"> "namespace") 
*/

public class ImportSchema extends XQueryExpression {
	
	protected boolean hasPrefix = false;
	protected String prefix = null;
	protected String name = null;
	protected String location = null;
	
	ImportSchema (boolean hasPrefix, String prefix, String name, String location) {
		this.hasPrefix = hasPrefix;
		this.prefix = prefix;
		this.name = name;
		this.location = location;
	}
	
	public boolean getHasPrefix() {
		return hasPrefix;
	}

	public String getPrefix() {
		return prefix;
	}

	public String getName() {
		return name;
	}

	public String getLocation() {
		return location;
	}

}
