/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.reconstruction;

import org.xquark.xquery.parser.XQueryException;

public class ReconstructionException extends XQueryException {
    
    private static final String RCSRevision = "$Revision: 1.1 $";
    private static final String RCSName     = "$Name:  $";
    
    protected int line = -1;
    protected int column = -1;
    
    public ReconstructionException(String message) { super(message); }
    
    public ReconstructionException(String message, int line, int column) {
        super(message);
        this.line = line;
        this.column = column;
    }
    
    public String getMessage() {
        if (line == -1 || column == -1) { return super.getMessage(); }
        return super.getMessage() + " - encountered at line " + line + " , column " + column;
    }
}
