/*
 * This file belongs to the XQuark distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * Copyright (C) 2003 XQuark Group.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquark.org.
 */

package org.xquark.xquery.typing;

import java.util.List;

import org.xquark.xquery.parser.XQueryException;

public class QTypeSequence extends QTypePrime implements QTypeVisitable {
	private static final String RCSRevision = "$Revision: 1.3 $";
	private static final String RCSName = "$Name:  $";

	List list = null;

	public QTypeSequence(List list) {
		super(list,SEQUENCE);
		setList(list);
		subclass = SEQUENCE;
		//primeList = list;
		this.occurence = OCC_1_1;
	}
	public QTypeSequence(List list, byte occurence) {
		super(list,SEQUENCE);
		setList(list);
		subclass = SEQUENCE;
		//primeList = list;
		this.occurence = occurence;
	}

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(QTypeVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

	// get/set
	public List getList() {
		return list;
	}

	private void setList(List list) {
		//if (list == null) throw new TypeException("list of QTypeSequence cannot be null");
		this.list = list;
	}

	// clone
	public Object clone() throws CloneNotSupportedException {
		QTypeSequence newObj = new QTypeSequence(list,occurence);
		return newObj;
	}
	// print
	public String toSimpleString() {
		return "QTypeSequence(" + list + ")";
	}

	public String toString() {
		return "QTypeSequence(" + list + ")";
	}

}
