/* Generated By:JavaCC: Do not edit this line. XQueryParser.java */
package org.xquark.xquery.parser;

import java.util.*;
import org.xquark.xquery.*;
import org.xquark.xquery.typing.*;
import org.xquark.xquery.parser.util.*;
import org.xquark.xquery.parser.primitivefunctions.fnfunctions.*;
import org.xquark.xquery.parser.primitivefunctions.xsfunctions.*;
import org.xquark.xquery.parser.hinttree.*;
import org.xquark.xquery.normalize.*;
import org.xquark.util.*;
import org.xquark.xpath.*;
import org.xquark.xquery.metadata.*;
import org.xquark.schema.*;
import org.xquark.xquery.metadata.resolver.*;
import java.net.*;
import org.xml.sax.SAXException;

public class XQueryParser implements XQueryParserConstants {
        private static final String RCSRevision = "$Revision: 1.14 $";
        private static final String RCSName = "$Name:  $";

        // to restrict parser, by default: true
        private boolean restriction = true;

        private Token currentToken = null;
        private StaticContext staticcontext = null;
        private SchemaManager initialSchemamanager = null;
        //private TypeVisitor typevisitor = null;
        private XQueryModule parentModule = null;

        private final String VAR_NAME = "var";
        private final String XMLNS = "xmlns";
        private final String XML = "xml";
        private final String XS = "xs";
        private final String XSI = "xsi";
        private final String FN = "fn";
        private final String XDT = "xdt";
        private final String LOCAL = "local";
        private final String XMLURI = "http://www.w3.org/XML/1998/namespace";
        private final String XSURI = "http://www.w3.org/2001/XMLSchema";
        private final String XSIURI = "http://www.w3.org/2001/XMLSchema-instance";
        private final String FNURI = "http://www.w3.org/2003/11/xpath-functions";
        private final String XDTURI = "http://www.w3.org/2003/11/xpath-datatypes";
        private final String LOCALURI = "http://www.w3.org/2003/11/xquery-local-functions";

        private ParserFactoryInterface factory = null;

        /* a Map from view name to view definition(String)*/
        private Map viewDefinitions = null;

        private HashMap varDefNames = new HashMap();
        private HashMap linkMap = new HashMap();

        private NamespaceContextStack namespaceContextStack = new NamespaceContextStack();

        private ArrayList declList = new ArrayList();

        private HashMap hashDeclVarList = new HashMap();
        private HashMap hashExtVar = new HashMap();

        private HashMap hashDeclFuncList = new HashMap();

        private HashMap importSchemas = new HashMap();
        private ArrayList schemaList = new ArrayList();

        private HashMap importModules = new HashMap();
        private ArrayList moduleList = new ArrayList();

        private String defaultElementNameSpace = null;
        private String defaultFunctionNameSpace = null;

        private String defaultCollation = null;
        private String baseURI = null;
        private boolean hasDeclaredBaseURI = false;
        private int xmlspace = Constants.NOTHING; // "strip" default value (preserve -> false)
        private int validation = Constants.NOTHING;

        private boolean inPredicate = false;

        private String libraryPrefix = null;

        public void reset() {
                varDefNames.clear();
                namespaceContextStack.reset();

                declList = new ArrayList();
                hashDeclVarList = new HashMap();
                hashDeclFuncList = new HashMap();
                importSchemas = new HashMap();
                importModules = new HashMap();
                schemaList = new ArrayList();
                moduleList = new ArrayList();
                hashExtVar = new HashMap();

                defaultElementNameSpace = null;
                defaultFunctionNameSpace = null;
                defaultCollation = null;
                xmlspace = Constants.NOTHING;
                validation = Constants.NOTHING;
                inPredicate = false;
                token_source.getStateStack().clear();
        }

        public void setBaseURI(String uri) {
                baseURI = uri;
        }

        private String unquote(String s) {
                return s.substring(1, s.length()-1);
        }

        private String getNameSpace(String prefixname) {
                if (prefixname == null) return  null;
                String str = namespaceContextStack.getNamespaceURI(prefixname);
                if (str == null) {
                        if (prefixname.equals(XML))
                                str = XMLURI;
                                //namespaceContextStack.declarePrefix(XML,"http://www.w3.org/XML/1998/namespace");
                        else if (prefixname.equals(XS))
                                str = XSURI;
                                //namespaceContextStack.declarePrefix(XS,"http://www.w3.org/2001/XMLSchema");
                        else if (prefixname.equals(XSI))
                                str = XSIURI;
                                //namespaceContextStack.declarePrefix(XSI,"http://www.w3.org/2001/XMLSchema-instance");
                        else if (prefixname.equals(FN))
                                str = FNURI;
                                //namespaceContextStack.declarePrefix(FN,"http://www.w3.org/2003/11/xpath-functions");
                        else if (prefixname.equals(XDT))
                                str = XDTURI;
                                //namespaceContextStack.declarePrefix(XDT,"http://www.w3.org/2003/11/xpath-datatypes");
                        else if (prefixname.equals(LOCAL))
                                str =LOCALURI;
                                //namespaceContextStack.declarePrefix(LOCAL,"http://www.w3.org/2003/11/xquery-local-functions");
                        //str = namespaceContextStack.getNamespaceURI(prefixname);
                }
                return str;
        }

        public TypeVisitor getTypeVisitor() {
                return staticcontext.getTypeVisitor();
        }

        public SchemaManager getSchemaManager() {
                return initialSchemamanager;
        }

        public void setFactory(String factoryClassName) throws ParseException {
                try {
                        Class c = Class.forName (factoryClassName) ;
                        factory = (ParserFactoryInterface) c.newInstance () ;
                }
                catch (ClassNotFoundException e) {
                        throw new ParseException("Could not find class " + factoryClassName);
                }
        catch (IllegalAccessException e) {
                throw new ParseException("Could not access factory builder");
        }
                catch (InstantiationException e) {
                                throw new ParseException("Could not instantiate factory");
                }
        }


        public void setViewDefinitions(Map viewDefinitions) {
                this.viewDefinitions = viewDefinitions;
        }

        private char parsePredefinedEntityRef(String predefinedEntityRef) throws ParseException {
                if (predefinedEntityRef.equals("&lt;")) return '<';
                if (predefinedEntityRef.equals("&gt;")) return '>';
                if (predefinedEntityRef.equals("&amp;")) return '&';
                if (predefinedEntityRef.equals("&quot;")) return '"';
                if (predefinedEntityRef.equals("&apos;")) return '\'';
                throw new ParseException("Invalid token error.");
        }

        private static char parseCharRef(String charRef) {
                int value = -1;
                if (charRef.startsWith("&#x")) value = Integer.parseInt(charRef.substring(3, charRef.length() - 1), 16);
                else value = Integer.parseInt(charRef.substring(2, charRef.length() - 1));
                switch(value) {
                        case(9):
                                return '\t';
                        case(10):
                                return '\n';
                        case(13):
                                return '\r';
                        default:
                                return (new Character((char)value)).charValue();
                }
        }

        private String extractName(String image,String left, String right) {
                int index;
                if (left != null) {
                        index = image.indexOf(left);
                        if (index != -1)
                                image = image.substring(index+left.length()).trim();
                }
                if (right != null) {
                        index = image.indexOf(right);
                        if (index != -1)
                                image = image.substring(0,index).trim();
                }
                return image;
        }

        /**************************************************************************************
	[21]    QName    ::=    [http://www.w3.org/TR/REC-xml-names/#NT-QName] Names 
	[6]  QName ::=  (Prefix ':')? LocalPart 
	[7]  Prefix ::=  NCName 
	[8]  LocalPart ::=  NCName 
	**************************************************************************************/
        private QName QName(String image) throws ParseException, TypeException, XQueryException {
                return QName(image,true,false);
        }
        private QName QName(String image, boolean check) throws ParseException, TypeException, XQueryException {
                return QName(image,check,false);
        }
        private QName QName(String image, boolean check, boolean isFunction) throws ParseException, TypeException, XQueryException {
                return QName(image,check,null,false);
        }
        private QName QName(String image, boolean check, String prefix, boolean isFunction) throws ParseException, TypeException, XQueryException {
                String namespace = null;
                String prefixname = null;
                String typeName = null;

                // calculate above values from image
        int index = image.indexOf(':');
        if (index == -1)
                        typeName = image;
                else {
                        prefixname = image.substring(0,index);
                        typeName = image.substring(index+1);
                }
                if (prefix != null && !prefix.equals(prefixname)) {
                        throw new TypeException("Incorrect prefix [ " + prefixname + " ], expected [ " + prefix + " ]" , currentToken.beginLine, currentToken.beginColumn);
                }
                try {
                        String tmpStr = null;
                        if (prefixname == null)
                        {
                                if (isFunction)
                                        namespace = defaultFunctionNameSpace;
// AM: Why is this check needed? It prevents default namespace resolution!
//				else if (!check)
                                else
                                        namespace = defaultElementNameSpace;
                        }
                        else
                        {
                                if (!prefixname.equals(XMLNS) && check)
                                {
                                        tmpStr = getNameSpace(prefixname);
                                        if (tmpStr == null)
                                                throw new TypeException("Could not match prefix [ " + prefixname + " ]" , currentToken.beginLine, currentToken.beginColumn);
                                        namespace = tmpStr;
                                }
                        }
                        return factory.createQName(namespace, prefixname, typeName, parentModule, namespaceContextStack.getNamespaceContext());
                } catch (TypeException te)
                {
                        throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);
                }
        }

        /**************************************************************************************
	[20]    VarName    ::=    QName 
	**************************************************************************************/
        private XQueryExpression VarName(String varname) throws ParseException, TypeException, XQueryException {
                return VarName(varname, true, null, true);
        }
        private XQueryExpression VarName(String varname, String prefix) throws ParseException, TypeException, XQueryException {
                return VarName(varname, true, prefix, true);
        }
        private XQueryExpression VarName(String varname, boolean isnew) throws ParseException, TypeException, XQueryException {
                return VarName(varname, isnew, null, true);
        }
        private XQueryExpression VarName(String varname, boolean isnew, String prefix, boolean rename) throws ParseException, TypeException, XQueryException {
                Variable var = null;

                String varStr = "$" + varname;
                String namespace = null;
                String prefixname = null;
                String localName = null;

                // calculate above values from image
        int index = varname.indexOf(':');
        if (index == -1)
                        localName = varname;
                else {
                        prefixname = varname.substring(0,index);
                        localName = varname.substring(index+1);
                }
                if (prefix != null && !prefix.equals(prefixname)) {
                        throw new TypeException("Incorrect prefix [ " + prefixname + " ], expected [ " + prefix + " ]" , currentToken.beginLine, currentToken.beginColumn);
                }
                if (prefixname != null)
                {
                        String tmpStr = getNameSpace(prefixname);
                        if (tmpStr == null)
                                throw new TypeException("Could not match prefix [ " + prefixname + " ]" , currentToken.beginLine, currentToken.beginColumn);
                        namespace = tmpStr;
                }
                String varStringValue = localName;
                if (namespace != null) {
                        varStringValue = "${"+namespace+"}"+varStringValue;
                } else {
                        varStringValue = "$"+varStringValue;
                }
                // calculate above values from image
                if (isnew)
                {
                        if (varDefNames.containsKey(varStr) || hashDeclVarList.containsKey(varStr))
                        {
                                throw new ParseException("Error : Variable $" + varname + " already defined!");
                        }
                        if (rename) {
                                        localName = staticcontext.getVarName(parentModule).getLocalName();
                                        String varNewStringValue = localName;
                                        if (namespace != null) {
                                                varNewStringValue = "${"+namespace+"}"+varNewStringValue;
                                        } else {
                                                varNewStringValue = "$"+varNewStringValue;
                                        }
                                        linkMap.put(varNewStringValue,varStringValue);
                        }
                        try
                        {
                                var = factory.createVariable(factory.createQName(namespace, prefixname, localName, parentModule, namespaceContextStack.getNamespaceContext()), parentModule);
                                addVarDefinition(varStringValue,var);
                        }
                        catch (TypeException te)
                        {
                                throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);
                        }
                }
                else
                {
                        /*
			HashMap map = (HashMap)hashDeclVarList.get(namespace);
			if (map != null && var != null)
				var = (Variable)map.get(var.getVarName().getLocalName());
			if (var == null)
			*/
                                var = getVarDefinition(varStringValue);
                        if (var == null)
                        {
                                throw new TypeException("Error : Variable $" + varname + " not defined!", currentToken.beginLine, currentToken.beginColumn);
                        }
                        ExternalVariable extVar = (ExternalVariable)hashExtVar.get(var);
                        if (extVar != null)
                                return extVar;
                }
                return var;
        }

        private void addVarDefinition(String varStr, Variable var) {
                Stack st = (Stack)varDefNames.get(varStr);
                if (st == null) {
                        st = new Stack();
                        varDefNames.put(varStr,st);
                }
                st.push(var);
        }

        private void removeVarDefinition(String varStr) {
                String str = (String)linkMap.get(varStr);
                if (str == null) str = varStr;
                Stack st = (Stack)varDefNames.get(str);
                st.pop();
                if (st.isEmpty())
                        varDefNames.remove(str);
        }

        private Variable getVarDefinition(String varStr) {
                Stack st = (Stack)varDefNames.get(varStr);
                if (st == null || st.isEmpty())
                        return null;
                return (Variable)st.peek();
        }

        public XQueryModule Start(MetadataAccess metadata, SchemaManager schemamanager, ModuleManager modulemanager, VarCounter varCounter, boolean qaOnly) throws ParseException, TypeException, XQueryException {
                return Start(metadata, schemamanager, modulemanager, varCounter, qaOnly, true);
        }

        public XQueryModule Start(MetadataAccess metadata, SchemaManager schemamanager, ModuleManager modulemanager, VarCounter varCounter) throws ParseException, TypeException, XQueryException {
                return Start(metadata, schemamanager, modulemanager, varCounter, false, true);
        }

  final public XQueryModule Start(MetadataAccess metadata, SchemaManager schemamanager, ModuleManager modulemanager, VarCounter varCounter, boolean qaOnly, boolean restriction) throws ParseException, TypeException, XQueryException {
        this.restriction = restriction;
        if (factory == null) factory = new ParserFactory();
        parentModule = factory.createXQueryModule();
        initialSchemamanager = schemamanager;
        staticcontext = new StaticContext(metadata,initialSchemamanager,modulemanager,varCounter);
        staticcontext.setTypeVisitor(new TypeVisitor(staticcontext, qaOnly));
        parentModule.setStaticContext(staticcontext);
        reset();
    try {
      XQueryModule();
      jj_consume_token(0);
    } catch (TypeException te) {
                String strmsg = te.getMessage();
        Iterator it = linkMap.keySet().iterator();
        while (it.hasNext())
        {
                String search = (String)it.next();
                int index=-1;
                while ((index = strmsg.indexOf(search, index+1)) != -1)
                {
                        strmsg = strmsg.substring(0, index)+(String)linkMap.get(search)+strmsg.substring(index+search.length());
                }
        }
                {if (true) throw new TypeException(strmsg);}
    } catch (TokenMgrError tme) {
                {if (true) throw new ParseException(tme.getMessage());}
    }
                        {if (true) return parentModule;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[30]    Module    ::=    VersionDecl? (MainModule | LibraryModule) 
[36]    VersionDecl    ::=    <"xquery" "version" StringLiteral> Separator 
***************************************************************************************/
  final public void XQueryModule() throws ParseException, TypeException, XQueryException {
        String version = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XQUERY_VERSION:
      currentToken = jj_consume_token(XQUERY_VERSION);
      currentToken = jj_consume_token(StringLiteral);
                        version = unquote(currentToken.image);
                        // added LARS
                        token_source.switchState(DEFAULT);
      currentToken = jj_consume_token(SEMI_COLON);
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case DECLARE_VALIDATION:
    case DECLARE_NAMESPACE:
    case DECLARE_BASE_URI:
    case DECLARE_VARIABLE_$:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case DECLARE_XMLSPACE:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case DECLARE_FUNCTION:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case DECLARE_DEFAULT_COLLATION:
    case DECLARE_DEFAULT_ELEMENT:
    case DECLARE_DEFAULT_FUNCTION:
    case IMPORT_SCHEMA:
    case IMPORT_MODULE:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      MainModule();
      break;
    case MODULE_NAMESPACE:
      LibraryModule();
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (version != null)
                parentModule.setVersion(version);
  }

/***************************************************************************************
[31]    MainModule    ::=    Prolog QueryBody 
[39]    QueryBody    ::=    Expr 
[40]    Expr    ::=    ExprSingle ("," ExprSingle)* 
***************************************************************************************/
  final public void MainModule() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList tmpVect = new ArrayList();
    Prolog();
    expression = ExprSingle();
        if (expression != null)
                tmpVect.add(expression);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
      currentToken = jj_consume_token(COMMA);
      expression = ExprSingle();
                if (expression != null)
                        tmpVect.add(expression);
    }
                if (hashDeclVarList.isEmpty()) { hashDeclVarList = null; }
                if (hashDeclFuncList.isEmpty()) { hashDeclFuncList = null; }
                if (importSchemas.isEmpty()) { importSchemas = null; schemaList = null; }
                if (importModules.isEmpty()) { importModules = null; moduleList = null; }
                if (declList.isEmpty()) { declList = null; }

                parentModule.setExpressions(tmpVect);
                parentModule.setDefaultCollation(defaultCollation);
                if (hasDeclaredBaseURI) parentModule.setBaseURI(baseURI);
                parentModule.setDefaultFunctionNamespace(defaultFunctionNameSpace);
                parentModule.setDeclarations(namespaceContextStack);
                parentModule.setVariables(hashDeclVarList);
                parentModule.setExternalVariables(hashExtVar);
                parentModule.setFunctions(hashDeclFuncList);
                parentModule.setImportSchemas(importSchemas);
                parentModule.setImportModules(importModules);
                parentModule.setDeclList(declList);
                parentModule.setSchemaList(schemaList);
                parentModule.setModuleList(moduleList);
                if (xmlspace != Constants.NOTHING) parentModule.setXmlSpace(xmlspace);
                if (validation != Constants.NOTHING) parentModule.setValidation(validation);
                parentModule.setSchemaManager(staticcontext.getSchemaManager());
  }

/***************************************************************************************
[32]    LibraryModule    ::=    ModuleDecl Prolog 
[33]    ModuleDecl    ::=    <"module" "namespace"> NCName "=" StringLiteral Separator 
***************************************************************************************/
  final public void LibraryModule() throws ParseException, TypeException, XQueryException {
        String modulePrefix = null;
        String moduleNamespace = null;
    currentToken = jj_consume_token(MODULE_NAMESPACE);
    currentToken = jj_consume_token(NAMESPACEDECL_NCNAME);
                modulePrefix = currentToken.image;
                libraryPrefix = modulePrefix;
    currentToken = jj_consume_token(NAMESPACEDECL_EQUAL);
    currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                moduleNamespace = unquote(currentToken.image);
                namespaceContextStack.declarePrefix(modulePrefix,moduleNamespace);
    currentToken = jj_consume_token(SEMI_COLON);
    Prolog();
                if (hashDeclVarList.isEmpty()) { hashDeclVarList = null; }
                if (hashDeclFuncList.isEmpty()) { hashDeclFuncList = null; }
                if (importSchemas.isEmpty()) { importSchemas = null; schemaList = null; }
                if (importModules.isEmpty()) { importModules = null; moduleList = null; }
                if (declList.isEmpty()) { declList = null; }

                parentModule.setPrefix(modulePrefix);
                parentModule.setNamespace(moduleNamespace);
                parentModule.setDefaultCollation(defaultCollation);
                if (hasDeclaredBaseURI) parentModule.setBaseURI(baseURI);
                parentModule.setDefaultFunctionNamespace(defaultFunctionNameSpace);
                parentModule.setDeclarations(namespaceContextStack);
                parentModule.setVariables(hashDeclVarList);
                parentModule.setExternalVariables(hashExtVar);
                parentModule.setFunctions(hashDeclFuncList);
                parentModule.setImportSchemas(importSchemas);
                parentModule.setImportModules(importModules);
                parentModule.setDeclList(declList);
                parentModule.setSchemaList(schemaList);
                parentModule.setModuleList(moduleList);
                if (xmlspace != Constants.NOTHING) parentModule.setXmlSpace(xmlspace);
                if (validation != Constants.NOTHING) parentModule.setValidation(validation);
                parentModule.setSchemaManager(staticcontext.getSchemaManager());
  }

/***************************************************************************************
[34]    Prolog    ::=    (
							(
							  NamespaceDecl
							| XMLSpaceDecl
							| DefaultNamespaceDecl
							| DefaultCollationDecl
							| BaseURIDecl
							| SchemaImport
							| ModuleImport
							| VarDecl
							| ValidationDecl
							| FunctionDecl
							) 
							Separator
						)* 
***************************************************************************************/
  final public void Prolog() throws ParseException, TypeException, XQueryException {
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DECLARE_VALIDATION:
      case DECLARE_NAMESPACE:
      case DECLARE_BASE_URI:
      case DECLARE_VARIABLE_$:
      case DECLARE_XMLSPACE:
      case DECLARE_FUNCTION:
      case DECLARE_DEFAULT_COLLATION:
      case DECLARE_DEFAULT_ELEMENT:
      case DECLARE_DEFAULT_FUNCTION:
      case IMPORT_SCHEMA:
      case IMPORT_MODULE:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DECLARE_NAMESPACE:
        NamespaceDecl();
        break;
      case DECLARE_XMLSPACE:
        XMLSpaceDecl();
        break;
      case DECLARE_DEFAULT_ELEMENT:
      case DECLARE_DEFAULT_FUNCTION:
        DefaultNamespaceDecl();
        break;
      case DECLARE_DEFAULT_COLLATION:
        DefaultCollationDecl();
        break;
      case DECLARE_BASE_URI:
        BaseURIDecl();
        break;
      case IMPORT_SCHEMA:
        SchemaImport();
        break;
      case IMPORT_MODULE:
        ModuleImport();
        break;
      case DECLARE_VARIABLE_$:
        VarDecl();
        break;
      case DECLARE_VALIDATION:
        ValidationDecl();
        break;
      case DECLARE_FUNCTION:
        FunctionDecl();
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMI_COLON:
        currentToken = jj_consume_token(SEMI_COLON);
        break;
      default:
        jj_la1[5] = jj_gen;
        ;
      }
    }
  }

/***************************************************************************************
[118]    NamespaceDecl    ::=    <"declare" "namespace"> NCName "=" StringLiteral 
***************************************************************************************/
  final public void NamespaceDecl() throws ParseException, TypeException, XQueryException {
        String prefix = null;
        String uri = null;
    currentToken = jj_consume_token(DECLARE_NAMESPACE);
    currentToken = jj_consume_token(NAMESPACEDECL_NCNAME);
                        prefix = currentToken.image;
    currentToken = jj_consume_token(NAMESPACEDECL_EQUAL);
    currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                        uri = unquote(currentToken.image);
                namespaceContextStack.declarePrefix(prefix, uri);
  }

/***************************************************************************************
[115]    XMLSpaceDecl    ::=    <"declare" "xmlspace"> ("preserve" | "strip") 
***************************************************************************************/
  final public void XMLSpaceDecl() throws ParseException, TypeException, XQueryException {
    currentToken = jj_consume_token(DECLARE_XMLSPACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XMLSPACE_DECL_PRESERVE:
      currentToken = jj_consume_token(XMLSPACE_DECL_PRESERVE);
                                xmlspace = Constants.XMLSPACE_PRESERVE;
      break;
    case XMLSPACE_DECL_STRIP:
      currentToken = jj_consume_token(XMLSPACE_DECL_STRIP);
                                xmlspace = Constants.XMLSPACE_STRIP;
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/***************************************************************************************
[119]    DefaultNamespaceDecl    ::=    (<"declare" "default" "element"> | <"declare" "default" "function">) "namespace" StringLiteral 
***************************************************************************************/
  final public void DefaultNamespaceDecl() throws ParseException, TypeException, XQueryException {
        String uri = null;
        boolean forFunction = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DECLARE_DEFAULT_ELEMENT:
      currentToken = jj_consume_token(DECLARE_DEFAULT_ELEMENT);
      break;
    case DECLARE_DEFAULT_FUNCTION:
      currentToken = jj_consume_token(DECLARE_DEFAULT_FUNCTION);
                                forFunction = true;
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(NAMESPACEKEYWORD_NAMESPACE);
    currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                        uri = unquote(currentToken.image);
                if (forFunction) {
                        if (defaultFunctionNameSpace != null)
                        {
                                {if (true) throw new TypeException("Default function namespace defined more than once", currentToken.beginLine, currentToken.beginColumn);}
                        }
                        defaultFunctionNameSpace = uri;
                } else {
                        if (defaultElementNameSpace != null) {
                                {if (true) throw new TypeException("Default element namespace defined more than once", currentToken.beginLine, currentToken.beginColumn);}
                        }
                        defaultElementNameSpace = uri;
                        namespaceContextStack.declarePrefix("", uri);
                }
  }

/***************************************************************************************
[116]    DefaultCollationDecl    ::=    <"declare" "default" "collation"> StringLiteral 
***************************************************************************************/
  final public void DefaultCollationDecl() throws ParseException, TypeException, XQueryException {
    currentToken = jj_consume_token(DECLARE_DEFAULT_COLLATION);
    currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                        defaultCollation = unquote(currentToken.image);
  }

/***************************************************************************************
[117]    BaseURIDecl    ::=    <"declare" "base-uri"> StringLiteral 
***************************************************************************************/
  final public void BaseURIDecl() throws ParseException, TypeException, XQueryException {
    currentToken = jj_consume_token(DECLARE_BASE_URI);
    currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                        baseURI = unquote(currentToken.image);
                        hasDeclaredBaseURI = true;
  }

/***************************************************************************************
[146]    SchemaImport    ::=    <"import" "schema"> SchemaPrefix? StringLiteral <"at" StringLiteral>? 
[147]    SchemaPrefix    ::=    ("namespace" NCName "=") | (<"default" "element"> "namespace") 
***************************************************************************************/
  final public void SchemaImport() throws ParseException, TypeException, XQueryException {
        boolean hasPrefix = false;
        String prefix = null;
        String name = null;
        String location = null;
    currentToken = jj_consume_token(IMPORT_SCHEMA);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACEKEYWORD_NAMESPACE:
    case NAMESPACEKEYWORD_DEFAULT_ELEMENT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAMESPACEKEYWORD_NAMESPACE:
        currentToken = jj_consume_token(NAMESPACEKEYWORD_NAMESPACE);
        currentToken = jj_consume_token(NAMESPACEDECL_NCNAME);
                                        prefix = currentToken.image;
                                        hasPrefix = true;
        currentToken = jj_consume_token(NAMESPACEDECL_EQUAL);
        break;
      case NAMESPACEKEYWORD_DEFAULT_ELEMENT:
        currentToken = jj_consume_token(NAMESPACEKEYWORD_DEFAULT_ELEMENT);
                                        prefix = null;
                                        hasPrefix = true;
        currentToken = jj_consume_token(NAMESPACEKEYWORD_NAMESPACE);
        break;
      default:
        jj_la1[8] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACEDECL_StringLiteral:
      currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                                name = unquote(currentToken.image);
      break;
    case NAMESPACEKEYWORD_StringLiteral:
      currentToken = jj_consume_token(NAMESPACEKEYWORD_StringLiteral);
                                name = unquote(currentToken.image);
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AT:
      currentToken = jj_consume_token(AT);
      currentToken = jj_consume_token(NAMESPACEKEYWORD_StringLiteral);
                        location = unquote(currentToken.image);
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
                try {
                        if (staticcontext.getTypeVisitor() != null)
                        {
                                if (baseURI != null && location != null)
                                        location = (new URL(new URL(baseURI),location)).toString();
                                if (name.length() == 0)
                                        name = null;
                                staticcontext.getTypeVisitor().getSchemaManager().addSchemaLocation(name, location);
                                staticcontext.getTypeVisitor().getSchemaManager().loadSchema(staticcontext.getTypeVisitor().getSchemaLocator(), name);
                                if (staticcontext.getTypeVisitor().getSchemaManager().getSchema(name) == null) {
                                        {if (true) throw new ParseException("Could not load schema at location : " + location);}
                                }
                        }
                } catch (MalformedURLException mue) {
                        {if (true) throw new ParseException(mue.getMessage());}
                } catch (SAXException saxe) {
                        {if (true) throw new ParseException(saxe.getMessage());}
                }
                if (hasPrefix) {
                        if (prefix != null) {
                                namespaceContextStack.declarePrefix(prefix, name);
                        } else {
                                if (defaultElementNameSpace != null) {
                                        {if (true) throw new TypeException("Default element namespace defined more than once", currentToken.beginLine, currentToken.beginColumn);}
                                }
                                defaultElementNameSpace = name;
                                namespaceContextStack.declarePrefix("", name);
                        }
                }
                importSchemas.put(name,factory.createImportSchema(hasPrefix,prefix,name,location));
                schemaList.add(name);
  }

/***************************************************************************************
[37]    ModuleImport    ::=    <"import" "module"> ("namespace" NCName "=")? StringLiteral <"at" StringLiteral>? 
***************************************************************************************/
  final public void ModuleImport() throws ParseException, TypeException, XQueryException {
        String prefix = null;
        String name = null;
        String location = null;
    currentToken = jj_consume_token(IMPORT_MODULE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACEKEYWORD_NAMESPACE:
      currentToken = jj_consume_token(NAMESPACEKEYWORD_NAMESPACE);
      currentToken = jj_consume_token(NAMESPACEDECL_NCNAME);
                                prefix = currentToken.image;
      currentToken = jj_consume_token(NAMESPACEDECL_EQUAL);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACEDECL_StringLiteral:
      currentToken = jj_consume_token(NAMESPACEDECL_StringLiteral);
                                name = unquote(currentToken.image);
      break;
    case NAMESPACEKEYWORD_StringLiteral:
      currentToken = jj_consume_token(NAMESPACEKEYWORD_StringLiteral);
                                name = unquote(currentToken.image);
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AT:
      currentToken = jj_consume_token(AT);
      currentToken = jj_consume_token(NAMESPACEKEYWORD_StringLiteral);
                        location = unquote(currentToken.image);
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
                XQueryModule mod = null;
                if (staticcontext.getTypeVisitor() != null)
                {
                        try {
                                if (baseURI != null && location != null)
                                        location = (new URL(new URL(baseURI),location)).toString();
                                if (name.length() == 0)
                                        name = null;
                                staticcontext.getModuleManager().addModuleLocation(name, location);
                                mod = staticcontext.getModuleManager().loadModule(name,initialSchemamanager,staticcontext.getTypeVisitor(),staticcontext.getVarCounter());
                                // add schemas from imported module to module ???
                if (mod.getVariables() != null) {
                        hashDeclVarList.putAll(mod.getVariables());
                }
                if (mod.getFunctions() != null) {
                        hashDeclFuncList.putAll(mod.getFunctions());
                }
                declList.addAll(mod.getDeclList());
                        } catch (MalformedURLException mue) {
                                {if (true) throw new ParseException(mue.getMessage());}
                        }
                }
                if (prefix != null)
                        namespaceContextStack.declarePrefix(prefix, name);
                importModules.put(name,factory.createImportModule(prefix,name,location,mod));
                moduleList.add(name);
  }

/***************************************************************************************
[38]    VarDecl    ::=    <"declare" "variable" "$"> VarName TypeDeclaration? (( ":=" "{" Expr "}") | "external") 
***************************************************************************************/
  final public void VarDecl() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        Variable var = null;
        SequenceType sequenceType = null;
        boolean isExternal = false;
    currentToken = jj_consume_token(DECLARE_VARIABLE_$);
    currentToken = jj_consume_token(VARNAME_QNAME);
                        var = (Variable)VarName(currentToken.image,true,libraryPrefix,false);
                        var.setBindingType(Constants.DECLARATION_BINDINGTYPE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_AS:
      sequenceType = TypeDeclaration();
                                var.setTypeDeclaration(sequenceType);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_COLON_EQUAL:
      currentToken = jj_consume_token(OPERATOR_COLON_EQUAL);
      expression = EnclosedExpr(true);
                                var.setExpression(expression, true);
      break;
    case OPERATOR_EXTERNAL:
      currentToken = jj_consume_token(OPERATOR_EXTERNAL);
                                isExternal = true;
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                HashMap map = (HashMap)hashDeclVarList.get(var.getVarName().getNameSpace());
                if (map == null) {
                        map = new HashMap();
                        hashDeclVarList.put(var.getVarName().getNameSpace(),map);
                } else {
                        if (map.get(var.getStringValue()) != null)
                                {if (true) throw new ParseException("Variable " + var.getVarName().getName() + " defined more than once.");}
                }
                map.put(var.getVarName().getLocalName(),var);
                declList.add(var.getVarName());
                if (isExternal) {
                        try {
                                ExternalVariable extVar = factory.createExternalVariable(var,parentModule);
                                hashExtVar.put(var,extVar);
                        }
                        catch (TypeException te) {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
  }

/***************************************************************************************
[145]    ValidationDecl    ::=    <"declare" "validation"> SchemaMode 
***************************************************************************************/
  final public void ValidationDecl() throws ParseException, TypeException, XQueryException {
        int mode = Constants.NOTHING;
    currentToken = jj_consume_token(DECLARE_VALIDATION);
    mode = SchemaMode();
                validation = mode;
  }

/***************************************************************************************
[12]    SchemaMode    ::=    "lax" | "strict" | "skip" 
***************************************************************************************/
  final public int SchemaMode() throws ParseException, TypeException, XQueryException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_LAX:
      currentToken = jj_consume_token(OPERATOR_LAX);
                {if (true) return Constants.VALIDATION_LAX;}
      break;
    case OPERATOR_STRICT:
      currentToken = jj_consume_token(OPERATOR_STRICT);
                {if (true) return Constants.VALIDATION_STRICT;}
      break;
    case OPERATOR_SKIP:
      currentToken = jj_consume_token(OPERATOR_SKIP);
                {if (true) return Constants.VALIDATION_SKIP;}
      break;
    case OPERATOR_PRESERVE:
      currentToken = jj_consume_token(OPERATOR_PRESERVE);
                {if (true) return Constants.VALIDATION_PRESERVE;}
      break;
    default:
      jj_la1[17] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[120]    FunctionDecl    ::=    <"declare" "function"> <QName "("> ParamList? (")" | (<")" "as"> SequenceType)) (EnclosedExpr | "external") 
***************************************************************************************/
  final public void FunctionDecl() throws ParseException, TypeException, XQueryException {
        QName funcName = null;
        ArrayList paramList = null;
        SequenceType sequenceType = null;
        XQueryExpression enclosedExpr = null;
        FunctionDeclaration functionDeclaration = null;
        HashMap map = null;
    currentToken = jj_consume_token(DECLARE_FUNCTION);
    currentToken = jj_consume_token(QNAME_L_PAREN);
                        String str = extractName(currentToken.image,null,"(");
                        funcName = QName(str,true,libraryPrefix,true);
                        // test funcName has prefix
                        if (funcName.getPrefixName() == null)
                                {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Function " + funcName.toString() + " should have a prefix.");}
                        // verify that prefix is not predefined prefix
                        if (funcName.getPrefixName().equals(XML) ||
                                funcName.getPrefixName().equals(XS) ||
                                funcName.getPrefixName().equals(FN) ||
                                funcName.getPrefixName().equals(XDT) ||
                                funcName.getPrefixName().equals(XSI))
                                {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Function " + funcName.toString() + " has incorrect predefined prefix.");}
                        map = (HashMap)hashDeclFuncList.get(funcName.getNameSpace());
                        if (map != null) {
                                functionDeclaration = (FunctionDeclaration)map.get(funcName.getLocalName());
                                if (functionDeclaration != null)
                                        {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Function " + funcName.toString() + " already defined.");}
                        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOLLAR:
      paramList = ParamList();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case R_PAREN:
      currentToken = jj_consume_token(R_PAREN);
      break;
    case R_PAREN_AS:
      currentToken = jj_consume_token(R_PAREN_AS);
      sequenceType = SequenceType();
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case L_BRACE:
    case ELEMENT_CONTENT_L_BRACE:
      enclosedExpr = EnclosedExpr(true);
      break;
    case OPERATOR_EXTERNAL:
      currentToken = jj_consume_token(OPERATOR_EXTERNAL);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". External Function Declaration is not supported yet.");}
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        functionDeclaration = factory.createFunctionDeclaration(funcName, paramList, sequenceType, (enclosedExpr==null)?null:((XQueryExpressionSequence)enclosedExpr).getSubExpressions(), parentModule);
                        map = (HashMap)hashDeclFuncList.get(functionDeclaration.getFuncName().getNameSpace());
                        if (map == null) {
                                map = new HashMap();
                                hashDeclFuncList.put(functionDeclaration.getFuncName().getNameSpace(),map);
                        } else {
                                if (map.get(functionDeclaration.getFuncName().getLocalName()) != null)
                                        {if (true) throw new ParseException("Function " + functionDeclaration.getFuncName().getLocalName() + " defined more than once.");}
                        }
                        map.put(functionDeclaration.getFuncName().getLocalName(),functionDeclaration);
                        declList.add(functionDeclaration.getFuncName());
                        ArrayList params = functionDeclaration.getParameters();
                        if (params != null)
                                for (int i=0;i<params.size();i++) {
                                        removeVarDefinition(((Variable)params.get(i)).getStringValue());
                                }
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
  }

/***************************************************************************************
[121]    ParamList    ::=    Param ("," Param)* 
***************************************************************************************/
  final public ArrayList ParamList() throws ParseException, TypeException, XQueryException {
        ArrayList params = new ArrayList();
        XQueryExpression expression = null;
    currentToken = jj_consume_token(DOLLAR);
    expression = Param();
                        params.add(expression);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_3;
      }
      currentToken = jj_consume_token(COMMA);
      currentToken = jj_consume_token(DOLLAR);
      expression = Param();
                                params.add(expression);
    }
                {if (true) return params;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[122]    Param    ::=    "$" VarName TypeDeclaration? 
***************************************************************************************/
  final public Variable Param() throws ParseException, TypeException, XQueryException {
        Variable var = null;
        SequenceType sequenceType = null;
    currentToken = jj_consume_token(VARNAME_QNAME);
                        var = (Variable)VarName(currentToken.image);
                        //addVarDefinition(var);

    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_AS:
      sequenceType = TypeDeclaration();
                                var.setTypeDeclaration(sequenceType);
      break;
    default:
      jj_la1[22] = jj_gen;
      ;
    }
                var.setBindingType(Constants.PARAMETER_BINDINGTYPE);
                var.accept(staticcontext.getTypeVisitor());
                {if (true) return var;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[123]    TypeDeclaration    ::=    "as" SequenceType 
***************************************************************************************/
  final public SequenceType TypeDeclaration() throws ParseException, TypeException, XQueryException {
        SequenceType sequenceType = null;
    currentToken = jj_consume_token(OPERATOR_AS);
    sequenceType = SequenceType();
                {if (true) return sequenceType;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[125]    SequenceType    ::=    (ItemType OccurrenceIndicator?) | ("empty" "(" ")") 
[144]    OccurrenceIndicator    ::=    "?" | "*" | "+" 
[127]    ItemType    ::=    AtomicType | KindTest | ("item" "(" ")") 
[126]    AtomicType    ::=    QName 
***************************************************************************************/
  final public SequenceType SequenceType() throws ParseException, TypeException, XQueryException {
        ItemType itemType = null;
        QName atomicType = null;
        int occurrenceIndicator = Constants.NOTHING;
        XQueryExpression nodeType = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case ITEMTYPE_QNAME:
    case ITEMTYPE_ITEM_L_PAREN_R_PAREN:
    case KINDTEST_ELEMENT_L_PAREN:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ITEMTYPE_QNAME:
        currentToken = jj_consume_token(ITEMTYPE_QNAME);
                                        QName qname = QName(currentToken.image);
                                        try
                                        {
                                                itemType = factory.createItemType((XQueryExpression)qname,parentModule);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
        break;
      case ELEMENT_L_PAREN:
      case ATTRIBUTE_L_PAREN:
      case COMMENT_L_PAREN:
      case TEXT_L_PAREN:
      case NODE_L_PAREN:
      case DOCUMENT_NODE_L_PAREN:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case KINDTEST_ELEMENT_L_PAREN:
        nodeType = KindTest();
                                        try
                                        {
                                                itemType = factory.createItemType((XQueryExpression)nodeType,parentModule);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
        break;
      case ITEMTYPE_ITEM_L_PAREN_R_PAREN:
        currentToken = jj_consume_token(ITEMTYPE_ITEM_L_PAREN_R_PAREN);
                                        try
                                        {
                                                itemType = factory.createItemType((XQueryExpression)null,parentModule);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
        break;
      default:
        jj_la1[23] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }

      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_STAR:
      case OPERATOR_QUESTION_MARK:
      case PLUS:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case OPERATOR_STAR:
          currentToken = jj_consume_token(OPERATOR_STAR);
                                        occurrenceIndicator = Constants.OCCURRENCE_STAR;
                                        token_source.SwitchTo(OPERATOR);
          break;
        case PLUS:
          currentToken = jj_consume_token(PLUS);
                                        occurrenceIndicator = Constants.OCCURRENCE_PLUS;
                                        token_source.SwitchTo(OPERATOR);
          break;
        case OPERATOR_QUESTION_MARK:
          currentToken = jj_consume_token(OPERATOR_QUESTION_MARK);
                                        occurrenceIndicator = Constants.OCCURRENCE_QUESTION_MARK;
                                        token_source.SwitchTo(OPERATOR);
          break;
        default:
          jj_la1[24] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[25] = jj_gen;
        ;
      }
      break;
    case ITEMTYPE_EMPTY_L_PAREN_R_PAREN:
      currentToken = jj_consume_token(ITEMTYPE_EMPTY_L_PAREN_R_PAREN);
      break;
    default:
      jj_la1[26] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        {if (true) return factory.createSequenceType(itemType, occurrenceIndicator, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[128]    KindTest    ::=    DocumentTest | ElementTest | AttributeTest | PITest | CommentTest | TextTest | AnyKindTest
[137]    PITest    ::=    <"processing-instruction" "("> (NCName | StringLiteral)? ")" 
[138]    DocumentTest    ::=    <"document-node" "("> ElementTest? ")" 
[139]    CommentTest    ::=    <"comment" "("> ")" 
[140]    TextTest    ::=    <"text" "("> ")" 
[141]    AnyKindTest    ::=    <"node" "("> ")" 
***************************************************************************************/
  final public XQueryExpression KindTest() throws ParseException, TypeException, XQueryException {
        XQueryExpression nodeType = null;
        String value = null;
        byte nodeKind = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOCUMENT_NODE_L_PAREN:
      currentToken = jj_consume_token(DOCUMENT_NODE_L_PAREN);
                                nodeKind = NodeKind.DOCUMENT;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT_L_PAREN:
      case KINDTEST_ELEMENT_L_PAREN:
        nodeType = ElementTest();
        break;
      default:
        jj_la1[27] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    case ELEMENT_L_PAREN:
    case KINDTEST_ELEMENT_L_PAREN:
      nodeType = ElementTest();
      break;
    case ATTRIBUTE_L_PAREN:
      nodeType = AttributeTest();
      break;
    case PROCESSING_INSTRUCTION_L_PAREN:
      currentToken = jj_consume_token(PROCESSING_INSTRUCTION_L_PAREN);
                                nodeKind = NodeKind.PI;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KINDTESTFORPI_NCNAME:
      case KINDTESTFORPI_StringLiteral:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KINDTESTFORPI_NCNAME:
          currentToken = jj_consume_token(KINDTESTFORPI_NCNAME);
                                        value = unquote(currentToken.image);
          break;
        case KINDTESTFORPI_StringLiteral:
          currentToken = jj_consume_token(KINDTESTFORPI_StringLiteral);
                                        value = currentToken.image;
          break;
        default:
          jj_la1[28] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(KINDTESTFORPI_R_PAREN);
      break;
    case COMMENT_L_PAREN:
      currentToken = jj_consume_token(COMMENT_L_PAREN);
                                nodeKind = NodeKind.COMMENT;
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    case TEXT_L_PAREN:
      currentToken = jj_consume_token(TEXT_L_PAREN);
                                nodeKind = NodeKind.TEXT;
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    case NODE_L_PAREN:
      currentToken = jj_consume_token(NODE_L_PAREN);
                                nodeKind = NodeKind.NODE;
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    default:
      jj_la1[30] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (nodeType != null)
                        {if (true) return nodeType;}
                try
                {
                        {if (true) return factory.createNodeTest(nodeKind, (value == null)?null:factory.createValueString(value, parentModule), parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[129]    ElementTest    ::=    "element" "(" ((SchemaContextPath ElementName)| (ElementNameOrWildcard ("," TypeNameOrWildcard "nillable"?)?))? ")" 
[131]    ElementName    ::=    QName 
[133]    TypeName    ::=    QName 
[134]    ElementNameOrWildcard    ::=    ElementName | "*" 
[136]    TypeNameOrWildcard    ::=    TypeName | "*" 
***************************************************************************************/
  final public XQueryExpression ElementTest() throws ParseException, TypeException, XQueryException {
        SchemaContextPath schemaContextPath = null;
        boolean nillable = false;
        QName elementQName = null;
        QName typeQName = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
      currentToken = jj_consume_token(ELEMENT_L_PAREN);
      break;
    case KINDTEST_ELEMENT_L_PAREN:
      currentToken = jj_consume_token(KINDTEST_ELEMENT_L_PAREN);
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_1(4)) {
      schemaContextPath = SchemaContextPath(false);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KINDTEST_STAR:
      case KINDTEST_QNAME:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KINDTEST_QNAME:
          currentToken = jj_consume_token(KINDTEST_QNAME);
          break;
        case KINDTEST_STAR:
          currentToken = jj_consume_token(KINDTEST_STAR);
          break;
        default:
          jj_la1[32] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                        elementQName = QName(currentToken.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CLOSEKINDTEST_COMMA:
          currentToken = jj_consume_token(CLOSEKINDTEST_COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KINDTEST_QNAME:
            currentToken = jj_consume_token(KINDTEST_QNAME);
            break;
          case KINDTEST_STAR:
            currentToken = jj_consume_token(KINDTEST_STAR);
            break;
          default:
            jj_la1[33] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                                typeQName = QName(currentToken.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case CLOSEKINDTEST_NILLABLE:
            currentToken = jj_consume_token(CLOSEKINDTEST_NILLABLE);
                                        nillable = true;
            break;
          default:
            jj_la1[34] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[35] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[36] = jj_gen;
        ;
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KINDTEST_R_PAREN:
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    case CLOSEKINDTEST_R_PAREN:
      currentToken = jj_consume_token(CLOSEKINDTEST_R_PAREN);
      break;
    default:
      jj_la1[37] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        {if (true) return factory.createElementTest(schemaContextPath, elementQName, typeQName, nillable, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[130]    AttributeTest    ::=    "attribute" "(" ((SchemaContextPath AttributeName)| (AttribNameOrWildcard ("," TypeNameOrWildcard)?))? ")" 
[132]    AttributeName    ::=    QName 
[133]    TypeName    ::=    QName 
[135]    AttribNameOrWildcard    ::=    AttributeName | "*" 
[136]    TypeNameOrWildcard    ::=    TypeName | "*" 
***************************************************************************************/
  final public XQueryExpression AttributeTest() throws ParseException, TypeException, XQueryException {
        SchemaContextPath schemaContextPath = null;
        QName elementQName = null;
        QName typeQName = null;
    currentToken = jj_consume_token(ATTRIBUTE_L_PAREN);
    if (jj_2_2(4)) {
      schemaContextPath = SchemaContextPath(false);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case KINDTEST_STAR:
      case KINDTEST_QNAME:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KINDTEST_QNAME:
          currentToken = jj_consume_token(KINDTEST_QNAME);
          break;
        case KINDTEST_STAR:
          currentToken = jj_consume_token(KINDTEST_STAR);
          break;
        default:
          jj_la1[38] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                        elementQName = QName(currentToken.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CLOSEKINDTEST_COMMA:
          currentToken = jj_consume_token(CLOSEKINDTEST_COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KINDTEST_QNAME:
            currentToken = jj_consume_token(KINDTEST_QNAME);
            break;
          case KINDTEST_STAR:
            currentToken = jj_consume_token(KINDTEST_STAR);
            break;
          default:
            jj_la1[39] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                                typeQName = QName(currentToken.image);
          break;
        default:
          jj_la1[40] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[41] = jj_gen;
        ;
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KINDTEST_R_PAREN:
      currentToken = jj_consume_token(KINDTEST_R_PAREN);
      break;
    case CLOSEKINDTEST_R_PAREN:
      currentToken = jj_consume_token(CLOSEKINDTEST_R_PAREN);
      break;
    default:
      jj_la1[42] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        {if (true) return factory.createAttributeTest(schemaContextPath, elementQName, typeQName, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[142]    SchemaContextPath    ::=    SchemaGlobalContext "/" (SchemaContextStep "/")*
[15]    SchemaContextStep    ::=    QName 
[14]    SchemaGlobalContext    ::=    QName | SchemaGlobalTypeName 
[13]    SchemaGlobalTypeName    ::=    "type" "(" QName ")" 
// changed LARS
[142]    SchemaContextPath    ::=    SchemaGlobalContext "/" (SchemaContextStep "/")* QName (in fact ElementName or AttributeName)
***************************************************************************************/
  final public SchemaContextPath SchemaContextPath(boolean attribute) throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList steps = new ArrayList();
        byte axis = Constants.NOAXIS;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case KINDTEST_QNAME:
      currentToken = jj_consume_token(KINDTEST_QNAME);
                                expression = QName(currentToken.image);
      break;
    case KINDTEST_TYPE_L_PAREN:
      currentToken = jj_consume_token(KINDTEST_TYPE_L_PAREN);
      currentToken = jj_consume_token(KINDTEST_QNAME);
                                        expression = QName(currentToken.image);
                                        axis = Constants.WITHTYPE;
      currentToken = jj_consume_token(CLOSEKINDTEST_R_PAREN);
      break;
    default:
      jj_la1[43] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        try {
                                steps.add(factory.createSchemaContextStep(axis, expression, parentModule));
                        } catch (TypeException te) {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CLOSEKINDTEST_SLASH:
      currentToken = jj_consume_token(CLOSEKINDTEST_SLASH);
      break;
    case KINDTEST_SLASH:
      currentToken = jj_consume_token(KINDTEST_SLASH);
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                axis = Constants.WITHAXIS;
    label_4:
    while (true) {
      if (jj_2_3(2)) {
        ;
      } else {
        break label_4;
      }
      currentToken = jj_consume_token(KINDTEST_QNAME);
                                expression = QName(currentToken.image);
                                try {
                                        steps.add(factory.createSchemaContextStep(axis, expression, parentModule));
                                } catch (TypeException te) {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CLOSEKINDTEST_SLASH:
        currentToken = jj_consume_token(CLOSEKINDTEST_SLASH);
        break;
      case KINDTEST_SLASH:
        currentToken = jj_consume_token(KINDTEST_SLASH);
        break;
      default:
        jj_la1[45] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    currentToken = jj_consume_token(KINDTEST_QNAME);
                        if (attribute)
                                axis = Constants.WITHATTAXIS;
                        expression = QName(currentToken.image);
                        try {
                                steps.add(factory.createSchemaContextStep(axis, expression, parentModule));
                        } catch (TypeException te) {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                try {
                        {if (true) return factory.createSchemaContextPath(steps, parentModule);}
                } catch (TypeException te) {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[143]    SchemaContextLoc    ::=    (SchemaContextPath? QName) | SchemaGlobalTypeName 
[13]    SchemaGlobalTypeName    ::=    "type" "(" QName ")" 
***************************************************************************************/
  final public SchemaContextPath SchemaContextLoc() throws ParseException, TypeException, XQueryException {
        SchemaContextPath scp = null;
        XQueryExpression expression = null;
    if (jj_2_4(2)) {
      scp = SchemaContextPath(false);
    } else {
      ;
    }
                {if (true) return scp;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[114]    EnclosedExpr    ::=    "{" Expr "}" 
***************************************************************************************/
//XQueryExpressionSequence EnclosedExpr() throws TypeException, XQueryException :
// change LARS 10/08/2003
  final public XQueryExpression EnclosedExpr(boolean forceSequence) throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_CONTENT_L_BRACE:
      currentToken = jj_consume_token(ELEMENT_CONTENT_L_BRACE);
      break;
    case L_BRACE:
      currentToken = jj_consume_token(L_BRACE);
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    expression = Expr(false);
    currentToken = jj_consume_token(R_BRACE);
                if (forceSequence && !(expression instanceof XQueryExpressionSequence))
                {
                        ArrayList sequence = new ArrayList(1);
                        sequence.add(expression);
                        try
                        {
                                expression = factory.createXQueryExpressionSequence(sequence, parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        //expression.setBrace(true);
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[40]    Expr    ::=    ExprSingle ("," ExprSingle)* 
***************************************************************************************/
  final public XQueryExpression Expr(boolean forceSequence) throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList sequence = new ArrayList(1);
    expression = ExprSingle();
                        sequence.add(expression);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_5;
      }
      currentToken = jj_consume_token(COMMA);
      expression = ExprSingle();
                                sequence.add(expression);
    }
                try
                {
                        if (forceSequence)
                        {
                                {if (true) return factory.createXQueryExpressionSequence(sequence, parentModule);}
                        }
                        if (sequence.size() > 1)
                        {
                                {if (true) return factory.createXQueryExpressionSequence(sequence, parentModule);}
                        }
                        else
                        {
                                {if (true) return expression;}
                        }
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
// support of sort by for regression purposes !!!
[41]    ExprSingle    ::=    FLWORExpr ( ( <"sortby" "("> | <"sort" "by" "("> ) SortSpecList ")" )* | QuantifiedExpr | TypeswitchExpr | IfExpr | OrExpr 
**************************************************************************************/
  final public XQueryExpression ExprSingle() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList tmpVect = null;
        ArrayList sortSpecList = new ArrayList(1);
        boolean oldInPredicate = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FOR_$:
    case LET_$:
      expression = FLWORExpr();
      if (jj_2_5(2)) {
        currentToken = jj_consume_token(SORTBY_L_PAREN);
                                                oldInPredicate = inPredicate;
                                                inPredicate = true;
        tmpVect = OrderSpecList();
                                                sortSpecList.addAll(tmpVect);
                                                inPredicate = oldInPredicate;
        currentToken = jj_consume_token(R_PAREN);
      } else {
        ;
      }
      break;
    case SOME_$:
    case EVERY_$:
      expression = QuantifiedExpr();
      break;
    case TYPESWITCH_L_PAREN:
      expression = TypeswitchExpr();
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". TypeswitchExpr is not supported yet.");}
      break;
    case IF_L_PAREN:
      expression = IfExpr();
      break;
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case QNAME_L_PAREN:
    case DOLLAR:
    case VALIDATE_L_BRACE:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = OrExpr();
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (!sortSpecList.isEmpty())
                {
                        try
                        {
                                {if (true) return factory.createSortedExpression(expression, sortSpecList, false, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[48]    OrderSpecList    ::=    OrderSpec ("," OrderSpec)* 
[49]    OrderSpec    ::=    ExprSingle OrderModifier 
***************************************************************************************/
  final public ArrayList OrderSpecList() throws ParseException, TypeException, XQueryException {
        ArrayList resVect = new ArrayList();
        ArrayList tmpVect = null;
        XQueryExpression expression = null;
        int[] order = {Constants.NOTHING, Constants.NOTHING};
    expression = ExprSingle();
    order = OrderModifier();
                        expression.setOrder(order);
                        resVect.add(expression);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      currentToken = jj_consume_token(COMMA);
      tmpVect = OrderSpecList();
                                resVect.addAll(tmpVect);
      break;
    default:
      jj_la1[49] = jj_gen;
      ;
    }
                {if (true) return resVect;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[50]    OrderModifier    ::=    ("ascending" | "descending")? (<"empty" "greatest"> | <"empty" "least">)? ("collation" StringLiteral)? 
***************************************************************************************/
  final public int[] OrderModifier() throws ParseException, TypeException, XQueryException {
        int[] order = {Constants.ASCENDING_ORDER, Constants.NOTHING};
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_ASCENDING:
    case OPERATOR_DESCENDING:
    case OPERATOR_PLACE_ORDER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_ASCENDING:
        currentToken = jj_consume_token(OPERATOR_ASCENDING);
                                order[0] = Constants.ASCENDING_ORDER;
        break;
      case OPERATOR_DESCENDING:
        currentToken = jj_consume_token(OPERATOR_DESCENDING);
                                order[0] = Constants.DESCENDING_ORDER;
        break;
      case OPERATOR_PLACE_ORDER:
        currentToken = jj_consume_token(OPERATOR_PLACE_ORDER);
                                order[0] = Constants.PLACE_ORDER;
        break;
      default:
        jj_la1[50] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[51] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_EMPTY_GREATEST:
    case OPERATOR_EMPTY_LEAST:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_EMPTY_GREATEST:
        currentToken = jj_consume_token(OPERATOR_EMPTY_GREATEST);
                                        order[1] = Constants.GREATEST_ORDER;
        break;
      case OPERATOR_EMPTY_LEAST:
        currentToken = jj_consume_token(OPERATOR_EMPTY_LEAST);
                                        order[1] = Constants.LEAST_ORDER;
        break;
      default:
        jj_la1[52] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Handling of empty sequence in SortModifier is not supported yet.");}
      break;
    default:
      jj_la1[53] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_COLLATION:
      currentToken = jj_consume_token(OPERATOR_COLLATION);
      currentToken = jj_consume_token(StringLiteral);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Handling of collation in SortModifier is not supported yet.");}
      break;
    default:
      jj_la1[54] = jj_gen;
      ;
    }
                {if (true) return order;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[42]    FLWORExpr    ::=    (ForClause | LetClause)+ WhereClause? OrderByClause? "return" ExprSingle 
***************************************************************************************/
  final public XQueryExpression FLWORExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression whereClause = null;
        XQueryExpression returnClause = null;
        ArrayList bindings = new ArrayList();
        ArrayList orderbys = null;
        ArrayList tmpVect = null;
        HintTree hintClause = null;
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FOR_$:
        tmpVect = ForClause();
        break;
      case LET_$:
        tmpVect = LetClause();
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                bindings.addAll(tmpVect);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FOR_$:
      case LET_$:
        ;
        break;
      default:
        jj_la1[56] = jj_gen;
        break label_6;
      }
    }
                        whereClause = null;
                        orderbys = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OUTER_MERGE:
    case OUTER_NESTED:
    case END_EXT_KEY:
    case MERGE:
    case CARTESIAN_PRODUCT:
    case JOIN:
    case NESTED_LOOP:
      hintClause = HintClause();
      break;
    default:
      jj_la1[57] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_WHERE:
      whereClause = WhereClause();
      break;
    default:
      jj_la1[58] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_ORDER_BY:
    case OPERATOR_STABLE_ORDER_BY:
      orderbys = OrderByClause();
      break;
    default:
      jj_la1[59] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(OPERATOR_RETURN);
    returnClause = ExprSingle();
                        for (int i = 0; i < bindings.size(); i++)
                        {
                                removeVarDefinition(((Variable) bindings.get(i)).getStringValue());
                        }
                        try
                        {
                                {if (true) return factory.createFLWRExpression(bindings, hintClause, whereClause, orderbys, returnClause, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[43]    ForClause    ::=    <"for" "$"> VarName TypeDeclaration? PositionalVar? "in" ExprSingle ("," "$" VarName TypeDeclaration? PositionalVar? "in" ExprSingle)* 
***************************************************************************************/
  final public ArrayList ForClause() throws ParseException, TypeException, XQueryException {
        boolean hasTypeDeclaration = false;
        XQueryExpression positionVar = null;
        SequenceType typeDeclaration = null;
        ArrayList vectVar = new ArrayList(1);
        Variable var = null;
        XQueryExpression expression = null;
    currentToken = jj_consume_token(FOR_$);
    currentToken = jj_consume_token(VARNAME_QNAME);
                        var = (Variable)VarName(currentToken.image);
                        vectVar.add(var);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_AS:
      TypeDeclaration();
                        hasTypeDeclaration = true;
      break;
    default:
      jj_la1[60] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AT:
      positionVar = PositionalVar();
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Positional Variable is not supported yet.");}
      break;
    default:
      jj_la1[61] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(OPERATOR_IN);
    expression = ExprSingle();
                        var.setBindingType(Constants.FOR_BINDINGTYPE);
                        var.setExpression(expression, true);
                        //if (staticcontext.getTypeVisitor() != null) var.accept(staticcontext.getTypeVisitor());
                        //addVarDefinition(var);

    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[62] = jj_gen;
        break label_7;
      }
      currentToken = jj_consume_token(COMMA);
                                hasTypeDeclaration = false;
                                positionVar = null;
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image);
                                vectVar.add(var);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_AS:
        TypeDeclaration();
                                hasTypeDeclaration = true;
        break;
      default:
        jj_la1[63] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AT:
        positionVar = PositionalVar();
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Positional Variable is not supported yet.");}
        break;
      default:
        jj_la1[64] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(OPERATOR_IN);
      expression = ExprSingle();
                                var.setBindingType(Constants.FOR_BINDINGTYPE);
                                var.setExpression(expression, true);
                                //if (staticcontext.getTypeVisitor() != null) var.accept(staticcontext.getTypeVisitor());
                                //addVarDefinition(var);

    }
                {if (true) return vectVar;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[44]    PositionalVar    ::=    "at" "$" VarName 
***************************************************************************************/
  final public XQueryExpression PositionalVar() throws ParseException, TypeException, XQueryException {
        XQueryExpression var = null;
    currentToken = jj_consume_token(AT);
    currentToken = jj_consume_token(DOLLAR);
    currentToken = jj_consume_token(VARNAME_QNAME);
                var = (Variable)VarName(currentToken.image,false);
                {if (true) return var;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[45]    LetClause    ::=    <"let" "$"> VarName TypeDeclaration? ":=" ExprSingle ("," "$" VarName TypeDeclaration? ":=" ExprSingle)* 
***************************************************************************************/
  final public ArrayList LetClause() throws ParseException, TypeException, XQueryException {
        boolean hasTypeDeclaration = false;
        SequenceType typeDeclaration = null;
        ArrayList vectVar = new ArrayList();
        Variable var = null;
        XQueryExpression expression = null;
    currentToken = jj_consume_token(LET_$);
    currentToken = jj_consume_token(VARNAME_QNAME);
                        var = (Variable)VarName(currentToken.image);
                        vectVar.add(var);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_AS:
      TypeDeclaration();
                        hasTypeDeclaration = true;
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(OPERATOR_COLON_EQUAL);
    expression = ExprSingle();
                        var.setBindingType(Constants.LET_BINDINGTYPE);
                        var.setExpression(expression, true);
                        //if (staticcontext.getTypeVisitor() != null) var.accept(staticcontext.getTypeVisitor());
                        //addVarDefinition(var);

    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[66] = jj_gen;
        break label_8;
      }
      currentToken = jj_consume_token(COMMA);
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image);
                                vectVar.add(var);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_AS:
        TypeDeclaration();
                                hasTypeDeclaration = true;
        break;
      default:
        jj_la1[67] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(OPERATOR_COLON_EQUAL);
      expression = ExprSingle();
                                var.setBindingType(Constants.LET_BINDINGTYPE);
                                var.setExpression(expression, true);
                                //if (staticcontext.getTypeVisitor() != null) var.accept(staticcontext.getTypeVisitor());
                                //addVarDefinition(var);

    }
                {if (true) return vectVar;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[46]    WhereClause    ::=    "where" Expr 
***************************************************************************************/
  final public XQueryExpression WhereClause() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(OPERATOR_WHERE);
    expression = ExprSingle();
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
ADDED LARS HintClause ::=						<"hint ("> NodeClause ")"
***************************************************************************************/
  final public HintTree HintClause() throws ParseException, TypeException, XQueryException {
        HintTree hintTree = null;
        byte outertype = HintTree.NO_TYPE;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OUTER_MERGE:
    case OUTER_NESTED:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OUTER_MERGE:
        currentToken = jj_consume_token(OUTER_MERGE);
                                outertype = HintTree.MERGE_TYPE;
        break;
      case OUTER_NESTED:
        currentToken = jj_consume_token(OUTER_NESTED);
                                outertype = HintTree.NESTED_TYPE;
        break;
      default:
        jj_la1[68] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[69] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MERGE:
    case CARTESIAN_PRODUCT:
    case JOIN:
    case NESTED_LOOP:
      hintTree = NodeClause();
      break;
    default:
      jj_la1[70] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(END_EXT_KEY);
                if (hintTree == null && outertype != HintTree.NO_TYPE) {
                        hintTree = factory.createHintTree(HintTree.NO_TYPE, HintTree.NO_SIDE, null, null);
                }
                if (hintTree != null) {
                        hintTree.setOuterType(outertype);
                }
                {if (true) return hintTree;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
ADDED LARS NodeClause ::=						( "merge" | "cartesian-product" | "join" | "nested-loop" ) "(" LeafClause "," LeafClause ")"
***************************************************************************************/
  final public HintTree NodeClause() throws ParseException, TypeException, XQueryException {
        Object left = null;
        Object right = null;
        byte type = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MERGE:
      currentToken = jj_consume_token(MERGE);
                                type = HintTree.MERGE_TYPE;
      break;
    case CARTESIAN_PRODUCT:
      currentToken = jj_consume_token(CARTESIAN_PRODUCT);
                                type = HintTree.CARTESIAN_PRODUCT_TYPE;
      break;
    case JOIN:
      currentToken = jj_consume_token(JOIN);
                                type = HintTree.JOIN_TYPE;
      break;
    case NESTED_LOOP:
      currentToken = jj_consume_token(NESTED_LOOP);
                                type = HintTree.NESTED_LOOP_TYPE;
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(HINT_L_PAREN);
    left = LeafClause();
    currentToken = jj_consume_token(HINT_COMMA);
    right = LeafClause();
    currentToken = jj_consume_token(HINT_R_PAREN);
                {if (true) return factory.createHintTree(type, HintTree.NO_SIDE, left, right);}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
ADDED LARS LeafClause ::=						NodeClause | VAR
***************************************************************************************/
  final public Object LeafClause() throws ParseException, TypeException, XQueryException {
        Object leaf = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MERGE:
    case CARTESIAN_PRODUCT:
    case JOIN:
    case NESTED_LOOP:
      leaf = NodeClause();
      break;
    case HINT_DOLLAR:
      currentToken = jj_consume_token(HINT_DOLLAR);
      currentToken = jj_consume_token(HINT_QNAME);
                                leaf = (Variable)VarName(currentToken.image,false);
      break;
    default:
      jj_la1[72] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return leaf;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[47]    OrderByClause    ::=    (<"order" "by"> | <"stable" "order" "by">) OrderSpecList 
***************************************************************************************/
  final public ArrayList OrderByClause() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        boolean stable = false;
        ArrayList tmpVect = null;
        ArrayList sortSpecList = new ArrayList(1);
        boolean oldInPredicate = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_ORDER_BY:
      currentToken = jj_consume_token(OPERATOR_ORDER_BY);
      break;
    case OPERATOR_STABLE_ORDER_BY:
      currentToken = jj_consume_token(OPERATOR_STABLE_ORDER_BY);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". \"stable\" in SortExpr is not supported yet.");}
                                stable = true;
      break;
    default:
      jj_la1[73] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        oldInPredicate = inPredicate;
                        inPredicate = true;
    tmpVect = OrderSpecList();
                        sortSpecList.addAll(tmpVect);
                        inPredicate = oldInPredicate;
                {if (true) return sortSpecList;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[51]    QuantifiedExpr    ::=    (<"some" "$"> | <"every" "$">) VarName TypeDeclaration? "in" ExprSingle ("," "$" VarName TypeDeclaration? "in" ExprSingle)* "satisfies" ExprSingle 
***************************************************************************************/
  final public XQueryExpression QuantifiedExpr() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
        Variable var = null;
        ArrayList varlist = new ArrayList();
        XQueryExpression expression = null;
        XQueryExpression satisfies = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SOME_$:
      currentToken = jj_consume_token(SOME_$);
                                kind = Constants.SOME_QUANTIFIER;
      break;
    case EVERY_$:
      currentToken = jj_consume_token(EVERY_$);
                                kind = Constants.EVERY_QUANTIFIER;
      break;
    default:
      jj_la1[74] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image);
    currentToken = jj_consume_token(OPERATOR_IN);
    expression = ExprSingle();
                                var.setBindingType(Constants.QUANTIFIER_BINDINGTYPE);
                                var.setExpression(expression, true);
                                //if (staticcontext.getTypeVisitor() != null)	var.accept(staticcontext.getTypeVisitor());
                                //addVarDefinition(var);
                                varlist.add(var);
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[75] = jj_gen;
        break label_9;
      }
      currentToken = jj_consume_token(COMMA);
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image);
      currentToken = jj_consume_token(OPERATOR_IN);
      expression = ExprSingle();
                                        var.setBindingType(Constants.QUANTIFIER_BINDINGTYPE);
                                        var.setExpression(expression, true);
                                        //if (staticcontext.getTypeVisitor() != null)	var.accept(staticcontext.getTypeVisitor());
                                        //addVarDefinition(var);
                                        varlist.add(var);
    }
    currentToken = jj_consume_token(OPERATOR_SATISFIES);
    satisfies = ExprSingle();
                        for (int i=0;i<varlist.size();i++)
                        {
                                removeVarDefinition(((Variable)varlist.get(i)).getStringValue());
                        }
                        try
                        {
                                {if (true) return factory.createQuantifiedExpression(kind, varlist, satisfies, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[52]    TypeswitchExpr    ::=    <"typeswitch" "("> Expr ")" CaseClause+ "default" ("$" VarName)? "return" ExprSingle 
LARS --> [52]    TypeswitchExpr    ::=    <"typeswitch" "("> ExprSingle ")" CaseClause+ "default" ("$" VarName)? "return" ExprSingle 
***************************************************************************************/
  final public XQueryExpression TypeswitchExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression switchExpression = null;
        CaseClauseExpression caseClause = null;
        XQueryExpression returnClause = null;
        HashMap cases = new HashMap();
        XQueryExpression var = null;
    currentToken = jj_consume_token(TYPESWITCH_L_PAREN);
    switchExpression = ExprSingle();
    currentToken = jj_consume_token(R_PAREN);
    label_10:
    while (true) {
      caseClause = CaseClause();
                                cases.put(caseClause.getSequenceType(), caseClause);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_CASE:
        ;
        break;
      default:
        jj_la1[76] = jj_gen;
        break label_10;
      }
    }
    currentToken = jj_consume_token(OPERATOR_DEFAULT);
                        var = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOLLAR:
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image,false);
      break;
    default:
      jj_la1[77] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(OPERATOR_RETURN);
    returnClause = ExprSingle();
                        try
                        {
                                if (var != null)
                                {
                                        {if (true) return factory.createTypeSwitchExpression(switchExpression, cases, (Variable)var, returnClause, parentModule);}
                                }
                                else
                                {
                                        {if (true) return factory.createTypeSwitchExpression(switchExpression, cases, null, returnClause, parentModule);}
                                }
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[53]    CaseClause    ::=    "case" ("$" VarName "as")? SequenceType "return" ExprSingle 
***************************************************************************************/
  final public CaseClauseExpression CaseClause() throws ParseException, TypeException, XQueryException {
        XQueryExpression var = null;
        SequenceType sequenceType = null;
        XQueryExpression returnExpression = null;
    currentToken = jj_consume_token(OPERATOR_CASE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOLLAR:
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                var = (Variable)VarName(currentToken.image);
                                var.setTypeDeclaration(sequenceType);
                                if (staticcontext.getTypeVisitor() != null)     var.accept(staticcontext.getTypeVisitor());
      currentToken = jj_consume_token(OPERATOR_AS);
      break;
    default:
      jj_la1[78] = jj_gen;
      ;
    }
    sequenceType = SequenceType();
    currentToken = jj_consume_token(OPERATOR_RETURN);
    returnExpression = ExprSingle();
                try
                {
                        if (var == null)
                        {
                                {if (true) return factory.createCaseClauseExpression(sequenceType, null, returnExpression, parentModule);}
                        }
                        else
                        {
                                removeVarDefinition(var.getStringValue());
                                {if (true) return factory.createCaseClauseExpression(null, (Variable)var, returnExpression, parentModule);}
                        }
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[54]    IfExpr    ::=    <"if" "("> Expr ")" "then" ExprSingle "else" ExprSingle 
***************************************************************************************/
  final public XQueryExpression IfExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression ifClause = null;
        XQueryExpression thenClause = null;
        XQueryExpression elseClause = null;
    currentToken = jj_consume_token(IF_L_PAREN);
    ifClause = ExprSingle();
    currentToken = jj_consume_token(R_PAREN);
    currentToken = jj_consume_token(OPERATOR_THEN);
    thenClause = ExprSingle();
    currentToken = jj_consume_token(OPERATOR_ELSE);
    elseClause = ExprSingle();
                        try
                        {
                                {if (true) return factory.createITEExpression(ifClause, thenClause, elseClause, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[55]    OrExpr    ::=    AndExpr ( "or" AndExpr )* 
***************************************************************************************/
  final public XQueryExpression OrExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        BinOpORExpression binOpORExpression = null;
    mainExpression = AndExpr();
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_OR:
        ;
        break;
      default:
        jj_la1[79] = jj_gen;
        break label_11;
      }
      currentToken = jj_consume_token(OPERATOR_OR);
      expression = AndExpr();
                                try
                                {
                                        binOpORExpression = factory.createBinOpORExpression(mainExpression, expression, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = binOpORExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[56]    AndExpr    ::=    InstanceofExpr ( "and" InstanceofExpr )* 
***************************************************************************************/
  final public XQueryExpression AndExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        BinOpANDExpression binOpANDExpression = null;
    mainExpression = InstanceofExpr();
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_AND:
        ;
        break;
      default:
        jj_la1[80] = jj_gen;
        break label_12;
      }
      currentToken = jj_consume_token(OPERATOR_AND);
      expression = InstanceofExpr();
                                try
                                {
                                        binOpANDExpression = factory.createBinOpANDExpression(mainExpression, expression, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = binOpANDExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[57]    InstanceofExpr    ::=    TreatExpr ( <"instance" "of"> SequenceType )? 
***************************************************************************************/
  final public XQueryExpression InstanceofExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        SequenceType sequenceType = null;
    expression = TreatExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_INSTANCE_OF:
      currentToken = jj_consume_token(OPERATOR_INSTANCE_OF);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". InstanceOfExpr is not supported yet.");}
      sequenceType = SequenceType();
                                try
                                {
                                        expression = factory.createInstanceOfExpression(expression, sequenceType, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[81] = jj_gen;
      ;
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[58]    TreatExpr    ::=    CastableExpr ( <"treat" "as"> SequenceType )? 
***************************************************************************************/
  final public XQueryExpression TreatExpr() throws ParseException, TypeException, XQueryException {
        SequenceType sequenceType = null;
        XQueryExpression expression = null;
    expression = CastableExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_TREAT_AS:
      currentToken = jj_consume_token(OPERATOR_TREAT_AS);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". TreatExpr is not supported yet.");}
      sequenceType = SequenceType();
                                try
                                {
                                        {if (true) return factory.createCastTreatExpression(Constants.TREAT_TYPING, sequenceType, expression, parentModule);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[82] = jj_gen;
      ;
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[59]    CastableExpr    ::=    CastExpr ( <"castable" "as"> SingleType )? 
[124]    SingleType    ::=    AtomicType "?"? 
[126]    AtomicType    ::=    QName 
***************************************************************************************/
  final public XQueryExpression CastableExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        XQueryExpression qname = null;
    expression = CastExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_CASTABLE_AS:
      currentToken = jj_consume_token(OPERATOR_CASTABLE_AS);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". CastableExpr is not supported yet.");}
      currentToken = jj_consume_token(QNAME);
                                qname = QName(currentToken.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_QUESTION_MARK:
        currentToken = jj_consume_token(OPERATOR_QUESTION_MARK);
        break;
      default:
        jj_la1[83] = jj_gen;
        ;
      }
                                try
                                {
                                        {if (true) return factory.createCastTreatExpression(Constants.CAST_TYPING, null, expression, parentModule);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[84] = jj_gen;
      ;
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[60]    CastExpr    ::=    ComparisonExpr ( <"cast" "as"> SingleType )? 
[124]    SingleType    ::=    AtomicType "?"? 
[126]    AtomicType    ::=    QName 
***************************************************************************************/
  final public XQueryExpression CastExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        XQueryExpression qname = null;
    expression = ComparisonExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_CAST_AS:
      currentToken = jj_consume_token(OPERATOR_CAST_AS);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". CastExpr is not supported yet.");}
      currentToken = jj_consume_token(ITEMTYPE_QNAME);
                                qname = QName(currentToken.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_QUESTION_MARK:
        currentToken = jj_consume_token(OPERATOR_QUESTION_MARK);
        break;
      default:
        jj_la1[85] = jj_gen;
        ;
      }
                                try
                                {
                                        {if (true) return factory.createCastTreatExpression(Constants.CAST_TYPING, null, expression, parentModule);}
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[86] = jj_gen;
      ;
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[61]    ComparisonExpr    ::=    RangeExpr ( (ValueComp | GeneralComp | NodeComp) RangeExpr )? 
**************************************************************************************/
  final public XQueryExpression ComparisonExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        int kind = Constants.NOTHING;
    mainExpression = RangeExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_EQUAL:
    case OPERATOR_EQ:
    case OPERATOR_GE:
    case OPERATOR_GT:
    case OPERATOR_LE:
    case OPERATOR_LT:
    case OPERATOR_NE:
    case OPERATOR_GREATER_EQUAL:
    case OPERATOR_GREATER_GREATER:
    case OPERATOR_GREATER:
    case OPERATOR_IS:
    case OPERATOR_LESS_EQUAL:
    case OPERATOR_LESS_LESS:
    case OPERATOR_LESS:
    case OPERATOR_NOT_EQUAL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_EQ:
      case OPERATOR_GE:
      case OPERATOR_GT:
      case OPERATOR_LE:
      case OPERATOR_LT:
      case OPERATOR_NE:
        kind = ValueComp();
        break;
      case OPERATOR_EQUAL:
      case OPERATOR_GREATER_EQUAL:
      case OPERATOR_GREATER:
      case OPERATOR_LESS_EQUAL:
      case OPERATOR_LESS:
      case OPERATOR_NOT_EQUAL:
        kind = GeneralComp();
        break;
      case OPERATOR_GREATER_GREATER:
      case OPERATOR_IS:
      case OPERATOR_LESS_LESS:
        kind = NodeComp();
                                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Node comparison is not supported yet.");}
        break;
      default:
        jj_la1[87] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = RangeExpr();
      break;
    default:
      jj_la1[88] = jj_gen;
      ;
    }
                if (kind != Constants.NOTHING)
                {
                        try
                        {
                                {if (true) return factory.createListOpCompExpression(mainExpression, expression, kind, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[82]    GeneralComp    ::=    "=" | "!=" | "<" | "<=" | ">" | ">=" // gn: lt
**************************************************************************************/
  final public int GeneralComp() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_EQUAL:
      currentToken = jj_consume_token(OPERATOR_EQUAL);
                        kind = Constants.EQ_COMPOP;
      break;
    case OPERATOR_NOT_EQUAL:
      currentToken = jj_consume_token(OPERATOR_NOT_EQUAL);
                        kind = Constants.NEQ_COMPOP;
      break;
    case OPERATOR_LESS:
      currentToken = jj_consume_token(OPERATOR_LESS);
                        kind = Constants.LT_COMPOP;
      break;
    case OPERATOR_LESS_EQUAL:
      currentToken = jj_consume_token(OPERATOR_LESS_EQUAL);
                        kind = Constants.LEQ_COMPOP;
      break;
    case OPERATOR_GREATER:
      currentToken = jj_consume_token(OPERATOR_GREATER);
                        kind = Constants.GT_COMPOP;
      break;
    case OPERATOR_GREATER_EQUAL:
      currentToken = jj_consume_token(OPERATOR_GREATER_EQUAL);
                        kind = Constants.GEQ_COMPOP;
      break;
    default:
      jj_la1[89] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[83]    ValueComp    ::=    "eq" | "ne" | "lt" | "le" | "gt" | "ge" 
**************************************************************************************/
  final public int ValueComp() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_EQ:
      currentToken = jj_consume_token(OPERATOR_EQ);
                        kind = Constants.EQ_VALUECOMP;
      break;
    case OPERATOR_NE:
      currentToken = jj_consume_token(OPERATOR_NE);
                        kind = Constants.NE_VALUECOMP;
      break;
    case OPERATOR_LT:
      currentToken = jj_consume_token(OPERATOR_LT);
                        kind = Constants.LT_VALUECOMP;
      break;
    case OPERATOR_LE:
      currentToken = jj_consume_token(OPERATOR_LE);
                        kind = Constants.LE_VALUECOMP;
      break;
    case OPERATOR_GT:
      currentToken = jj_consume_token(OPERATOR_GT);
                        kind = Constants.GT_VALUECOMP;
      break;
    case OPERATOR_GE:
      currentToken = jj_consume_token(OPERATOR_GE);
                        kind = Constants.GE_VALUECOMP;
      break;
    default:
      jj_la1[90] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[84]    NodeComp    ::=    "is" | "<<" | ">>" 
**************************************************************************************/
  final public int NodeComp() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_IS:
      currentToken = jj_consume_token(OPERATOR_IS);
                        kind = Constants.IS_NODECOMP;
      break;
    case OPERATOR_LESS_LESS:
      currentToken = jj_consume_token(OPERATOR_LESS_LESS);
                        kind = Constants.LEAST_NODECOMP;
      break;
    case OPERATOR_GREATER_GREATER:
      currentToken = jj_consume_token(OPERATOR_GREATER_GREATER);
                        kind = Constants.GREATEST_NODECOMP;
      break;
    default:
      jj_la1[91] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return kind;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[62]    RangeExpr    ::=    AdditiveExpr ( "to" AdditiveExpr )? 
**************************************************************************************/
  final public XQueryExpression RangeExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        XQueryExpression rangeExpr = null;
    mainExpression = AdditiveExpr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPERATOR_TO:
      currentToken = jj_consume_token(OPERATOR_TO);
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". RangeExpr is not supported yet.");}
      expression = AdditiveExpr();
                                try
                                {
                                        rangeExpr = factory.createRangeExpression(mainExpression, expression, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = rangeExpr;
      break;
    default:
      jj_la1[92] = jj_gen;
      ;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[63]    AdditiveExpr    ::=    MultiplicativeExpr ( ("+" | "-") MultiplicativeExpr )* 
**************************************************************************************/
  final public XQueryExpression AdditiveExpr() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpArithExpression listOpArithExpression = null;
    mainExpression = MultiplicativeExpr();
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case PLUS:
        ;
        break;
      default:
        jj_la1[93] = jj_gen;
        break label_13;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        currentToken = jj_consume_token(PLUS);
                                        kind = Constants.PLUS_ARITHMETICS;
        break;
      case MINUS:
        currentToken = jj_consume_token(MINUS);
                                        kind = Constants.MINUS_ARITHMETICS;
        break;
      default:
        jj_la1[94] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = MultiplicativeExpr();
                                try
                                {
                                        listOpArithExpression = factory.createListOpArithExpression(mainExpression, expression, kind, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpArithExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[64]    MultiplicativeExpr    ::=    UnaryExpr ( ("*" | "div" | "idiv" | "mod") UnaryExpr )* 
**************************************************************************************/
  final public XQueryExpression MultiplicativeExpr() throws ParseException, TypeException, XQueryException {
        int kind = Constants.NOTHING;
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpArithExpression listOpArithExpression = null;
    mainExpression = UnaryExpr();
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_DIV:
      case OPERATOR_IDIV:
      case OPERATOR_MOD:
      case OPERATOR_STAR:
        ;
        break;
      default:
        jj_la1[95] = jj_gen;
        break label_14;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_STAR:
        currentToken = jj_consume_token(OPERATOR_STAR);
                                        kind = Constants.MULTIPLY_ARITHMETICS;
        break;
      case OPERATOR_DIV:
        currentToken = jj_consume_token(OPERATOR_DIV);
                                        kind = Constants.DIVIDE_ARITHMETICS;
        break;
      case OPERATOR_IDIV:
        currentToken = jj_consume_token(OPERATOR_IDIV);
                                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". Integer division is not supported yet.");}
                                        kind = Constants.INTEGER_DIVIDE_ARITHMETICS;
        break;
      case OPERATOR_MOD:
        currentToken = jj_consume_token(OPERATOR_MOD);
                                        kind = Constants.MODULO_ARITHMETICS;
        break;
      default:
        jj_la1[96] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expression = UnaryExpr();
                                try
                                {
                                        listOpArithExpression = factory.createListOpArithExpression(mainExpression, expression, kind, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpArithExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[65]    UnaryExpr    ::=    ("-" | "+")* UnionExpr 
**************************************************************************************/
  final public XQueryExpression UnaryExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        boolean minus = false;
        boolean hasSign = false;
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case PLUS:
        ;
        break;
      default:
        jj_la1[97] = jj_gen;
        break label_15;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
        currentToken = jj_consume_token(MINUS);
                                hasSign = true;
                                minus = true;
        break;
      case PLUS:
        currentToken = jj_consume_token(PLUS);
                                hasSign = true;
        break;
      default:
        jj_la1[98] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    expression = UnionExpr();
                if (hasSign)
                {
                        try
                        {
                                {if (true) return factory.createUnOpMinusExpression(expression, minus, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[66]    UnionExpr    ::=    IntersectExceptExpr ( ("union" | "|") IntersectExceptExpr )* 
**************************************************************************************/
  final public XQueryExpression UnionExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        ListOpUNIONExpression listOpUNIONExpression = null;
    mainExpression = IntersectExceptExpr();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_UNION:
      case OPERATOR_BAR:
        ;
        break;
      default:
        jj_la1[99] = jj_gen;
        break label_16;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_UNION:
        currentToken = jj_consume_token(OPERATOR_UNION);
        break;
      case OPERATOR_BAR:
        currentToken = jj_consume_token(OPERATOR_BAR);
        break;
      default:
        jj_la1[100] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". UnionExpr is not supported yet.");}
      expression = IntersectExceptExpr();
                                try
                                {
                                        listOpUNIONExpression = factory.createListOpUNIONExpression(mainExpression, expression, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = listOpUNIONExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[67]    IntersectExceptExpr    ::=    ValueExpr ( ("intersect" | "except") ValueExpr )* 
**************************************************************************************/
  final public XQueryExpression IntersectExceptExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression mainExpression = null;
        XQueryExpression expression = null;
        XQueryExpression resultExpression = null;
        boolean kind = false;
    mainExpression = ValueExpr();
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_EXCEPT:
      case OPERATOR_INTERSECT:
        ;
        break;
      default:
        jj_la1[101] = jj_gen;
        break label_17;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPERATOR_INTERSECT:
        currentToken = jj_consume_token(OPERATOR_INTERSECT);
                                        kind = true;
        break;
      case OPERATOR_EXCEPT:
        currentToken = jj_consume_token(OPERATOR_EXCEPT);
        break;
      default:
        jj_la1[102] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". IntersectExceptExpr is not supported yet.");}
      expression = ValueExpr();
                                try
                                {
                                        if (kind)
                                        {
                                                resultExpression = factory.createListOpINTERSECTExpression(mainExpression, expression, parentModule);
                                        }
                                        else
                                        {
                                                resultExpression = factory.createListOpEXCEPTExpression(mainExpression, expression, parentModule);
                                        }
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
                                mainExpression = resultExpression;
    }
                {if (true) return mainExpression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[68]    ValueExpr    ::=    ValidateExpr | PathExpr
**************************************************************************************/
  final public XQueryExpression ValueExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case VALIDATE_L_BRACE:
      expression = ValidateExpr();
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". ValidateExpr is not supported yet.");}
      break;
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case QNAME_L_PAREN:
    case DOLLAR:
    case L_PAREN:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = PathExpr();
      break;
    default:
      jj_la1[103] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[78]    ValidateExpr    ::=    (<"validate" "{"> | (<"validate" "global"> "{") | (<"validate" "context"> SchemaContextLoc "{") | (<"validate" SchemaMode> SchemaContext? "{")) Expr "}" 
[79]    SchemaContext    ::=    ("context" SchemaContextLoc) | "global" 
**************************************************************************************/
  final public XQueryExpression ValidateExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression schemaContext = null;
        XQueryExpression validateExpression = null;
        SchemaContextPath scp = null;
        int validation_type = Constants.NOTHING;
        int scope_type = Constants.NOTHING;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VALIDATE_L_BRACE:
      currentToken = jj_consume_token(VALIDATE_L_BRACE);
      break;
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VALIDATE_GLOBAL:
        currentToken = jj_consume_token(VALIDATE_GLOBAL);
                                                scope_type = Constants.SCOPE_GLOBAL;
        break;
      case VALIDATE_CONTEXT:
        currentToken = jj_consume_token(VALIDATE_CONTEXT);
                                                        scope_type = Constants.SCOPE_CONTEXT;
        scp = SchemaContextLoc();
        break;
      case VALIDATE_LAX:
      case VALIDATE_STRICT:
      case VALIDATE_SKIP:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case VALIDATE_LAX:
          currentToken = jj_consume_token(VALIDATE_LAX);
                                                                validation_type = Constants.VALIDATION_LAX;
          break;
        case VALIDATE_STRICT:
          currentToken = jj_consume_token(VALIDATE_STRICT);
                                                                validation_type = Constants.VALIDATION_STRICT;
          break;
        case VALIDATE_SKIP:
          currentToken = jj_consume_token(VALIDATE_SKIP);
                                                                validation_type = Constants.VALIDATION_SKIP;
          break;
        default:
          jj_la1[104] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        SchemaMode();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case KINDTEST_CONTEXT:
        case KINDTEST_GLOBAL:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case KINDTEST_CONTEXT:
            jj_consume_token(KINDTEST_CONTEXT);
                                                                        scope_type = Constants.SCOPE_CONTEXT;
            scp = SchemaContextLoc();
            break;
          case KINDTEST_GLOBAL:
            jj_consume_token(KINDTEST_GLOBAL);
                                                                scope_type = Constants.SCOPE_GLOBAL;
            break;
          default:
            jj_la1[105] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[106] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[107] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      currentToken = jj_consume_token(L_BRACE);
      break;
    default:
      jj_la1[108] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    validateExpression = Expr(false);
    currentToken = jj_consume_token(R_BRACE);
                try
                {
                        {if (true) return factory.createValidateExpression(scope_type, validation_type, scp, validateExpression, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[69]    PathExpr    ::=    ("/" RelativePathExpr?) | ("//" RelativePathExpr) | RelativePathExpr
**************************************************************************************/
  final public XQueryExpression PathExpr() throws ParseException, TypeException, XQueryException {
        boolean separator = false;
        Step step = null;
        NodeTest nodeType = null;
        ArrayList tmpSteps = null;
        ArrayList resSteps = new ArrayList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SLASH:
      currentToken = jj_consume_token(SLASH);
                                separator = true;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT_L_PAREN:
      case ATTRIBUTE_L_PAREN:
      case COMMENT_L_PAREN:
      case TEXT_L_PAREN:
      case NODE_L_PAREN:
      case DOCUMENT_NODE_L_PAREN:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case STAR:
      case XMLCOMMENT_START:
      case XMLPROCESSING_START:
      case CDATA_START:
      case TAG_START:
      case ELEMENT_QNAME_L_BRACE:
      case ELEMENT_L_BRACE:
      case ATTRIBUTE_L_BRACE:
      case ATTRIBUTE_QNAME_L_BRACE:
      case NAMESPACE_NCNAME_L_BRACE:
      case DOCUMENT_L_BRACE:
      case TEXT_L_BRACE:
      case PROCESSING_INSTRUCTION_L_BRACE:
      case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
      case COMMENT_L_BRACE:
      case AROBASE:
      case ANCESTOR_OR_SELF_DCOLON:
      case ANCESTOR_DCOLON:
      case ATTRIBUTE_DCOLON:
      case CHILD_DCOLON:
      case DESCENDANT_SELF_DCOLON:
      case DESCENDANT_DCOLON:
      case FOLLOWING_SIBLING_DCOLON:
      case FOLLOWING_DCOLON:
      case PARENT_DCOLON:
      case PRECEDING_SIBLING_DCOLON:
      case PRECEDING_DCOLON:
      case SELF_DCOLON:
      case QNAME_L_PAREN:
      case DOLLAR:
      case L_PAREN:
      case DecimalLiteral:
      case DOTDOT:
      case DOT:
      case DoubleLiteral:
      case IntegerLiteral:
      case NCNAME_STAR:
      case STAR_NCNAME:
      case StringLiteral:
      case QNAME:
      case KINDTEST_ELEMENT_L_PAREN:
      case ELEMENT_CONTENT_ELT_LESS:
      case ELEMENT_CONTENT_XMLCOMMENT_START:
      case ELEMENT_CONTENT_XMLPROCESSING_START:
      case ELEMENT_CONTENT_CDATA_START:
        tmpSteps = RelativePathExpr(separator);
                                        if (tmpSteps != null) resSteps.addAll(tmpSteps);
        break;
      default:
        jj_la1[109] = jj_gen;
        ;
      }
                                if (tmpSteps == null)
                                {
                                        try
                                        {
                                                nodeType = factory.createNodeTest(NodeKind.NODE, null, parentModule);
                                                step = factory.createStep(separator, Axis.CHILD, nodeType, null, parentModule);
                                                resSteps.add(step);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
                                }
      break;
    case SLASH_SLASH:
      currentToken = jj_consume_token(SLASH_SLASH);
                                separator = true;
                                try
                                {
                                        nodeType = factory.createNodeTest(NodeKind.NODE, null, parentModule);
                                        step = factory.createStep(separator, Axis.DESCENDANT_OR_SELF, nodeType, null, parentModule);
                                        resSteps.add(step);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      tmpSteps = RelativePathExpr(separator);
                                resSteps.addAll(tmpSteps);
      break;
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case QNAME_L_PAREN:
    case DOLLAR:
    case L_PAREN:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      tmpSteps = RelativePathExpr(false);
                                separator = false;
                                resSteps.addAll(tmpSteps);
      break;
    default:
      jj_la1[110] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                XQueryExpression expr = (XQueryExpression) resSteps.get(0);
                if (resSteps.size() == 1 && !(expr instanceof Step))
                        {if (true) return expr;}
                if (resSteps.size() != 1 && !(expr instanceof Step)) {
                        resSteps.set(0,factory.createStep(separator, Axis.NONE, expr, null, parentModule));
                }
                /*
		if (!step.hasSeparator() && step.getAxis() == Axis.NONE && step.getPredicates() == null)
			{
				// remove step from parent !!!
				step.getExpression().getParentExpression().remove(step);
				return step.getExpression();
			}
		}
		*/
                try {
                        if (LocatedExpressionReducer.simplifySteps(resSteps, inPredicate, parentModule) == 0)
                                {if (true) throw new TypeException("steps of LocatedExpression are not valid", currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (NormalizeException ne) {
                        {if (true) throw new TypeException(ne.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
                try
                {
                        {if (true) return factory.createLocatedExpression(resSteps, inPredicate, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[70]    RelativePathExpr    ::=    StepExpr (("/" | "//") StepExpr)* 
**************************************************************************************/
  final public ArrayList RelativePathExpr(boolean separator) throws ParseException, TypeException, XQueryException {
        XQueryExpression step = null;
        ArrayList steps = new ArrayList();
        NodeTest nodeType = null;
    step = StepExpr(separator, true);
                                steps.add(step);
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH_SLASH:
      case SLASH:
        ;
        break;
      default:
        jj_la1[111] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH:
        currentToken = jj_consume_token(SLASH);
                                        separator = true;
        break;
      case SLASH_SLASH:
        currentToken = jj_consume_token(SLASH_SLASH);
                                        separator = true;
                                        try
                                        {
                                                nodeType = factory.createNodeTest(NodeKind.NODE, null, parentModule);
                                                step = factory.createStep(separator, Axis.DESCENDANT_OR_SELF, nodeType, null, parentModule);
                                                steps.add(step);
                                        }
                                        catch (TypeException te)
                                        {
                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                        }
        break;
      default:
        jj_la1[112] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      step = StepExpr(separator, false);
                                steps.add(step);
    }
                {if (true) return steps;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[71]    StepExpr    ::=    AxisStep | FilterStep 
[72]    AxisStep    ::=    (ForwardStep | ReverseStep) Predicates 
[73]    FilterStep    ::=    PrimaryExpr Predicates 

**************************************************************************************/
  final public XQueryExpression StepExpr(boolean separator, boolean isFirst) throws ParseException, TypeException, XQueryException {
        XQueryExpression step = null;
        ArrayList predicates = new ArrayList();
    if (jj_2_6(4)) {
      step = PrimaryExpr(isFirst);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT_L_PAREN:
      case ATTRIBUTE_L_PAREN:
      case COMMENT_L_PAREN:
      case TEXT_L_PAREN:
      case NODE_L_PAREN:
      case DOCUMENT_NODE_L_PAREN:
      case PROCESSING_INSTRUCTION_L_PAREN:
      case STAR:
      case AROBASE:
      case ATTRIBUTE_DCOLON:
      case CHILD_DCOLON:
      case DESCENDANT_SELF_DCOLON:
      case DESCENDANT_DCOLON:
      case FOLLOWING_SIBLING_DCOLON:
      case FOLLOWING_DCOLON:
      case SELF_DCOLON:
      case NCNAME_STAR:
      case STAR_NCNAME:
      case QNAME:
      case KINDTEST_ELEMENT_L_PAREN:
        step = ForwardStep(separator);
        break;
      case ANCESTOR_OR_SELF_DCOLON:
      case ANCESTOR_DCOLON:
      case PARENT_DCOLON:
      case PRECEDING_SIBLING_DCOLON:
      case PRECEDING_DCOLON:
      case DOTDOT:
        step = ReverseStep(separator);
        break;
      default:
        jj_la1[113] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    predicates = Predicates();
                if (predicates != null)
                {
                        if (!(step instanceof Step))
                                step = factory.createStep(separator, Axis.NONE, step, predicates, parentModule);
                        else
                                ((Step)step).setPredicates(predicates);
                        if (staticcontext.getTypeVisitor() != null) step.accept(staticcontext.getTypeVisitor());
                }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[75]    PrimaryExpr    ::=    Literal | VarRef | ParenthesizedExpr | ContextItemExpr | FunctionCall | Constructor 
[74]    ContextItemExpr    ::=    "." 
[76]    VarRef    ::=    "$" VarName 
**************************************************************************************/
  final public XQueryExpression PrimaryExpr(boolean isFirst) throws ParseException, TypeException, XQueryException {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
        boolean separator = true;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DecimalLiteral:
    case DoubleLiteral:
    case IntegerLiteral:
    case StringLiteral:
      expression = Literal();
      break;
    case DOLLAR:
      currentToken = jj_consume_token(DOLLAR);
      currentToken = jj_consume_token(VARNAME_QNAME);
                                expression = VarName(currentToken.image,false);
      break;
    case L_PAREN:
      expression = ParenthesizedExpr();
      break;
    case DOT:
      currentToken = jj_consume_token(DOT);
                        try
                        {
                                expression = factory.createNodeTest(NodeKind.NODE, null, parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        if (isFirst) {
                                isFirst = false;
                                separator = false;
                        }
                        axis = Axis.SELF;
      break;
    case QNAME_L_PAREN:
      expression = FunctionCall();
      break;
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = Constructor();
      break;
    default:
      jj_la1[114] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (!isFirst) {
                        if (separator && axis == Axis.NONE)
                        {
                                axis = Axis.CHILD;
                        }
                        try
                        {
                                Step step = factory.createStep(separator, axis, expression, null, parentModule);
                                if (expression.getParenthesis()) step.setParenthesis(true);
                                {if (true) return step;}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[85]    ForwardStep    ::=    (ForwardAxis NodeTest) | AbbrevForwardStep 
**************************************************************************************/
  final public Step ForwardStep(boolean separator) throws ParseException, TypeException, XQueryException {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
        Step step = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case AROBASE:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
      step = AbbrevForwardStep(separator);
      break;
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case SELF_DCOLON:
      axis = ForwardAxis();
      expression = NodeTest();
                                try
                                {
                                        if (axis == Axis.ATTRIBUTE && defaultElementNameSpace != null && expression instanceof QName) ((QName) expression).setNameSpace(null);
                                        step = factory.createStep(separator, axis, expression, null, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[115] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[87]    AbbrevForwardStep    ::=    "@"? NodeTest 
***************************************************************************************/
  final public Step AbbrevForwardStep(boolean separator) throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        byte axis = Axis.NONE;
        if (separator)
        {
                axis = Axis.CHILD;
        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AROBASE:
      currentToken = jj_consume_token(AROBASE);
                                axis = Axis.ATTRIBUTE;
      break;
    default:
      jj_la1[116] = jj_gen;
      ;
    }
    expression = NodeTest();
                try
                {
                        if (axis == Axis.ATTRIBUTE && defaultElementNameSpace != null && expression instanceof QName) ((QName) expression).setNameSpace(null);
                        {if (true) return factory.createStep(separator, axis, expression, null, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[89]    ForwardAxis    ::=    <"child" "::"> | <"descendant" "::"> | <"attribute" "::"> | <"self" "::"> | <"descendant-or-self" "::"> | <"following-sibling" "::"> | <"following" "::"> 
***************************************************************************************/
  final public byte ForwardAxis() throws ParseException, TypeException, XQueryException {
        byte axis = Axis.NONE;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CHILD_DCOLON:
      currentToken = jj_consume_token(CHILD_DCOLON);
                        axis = Axis.CHILD;
      break;
    case DESCENDANT_DCOLON:
      currentToken = jj_consume_token(DESCENDANT_DCOLON);
                        axis = Axis.DESCENDANT;
      break;
    case ATTRIBUTE_DCOLON:
      currentToken = jj_consume_token(ATTRIBUTE_DCOLON);
                        axis = Axis.ATTRIBUTE;
      break;
    case SELF_DCOLON:
      currentToken = jj_consume_token(SELF_DCOLON);
                        axis = Axis.SELF;
      break;
    case DESCENDANT_SELF_DCOLON:
      currentToken = jj_consume_token(DESCENDANT_SELF_DCOLON);
                        axis = Axis.DESCENDANT_OR_SELF;
      break;
    case FOLLOWING_SIBLING_DCOLON:
      currentToken = jj_consume_token(FOLLOWING_SIBLING_DCOLON);
                        axis = Axis.FOLLOWING_SIBLING;
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'following-sibling' axis is not supported yet.");}
      break;
    case FOLLOWING_DCOLON:
      currentToken = jj_consume_token(FOLLOWING_DCOLON);
                        axis = Axis.FOLLOWING;
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'following' axis is not supported yet.");}
      break;
    default:
      jj_la1[117] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return axis;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[86]    ReverseStep    ::=    (ReverseAxis NodeTest) | AbbrevReverseStep 
**************************************************************************************/
  final public Step ReverseStep(boolean separator) throws ParseException, TypeException, XQueryException {
        byte axis = Axis.NONE;
        XQueryExpression expression = null;
        Step step = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOTDOT:
      step = AbbrevReverseStep(separator);
      break;
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
      axis = ReverseAxis();
      expression = NodeTest();
                                try
                                {
                                        step = factory.createStep(separator, axis, expression, null, parentModule);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
      break;
    default:
      jj_la1[118] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[88]    AbbrevReverseStep    ::=    ".." 
***************************************************************************************/
  final public Step AbbrevReverseStep(boolean separator) throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        byte axis = Axis.NONE;
    currentToken = jj_consume_token(DOTDOT);
                        try
                        {
                                expression = factory.createNodeTest(NodeKind.NODE, null, parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                        axis = Axis.PARENT;
                try
                {
                        {if (true) return factory.createStep(separator, axis, expression, null, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[90]    ReverseAxis    ::=    <"parent" "::"> | <"ancestor" "::"> | <"preceding-sibling" "::"> | <"preceding" "::"> | <"ancestor-or-self" "::"> 
***************************************************************************************/
  final public byte ReverseAxis() throws ParseException, TypeException, XQueryException {
        byte axis = Axis.NONE;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PARENT_DCOLON:
      currentToken = jj_consume_token(PARENT_DCOLON);
                        axis = Axis.PARENT;
      break;
    case ANCESTOR_DCOLON:
      currentToken = jj_consume_token(ANCESTOR_DCOLON);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'ancestor' axis is not supported yet.");}
                        axis = Axis.ANCESTOR;
      break;
    case PRECEDING_SIBLING_DCOLON:
      currentToken = jj_consume_token(PRECEDING_SIBLING_DCOLON);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'preceding-sibling' axis is not supported yet.");}
                        axis = Axis.PRECEDING_SIBLING;
      break;
    case PRECEDING_DCOLON:
      currentToken = jj_consume_token(PRECEDING_DCOLON);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'preceding' axis is not supported yet.");}
                        axis = Axis.PRECEDING;
      break;
    case ANCESTOR_OR_SELF_DCOLON:
      currentToken = jj_consume_token(ANCESTOR_OR_SELF_DCOLON);
                        if (restriction) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". 'ancestor-or-self' axis is not supported yet.");}
                        axis = Axis.ANCESTOR_OR_SELF;
      break;
    default:
      jj_la1[119] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return axis;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[91]    NodeTest    ::=    KindTest | NameTest 
***************************************************************************************/
  final public XQueryExpression NodeTest() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case KINDTEST_ELEMENT_L_PAREN:
      expression = KindTest();
      break;
    case STAR:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case QNAME:
      expression = NameTest();
      break;
    default:
      jj_la1[120] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[92]    NameTest    ::=    QName | Wildcard 
***************************************************************************************/
  final public QName NameTest() throws ParseException, TypeException, XQueryException {
        QName nameTest = null;
    if (jj_2_7(3)) {
      currentToken = jj_consume_token(QNAME);
                        nameTest = QName(currentToken.image);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case NCNAME_STAR:
      case STAR_NCNAME:
        nameTest = Wildcard();
        break;
      default:
        jj_la1[121] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                {if (true) return nameTest;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[93]    Wildcard    ::=    "*" | <NCName ":" "*"> | <"*" ":" NCName> 
***************************************************************************************/
  final public QName Wildcard() throws ParseException, TypeException, XQueryException {
        String namespace = null;
        String prefixname = null;
        String localname = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STAR:
      currentToken = jj_consume_token(STAR);
                        localname = currentToken.image;
                        prefixname = currentToken.image;
      break;
    case NCNAME_STAR:
      currentToken = jj_consume_token(NCNAME_STAR);
                        localname = "*";
                        prefixname = currentToken.image.substring(0,currentToken.image.length()-2);
      break;
    case STAR_NCNAME:
      currentToken = jj_consume_token(STAR_NCNAME);
                        prefixname = "*";
                        localname = currentToken.image.substring(2);
      break;
    default:
      jj_la1[122] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        String tmpStr = null;
                        if (prefixname == null)
                        {
                                namespace = defaultElementNameSpace;
                        }
                        else if (prefixname.equals("*"))
                        {
                                namespace = prefixname;
                        }
                        else
                        {
                                tmpStr = getNameSpace(prefixname);
                                if (tmpStr == null)
                                {
                                        {if (true) throw new TypeException("Could not match prefix [ " + prefixname + " ]" , currentToken.beginLine, currentToken.beginColumn);}
                                }
                                namespace = tmpStr;
                        }
                        {if (true) return factory.createQName(namespace, prefixname, localname, parentModule, namespaceContextStack.getNamespaceContext());}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[77]    Predicates    ::=    ("[" Expr "]")* 
LARS --> [77]    Predicates    ::=    ("[" ExprSingle "]")* 
**************************************************************************************/
  final public ArrayList Predicates() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList predicates = null;
        boolean oldInPredicate = false;
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case L_BRACKET:
        ;
        break;
      default:
        jj_la1[123] = jj_gen;
        break label_19;
      }
      currentToken = jj_consume_token(L_BRACKET);
                                oldInPredicate = inPredicate;
                                inPredicate = true;
      expression = ExprSingle();
                                if (restriction && expression instanceof Value) {if (true) throw new ParseException("Encountered \"" + currentToken.image + "\" at line " + currentToken.beginLine + ", column " + currentToken.beginColumn + ". RangeExpr is not supported yet.");}
      currentToken = jj_consume_token(R_BRACKET);
                                inPredicate = oldInPredicate;
                        if (predicates == null)
                        {
                                predicates = new ArrayList(1);
                        }
                        //expression.setBracket(true);
                        predicates.add(expression);
    }
                {if (true) return predicates;}
    throw new Error("Missing return statement in function");
  }

/**************************************************************************************
[94]    Literal    ::=    NumericLiteral | StringLiteral 
**************************************************************************************/
  final public Value Literal() throws ParseException, TypeException, XQueryException {
        Value value = null;
        String stringLiteral;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DecimalLiteral:
    case DoubleLiteral:
    case IntegerLiteral:
      value = NumericLiteral();
      break;
    case StringLiteral:
      currentToken = jj_consume_token(StringLiteral);
                        stringLiteral = currentToken.image;
                        try
                        {
                                value = factory.createValueString(unquote(stringLiteral), parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    default:
      jj_la1[124] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[95]    NumericLiteral    ::=    IntegerLiteral | DecimalLiteral | DoubleLiteral 
***************************************************************************************/
  final public Value NumericLiteral() throws ParseException, TypeException, XQueryException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IntegerLiteral:
      currentToken = jj_consume_token(IntegerLiteral);
                try
                {
                        {if (true) return factory.createValueInteger(currentToken.image, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    case DecimalLiteral:
      currentToken = jj_consume_token(DecimalLiteral);
                try
                {
                        {if (true) return factory.createValueDecimal(currentToken.image, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    case DoubleLiteral:
      currentToken = jj_consume_token(DoubleLiteral);
                try
                {
                        {if (true) return factory.createValueDouble(currentToken.image, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
      break;
    default:
      jj_la1[125] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[96]    ParenthesizedExpr    ::=    "(" Expr? ")" 
***************************************************************************************/
  final public XQueryExpression ParenthesizedExpr() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(L_PAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = Expr(false);
      break;
    default:
      jj_la1[126] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_PAREN);
                        if (expression == null)
                                expression = factory.createXQueryVoid(parentModule);
                        else
                                expression.setParenthesis(true);
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[97]    FunctionCall    ::=    <QName "("> (ExprSingle ("," ExprSingle)*)? ")" 
***************************************************************************************/
  final public XQueryExpression FunctionCall() throws ParseException, TypeException, XQueryException {
        QName funcName = null;
        XQueryExpression expression = null;
        XQueryExpressionSequence tmpExpr = null;
        ArrayList arguments = null;
    currentToken = jj_consume_token(QNAME_L_PAREN);
                        String tmpstr = extractName(currentToken.image,null,"(");
                        funcName = QName(tmpstr,true,true);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = ExprSingle();
                                if (arguments == null) arguments = new ArrayList(1);
                                arguments.add(expression);
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[127] = jj_gen;
          break label_20;
        }
        currentToken = jj_consume_token(COMMA);
        expression = ExprSingle();
                                        arguments.add(expression);
      }
      break;
    default:
      jj_la1[128] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_PAREN);
                HashMap map = (HashMap)hashDeclFuncList.get(funcName.getNameSpace());
                if (map != null && map.containsKey(funcName.getLocalName()))
                {
                        try
                        {
                                {if (true) return factory.createLibraryFunctionCall(funcName, arguments, (FunctionDeclaration)map.get(funcName.getLocalName()), parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {

                        String functionName = funcName.getLocalName();
                        if (functionName.equals("collection"))
                        {
                                /* looks up view definition */
                                ValueString viewName = (ValueString)arguments.get(0);
                                String viewNameString = viewName.getValue();
                                if (null != viewDefinitions) {
                                        XQueryModule resFile = (XQueryModule)viewDefinitions.get(viewNameString);
                                        XQueryExpression resExpr = null;
                                        resExpr = (XQueryExpression)resFile.getExpressions().get(0);
                                        if (resExpr != null) {if (true) return resExpr;}
                                }
                        }
                        functionName = funcName.getLocalName().toUpperCase();
                        functionName = functionName.replace('-', '_');
                        boolean found = true;
                        java.lang.Class cl = null;
                        try {
                                found = true;
                                cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.fnfunctions.Function" + functionName );
                        } catch (ClassNotFoundException cnfe) { found = false; }
                        if (!found)
                                try {
                                        found = true;
                                        cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.myfunctions.Function" + functionName );
                                } catch (ClassNotFoundException cnfe) {found = false;}
                        if (!found)
                                try {
                                        found = true;
                                        cl = Class.forName("org.xquark.xquery.parser.primitivefunctions.xsfunctions.Function" + functionName );
                                } catch (ClassNotFoundException cnfe) {found = false;}
                        if (!found)
                                {if (true) throw new TypeException("Could not find primitive function " + funcName, currentToken.beginLine, currentToken.beginColumn);}
                        java.lang.Class[] paramTypes = { Class.forName("java.util.ArrayList"), Class.forName("org.xquark.xquery.parser.XQueryModule")};
                        java.lang.reflect.Constructor constructor = cl.getConstructor(paramTypes);
                        Object[] params = { arguments, parentModule };
                        FunctionCall fc = null;
                        fc = (FunctionCall) constructor.newInstance(params);
                        String localName = funcName.getLocalName();
                        if (!fc.getFuncName().getLocalName().equals(localName)) {if (true) throw new ParseException("XQuery is a case-sensitive language. Primitive function " + localName + " is not a valid name.");}
                        // change lars 18/06/2003
                        if (fc instanceof FunctionINTEGER || fc instanceof FunctionDOUBLE || fc instanceof FunctionDECIMAL || fc instanceof FunctionFLOAT)
                        {
                                if (fc.getArgument(0) instanceof Value)
                                        {if (true) return (XQueryExpression)fc.getArguments().get(0);}
                        }
                        {if (true) return fc;}
                }
                catch (ClassNotFoundException cnfe) {
                        {if (true) throw new TypeException("Could not find primitive function " + funcName, currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (java.lang.reflect.InvocationTargetException ite) {
                        {if (true) throw new TypeException(ite.getTargetException().getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
                catch (TypeException e) {
                        {if (true) throw e;}
                }
                catch (Exception e) // { /* this is done on purpose you fool! */ }
                {
                        {if (true) throw new TypeException(e.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[80]    Constructor    ::=    DirElemConstructor | ComputedConstructor | XmlComment | XmlPI | CdataSection 
[81]    ComputedConstructor    ::=    CompElemConstructor | CompAttrConstructor | CompDocConstructor | CompTextConstructor | CompXmlPI | CompXmlComment | CompNSConstructor 
***************************************************************************************/
  final public XQueryExpression Constructor() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TAG_START:
    case ELEMENT_CONTENT_ELT_LESS:
      expression = DirElemConstructor();
      break;
    case XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
      expression = XmlComment();
      break;
    case XMLPROCESSING_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
      expression = XmlPI();
      break;
    case CDATA_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = CdataSection();
      break;
    case DOCUMENT_L_BRACE:
      expression = CompDocConstructor();
      break;
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
      expression = CompElemConstructor();
      break;
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
      expression = CompAttrConstructor();
      break;
    case COMMENT_L_BRACE:
      expression = CompXmlComment();
      break;
    case NAMESPACE_NCNAME_L_BRACE:
      expression = CompNSConstructor();
      break;
    case TEXT_L_BRACE:
      expression = CompTextConstructor();
      break;
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
      expression = CompXmlPI();
      break;
    default:
      jj_la1[129] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[98]    DirElemConstructor    ::=    "<" QName AttributeList S? ("/>" | (">" ElementContent* "</" QName S? ">"))  
***************************************************************************************/
  final public Element DirElemConstructor() throws ParseException, TypeException, XQueryException {
        String startTagString = null;
        QName startTag = null;
        ArrayList attributeList = null;
        ArrayList vectExpressions = null;
        XQueryExpression expression = null;
        QName endTag = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TAG_START:
      currentToken = jj_consume_token(TAG_START);

      break;
    case ELEMENT_CONTENT_ELT_LESS:
      currentToken = jj_consume_token(ELEMENT_CONTENT_ELT_LESS);

      break;
    default:
      jj_la1[130] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        namespaceContextStack.pushContext();
    currentToken = jj_consume_token(START_TAG_QNAME);
                        startTagString = currentToken.image;
                        //startTag = QName(currentToken.image,false,false);

    attributeList = AttributeList();
                        startTag = QName(startTagString);
                        if (startTag.getPrefixName() == null)
                        {
                                startTag.setNameSpace(defaultElementNameSpace);
                        }
                        else
                        {
                                String tmpStr = getNameSpace(startTag.getPrefixName());
                                if (tmpStr == null)
                                        {if (true) throw new TypeException("Could not match prefix [ " + startTag.getPrefixName() + " ]" , currentToken.beginLine, currentToken.beginColumn);}
                                startTag.setNameSpace(tmpStr);
                        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_TAG_SLASH_GREATER:
      currentToken = jj_consume_token(START_TAG_SLASH_GREATER);
      break;
    case START_TAG_GREATER:
      currentToken = jj_consume_token(START_TAG_GREATER);
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case XMLCOMMENT_START:
        case XMLPROCESSING_START:
        case CDATA_START:
        case TAG_START:
        case L_BRACE:
        case ELEMENT_CONTENT_ELT_LESS:
        case ELEMENT_CONTENT_L_BRACE:
        case ELEMENT_CONTENT_XMLCOMMENT_START:
        case ELEMENT_CONTENT_XMLPROCESSING_START:
        case ELEMENT_CONTENT_CDATA_START:
        case ELEMENT_CONTENT_ESCAPE_L_BRACE:
        case ELEMENT_CONTENT_ESCAPE_R_BRACE:
        case ELEMENT_CONTENT_PredefinedEntityRef:
        case ELEMENT_CONTENT_CharRef:
        case ELEMENT_CONTENT_WhiteChar:
        case ELEMENT_CONTENT_Char:
          ;
          break;
        default:
          jj_la1[131] = jj_gen;
          break label_21;
        }
        expression = ElementContent();
                                                if (expression != null)
                                                {
                                                        if (vectExpressions == null)
                                                        {
                                                                vectExpressions = new ArrayList();
                                                        }
                                                        if (expression instanceof XQueryExpressionSequence && ((XQueryExpressionSequence)expression).getSubExpressions().size() > 1)
                                                        {
                                                                ArrayList subExpressions = ((XQueryExpressionSequence)expression).getSubExpressions();
                                                                XQueryExpression expri = null;
                                                                ArrayList sequence = null;
                                                                for (int i = 0; i < subExpressions.size(); i++)
                                                                {
                                                                        expri = (XQueryExpression)subExpressions.get(i);
                                                                        sequence = new ArrayList(1);
                                                                        sequence.add(expri);
                                                                        try
                                                                        {
                                                                                expri = factory.createXQueryExpressionSequence(sequence, parentModule);
                                                                        }
                                                                        catch (TypeException te)
                                                                        {
                                                                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                                                        }
                                                                        //expri.setBrace(true);
                                                                        vectExpressions.add(expri);
                                                                }
                                                                if (subExpressions.isEmpty()) vectExpressions = null;
                                                        }
                                                        else
                                                        {
                                                                vectExpressions.add(expression);
                                                        }
                                                }
      }
      currentToken = jj_consume_token(ELEMENT_CONTENT_ELT_LESS_SLASH);
      currentToken = jj_consume_token(END_TAG_QNAME);
                                        endTag = QName(currentToken.image);
                                        if (!endTag.getName().equals(startTag.getName()))
                                        {
                                                {if (true) throw new ParseException("Error : tag '" + startTag.getName() + "' is ended with '" + endTag.getName() + "'!");}
                                        }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case END_TAG_S:
        currentToken = jj_consume_token(END_TAG_S);
        break;
      default:
        jj_la1[132] = jj_gen;
        ;
      }
      currentToken = jj_consume_token(END_TAG_GREATER_THAN);
      break;
    default:
      jj_la1[133] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                try
                {
                        List list = namespaceContextStack.getDeclaredPrefixes();
                        HashMap localPrefixes = null;
                        for (int i = 0; i < list.size(); i++)
                        {
                                if (i == 0) localPrefixes = new HashMap();
                                String prefix = (String)list.get(i);
                                localPrefixes.put(prefix, namespaceContextStack.getNamespaceURI(prefix));
                        }
                        namespaceContextStack.popContext();
                        {if (true) return factory.createElement(startTag, localPrefixes, attributeList, vectExpressions, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[99]    CompDocConstructor    ::=    <"document" "{"> Expr "}" 
***************************************************************************************/
  final public Document CompDocConstructor() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
    currentToken = jj_consume_token(DOCUMENT_L_BRACE);
    expression = Expr(false);
    currentToken = jj_consume_token(R_BRACE);
                try
                {
                        {if (true) return factory.createDocument(expression, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[100]    CompElemConstructor    ::=    (<"element" QName "{"> | (<"element" "{"> Expr "}" "{")) Expr? "}" 
***************************************************************************************/
  final public Element CompElemConstructor() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        XQueryExpression sequence = null;
        ArrayList attributeList = null;
        ArrayList vectExpressions = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_QNAME_L_BRACE:
      currentToken = jj_consume_token(ELEMENT_QNAME_L_BRACE);
                                        expression = QName(extractName(currentToken.image,"element","{"),false,false);
      break;
    case ELEMENT_L_BRACE:
      currentToken = jj_consume_token(ELEMENT_L_BRACE);
      expression = Expr(false);
      currentToken = jj_consume_token(R_BRACE);
      currentToken = jj_consume_token(L_BRACE);
      break;
    default:
      jj_la1[134] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        namespaceContextStack.pushContext();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      sequence = Expr(false);
      break;
    default:
      jj_la1[135] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);
                if (sequence != null)
                {
                        if (sequence instanceof AttributeValuePair)
                        {
                                attributeList = new ArrayList(1);
                                attributeList.add(sequence);
                        }
                        else if (sequence instanceof XQueryExpressionSequence)
                        {
                                vectExpressions = ((XQueryExpressionSequence)sequence).getSubExpressions();
                                XQueryExpression expri = null;
                                for (int i = 0; i < vectExpressions.size(); i++)
                                {
                                        expri = (XQueryExpression)vectExpressions.get(i);
                                        if (expri instanceof AttributeValuePair)
                                        {
                                                if (attributeList == null) attributeList = new ArrayList(1);
                                                attributeList.add(expri);
                                                vectExpressions.remove(i);
                                                i--;
                                        }
                                }
                                if (vectExpressions.isEmpty()) vectExpressions = null;
                        }
                        else
                        {
                                vectExpressions = new ArrayList(1);
                                vectExpressions.add(sequence);
                        }
                }
                try
                {
                        List list = namespaceContextStack.getDeclaredPrefixes();
                        HashMap localPrefixes = null;
                        for (int i = 0; i < list.size(); i++)
                        {
                                if (i == 0) localPrefixes = new HashMap();
                                String prefix = (String)list.get(i);
                                localPrefixes.put(prefix, namespaceContextStack.getNamespaceURI(prefix));
                        }
                        namespaceContextStack.popContext();
                        Element element = factory.createElement(expression, localPrefixes, attributeList, vectExpressions, parentModule);
                        element.setIsComputed(true);
                        {if (true) return element;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[102]    CompAttrConstructor    ::=    (<"attribute" QName "{"> | (<"attribute" "{"> Expr "}" "{")) Expr? "}" 
***************************************************************************************/
  final public AttributeValuePair CompAttrConstructor() throws ParseException, TypeException, XQueryException {
        XQueryExpression attributeName = null;
        XQueryExpression attributeValue = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ATTRIBUTE_QNAME_L_BRACE:
      currentToken = jj_consume_token(ATTRIBUTE_QNAME_L_BRACE);
                                attributeName = QName(extractName(currentToken.image,"attribute","{"));
      break;
    case ATTRIBUTE_L_BRACE:
      currentToken = jj_consume_token(ATTRIBUTE_L_BRACE);
      attributeName = Expr(false);
      currentToken = jj_consume_token(R_BRACE);
      currentToken = jj_consume_token(L_BRACE);
      break;
    default:
      jj_la1[136] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      attributeValue = Expr(false);
      break;
    default:
      jj_la1[137] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);
                if (attributeValue == null)
                {
                        try
                        {
                                attributeValue = factory.createValueString("", parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {
                        AttributeValuePair attributeValuePair = factory.createAttributeValuePair(attributeName, attributeValue, false, parentModule);
                        attributeValuePair.setIsComputed(true);
                        {if (true) return attributeValuePair;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[103]    CompXmlPI    ::=    (("processing-instruction" NCName "{") | ("processing-instruction" "{" Expr "}" "{")) Expr? "}" 
***************************************************************************************/
  final public XMLProcessingInstruction CompXmlPI() throws ParseException, TypeException, XQueryException {
        XQueryExpression name = null;
        XQueryExpression value = null;
        String nameStr = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
      currentToken = jj_consume_token(PROCESSING_INSTRUCTION_NCNAME_L_BRACE);
                                name = QName(extractName(currentToken.image,"processing-instruction","{"));
      break;
    case PROCESSING_INSTRUCTION_L_BRACE:
      currentToken = jj_consume_token(PROCESSING_INSTRUCTION_L_BRACE);
      name = ExprSingle();
      currentToken = jj_consume_token(R_BRACE);
      currentToken = jj_consume_token(L_BRACE);
      break;
    default:
      jj_la1[138] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      value = Expr(false);
      break;
    default:
      jj_la1[139] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);
                if (value == null)
                {
                        try
                        {
                                value = factory.createValueString("", parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                try
                {
                        XMLProcessingInstruction xmlpi = factory.createXMLProcessingInstruction(name, value, parentModule);
                        xmlpi.setIsComputed(true);
                        {if (true) return xmlpi;}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[104]    CompXmlComment    ::=    <"comment" "{"> Expr "}" 
***************************************************************************************/
  final public XQueryExpression CompXmlComment() throws ParseException, TypeException, XQueryException {
        XQueryExpression commentValue = null;
    currentToken = jj_consume_token(COMMENT_L_BRACE);
    commentValue = Expr(false);
    currentToken = jj_consume_token(R_BRACE);
                try
                {
                        {if (true) return factory.createXMLComment(commentValue, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[101]    CompNSConstructor    ::=    <"namespace" NCName "{"> Expr "}" 
***************************************************************************************/
  final public XQueryExpression CompNSConstructor() throws ParseException, TypeException, XQueryException {
        String ncname = null;
        XQueryExpression namespaceValue = null;
    currentToken = jj_consume_token(NAMESPACE_NCNAME_L_BRACE);
                        ncname = extractName(currentToken.image,"namespace","{");
    namespaceValue = ExprSingle();
    currentToken = jj_consume_token(R_BRACE);
                try
                {
                        {if (true) return factory.createComputedNamespace(ncname,namespaceValue, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[105]    CompTextConstructor    ::=    <"text" "{"> Expr? "}" 
***************************************************************************************/
  final public XQueryExpression CompTextConstructor() throws ParseException, TypeException, XQueryException {
        XQueryExpression textValue = null;
    currentToken = jj_consume_token(TEXT_L_BRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_L_PAREN:
    case ATTRIBUTE_L_PAREN:
    case COMMENT_L_PAREN:
    case TEXT_L_PAREN:
    case NODE_L_PAREN:
    case DOCUMENT_NODE_L_PAREN:
    case PROCESSING_INSTRUCTION_L_PAREN:
    case STAR:
    case XMLCOMMENT_START:
    case XMLPROCESSING_START:
    case CDATA_START:
    case TAG_START:
    case VALIDATE_GLOBAL:
    case VALIDATE_CONTEXT:
    case VALIDATE_LAX:
    case VALIDATE_STRICT:
    case VALIDATE_SKIP:
    case ELEMENT_QNAME_L_BRACE:
    case ELEMENT_L_BRACE:
    case ATTRIBUTE_L_BRACE:
    case ATTRIBUTE_QNAME_L_BRACE:
    case NAMESPACE_NCNAME_L_BRACE:
    case DOCUMENT_L_BRACE:
    case TEXT_L_BRACE:
    case PROCESSING_INSTRUCTION_L_BRACE:
    case PROCESSING_INSTRUCTION_NCNAME_L_BRACE:
    case COMMENT_L_BRACE:
    case AROBASE:
    case ANCESTOR_OR_SELF_DCOLON:
    case ANCESTOR_DCOLON:
    case ATTRIBUTE_DCOLON:
    case CHILD_DCOLON:
    case DESCENDANT_SELF_DCOLON:
    case DESCENDANT_DCOLON:
    case FOLLOWING_SIBLING_DCOLON:
    case FOLLOWING_DCOLON:
    case PARENT_DCOLON:
    case PRECEDING_SIBLING_DCOLON:
    case PRECEDING_DCOLON:
    case SELF_DCOLON:
    case IF_L_PAREN:
    case QNAME_L_PAREN:
    case DOLLAR:
    case FOR_$:
    case LET_$:
    case SOME_$:
    case EVERY_$:
    case VALIDATE_L_BRACE:
    case TYPESWITCH_L_PAREN:
    case L_PAREN:
    case MINUS:
    case PLUS:
    case SLASH_SLASH:
    case SLASH:
    case DecimalLiteral:
    case DOTDOT:
    case DOT:
    case DoubleLiteral:
    case IntegerLiteral:
    case NCNAME_STAR:
    case STAR_NCNAME:
    case StringLiteral:
    case QNAME:
    case KINDTEST_ELEMENT_L_PAREN:
    case ELEMENT_CONTENT_ELT_LESS:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
    case ELEMENT_CONTENT_CDATA_START:
      textValue = Expr(false);
      break;
    default:
      jj_la1[140] = jj_gen;
      ;
    }
    currentToken = jj_consume_token(R_BRACE);
                try
                {
                        if (textValue == null) {
                                textValue = factory.createValueString("",parentModule);
                        }
                        {if (true) return factory.createComputedText(textValue, parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[106]    CdataSection    ::=    "<![CDATA[" Char* "]]>" 
***************************************************************************************/
  final public CData CdataSection() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CDATA_START:
      currentToken = jj_consume_token(CDATA_START);
      break;
    case ELEMENT_CONTENT_CDATA_START:
      currentToken = jj_consume_token(ELEMENT_CONTENT_CDATA_START);
      break;
    default:
      jj_la1[141] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_22:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CDATA_SECTION_CHAR:
        ;
        break;
      default:
        jj_la1[142] = jj_gen;
        break label_22;
      }
      currentToken = jj_consume_token(CDATA_SECTION_CHAR);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(CDATA_SECTION_END);
                try
                {
                        {if (true) return factory.createCData(buf.toString(), parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[107]    XmlPI    ::=    "<?" PITarget Char* "?>"
***************************************************************************************/
  final public XMLProcessingInstruction XmlPI() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
        String PITarget = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XMLPROCESSING_START:
      currentToken = jj_consume_token(XMLPROCESSING_START);
      break;
    case ELEMENT_CONTENT_XMLPROCESSING_START:
      currentToken = jj_consume_token(ELEMENT_CONTENT_XMLPROCESSING_START);
      break;
    default:
      jj_la1[143] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    currentToken = jj_consume_token(PROCESSING_INSTRUCTION_NCNAME);
                        PITarget = unquote(currentToken.image);
    label_23:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROCESSING_INSTRUCTION_CONTENT_CHAR:
        ;
        break;
      default:
        jj_la1[144] = jj_gen;
        break label_23;
      }
      currentToken = jj_consume_token(PROCESSING_INSTRUCTION_CONTENT_CHAR);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(PROCESSING_INSTRUCTION_CONTENT_PROCESSING_INSTRUCTION_END);
                try
                {
                        {if (true) return factory.createXMLProcessingInstruction(factory.createValueString(PITarget,parentModule), factory.createValueString(buf.toString(),parentModule), parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[108]    XmlComment    ::=    "<!--" Char* "-->" 
***************************************************************************************/
  final public XMLComment XmlComment() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XMLCOMMENT_START:
      currentToken = jj_consume_token(XMLCOMMENT_START);
      break;
    case ELEMENT_CONTENT_XMLCOMMENT_START:
      currentToken = jj_consume_token(ELEMENT_CONTENT_XMLCOMMENT_START);
      break;
    default:
      jj_la1[145] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_24:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XML_COMMENT_CHAR:
        ;
        break;
      default:
        jj_la1[146] = jj_gen;
        break label_24;
      }
      currentToken = jj_consume_token(XML_COMMENT_CHAR);
                                buf.append(currentToken.image);
    }
    currentToken = jj_consume_token(XML_COMMENT_END);
                try
                {
                        {if (true) return factory.createXMLComment(factory.createValueString(buf.toString(),parentModule), parentModule);}
                }
                catch (TypeException te)
                {
                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[109]    ElementContent    ::=    ElementContentChar | "{{" | "}}" | DirElemConstructor | EnclosedExpr | CdataSection | CharRef | PredefinedEntityRef | XmlComment | XmlPI
***************************************************************************************/
  final public XQueryExpression ElementContent() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
        XQueryExpression expression = null;
        boolean hasCharRef = false;
        boolean isWhiteOnly = true;
        boolean prevIsR = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELEMENT_CONTENT_ESCAPE_L_BRACE:
    case ELEMENT_CONTENT_ESCAPE_R_BRACE:
    case ELEMENT_CONTENT_PredefinedEntityRef:
    case ELEMENT_CONTENT_CharRef:
    case ELEMENT_CONTENT_WhiteChar:
    case ELEMENT_CONTENT_Char:
      label_25:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ELEMENT_CONTENT_WhiteChar:
          currentToken = jj_consume_token(ELEMENT_CONTENT_WhiteChar);
                                        if (currentToken.image.charAt(0) == '\r')
                                                prevIsR = true;
                                        else {
                                                if (prevIsR) {
                                                        if (currentToken.image.charAt(0) == '\n')
                                                                buf.deleteCharAt(buf.length()-1);
                                                        else
                                                                buf.setCharAt(buf.length()-1,'\n');
                                                        prevIsR = false;
                                                }
                                        }
                                        buf.append(currentToken.image);
          break;
        case ELEMENT_CONTENT_Char:
          currentToken = jj_consume_token(ELEMENT_CONTENT_Char);
                                        buf.append(currentToken.image);
                                        if (isWhiteOnly) isWhiteOnly = false;
                                        if (prevIsR) {
                                                buf.setCharAt(buf.length()-1,'\n');
                                                prevIsR = false;
                                        }
          break;
        case ELEMENT_CONTENT_ESCAPE_L_BRACE:
          currentToken = jj_consume_token(ELEMENT_CONTENT_ESCAPE_L_BRACE);
                                        buf.append("{");
                                        if (isWhiteOnly) isWhiteOnly = false;
                                        if (prevIsR) {
                                                buf.setCharAt(buf.length()-1,'\n');
                                                prevIsR = false;
                                        }
          break;
        case ELEMENT_CONTENT_ESCAPE_R_BRACE:
          currentToken = jj_consume_token(ELEMENT_CONTENT_ESCAPE_R_BRACE);
                                        buf.append("}");
                                        if (isWhiteOnly) isWhiteOnly = false;
                                        if (prevIsR) {
                                                buf.setCharAt(buf.length()-1,'\n');
                                                prevIsR = false;
                                        }
          break;
        case ELEMENT_CONTENT_CharRef:
          currentToken = jj_consume_token(ELEMENT_CONTENT_CharRef);
                                        if (!hasCharRef) hasCharRef = true;
                                        char car = parseCharRef(currentToken.image);
                                        if (car == '\r' || car == '\n' || car == '\n' || car == '\n') {
                                                if (car == '\r')
                                                        prevIsR = true;
                                                else {
                                                        if (prevIsR) {
                                                                if (car == '\n')
                                                                        buf.deleteCharAt(buf.length()-1);
                                                                else
                                                                        buf.setCharAt(buf.length()-1,'\n');
                                                                prevIsR = false;
                                                        }
                                                }
                                        } else {
                                                if (isWhiteOnly) isWhiteOnly = false;
                                                if (prevIsR) {
                                                        buf.setCharAt(buf.length()-1,'\n');
                                                        prevIsR = false;
                                                }
                                        }
                                        buf.append(car);
          break;
        case ELEMENT_CONTENT_PredefinedEntityRef:
          currentToken = jj_consume_token(ELEMENT_CONTENT_PredefinedEntityRef);
                                        if (!hasCharRef) hasCharRef = true;
                                        if (isWhiteOnly) isWhiteOnly = false;
                                        if (prevIsR) {
                                                buf.setCharAt(buf.length()-1,'\n');
                                                prevIsR = false;
                                        }
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[147] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_8(2)) {
          ;
        } else {
          break label_25;
        }
      }
                        try
                        {
                                if (buf.length() == 0 || (isWhiteOnly && !hasCharRef && xmlspace != Constants.XMLSPACE_PRESERVE))
                                        expression = null;
                                else
                                        expression = factory.createValueText(buf.toString(), parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case TAG_START:
    case ELEMENT_CONTENT_ELT_LESS:
      expression = DirElemConstructor();
      break;
    case L_BRACE:
    case ELEMENT_CONTENT_L_BRACE:
      expression = EnclosedExpr(false);
      break;
    case CDATA_START:
    case ELEMENT_CONTENT_CDATA_START:
      expression = CdataSection();
      break;
    case XMLCOMMENT_START:
    case ELEMENT_CONTENT_XMLCOMMENT_START:
      expression = XmlComment();
      break;
    case XMLPROCESSING_START:
    case ELEMENT_CONTENT_XMLPROCESSING_START:
      expression = XmlPI();
      break;
    default:
      jj_la1[148] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[110]    AttributeList    ::=    (S (QName S? "=" S? AttributeValue)?)* 
***************************************************************************************/
  final public ArrayList AttributeList() throws ParseException, TypeException, XQueryException {
        QName attributeName = null;
        AttributeValuePair attributeValuePair = null;
        XQueryExpression attributeValue = null;
        ArrayList attributeList = null;
    label_26:
    while (true) {
      if (jj_2_9(2)) {
        ;
      } else {
        break label_26;
      }
      currentToken = jj_consume_token(START_TAG_S);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case START_TAG_QNAME:
        currentToken = jj_consume_token(START_TAG_QNAME);
                                attributeName = QName(currentToken.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case START_TAG_S:
          currentToken = jj_consume_token(START_TAG_S);
          break;
        default:
          jj_la1[149] = jj_gen;
          ;
        }
        currentToken = jj_consume_token(START_TAG_EQUAL);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case START_TAG_S:
          currentToken = jj_consume_token(START_TAG_S);
          break;
        default:
          jj_la1[150] = jj_gen;
          ;
        }
        attributeValue = AttributeValue();
                                try
                                {
                                        if (attributeName.getNameSpace() == null && attributeName.getPrefixName() != null && attributeName.getPrefixName().equals(XMLNS))
                                        {
                                                namespaceContextStack.declarePrefix(attributeName.getLocalName(), ((ValueString)attributeValue).getStringValue());
                                                attributeValuePair = factory.createAttributeValuePair(factory.createValueString(attributeName.getLocalName(), parentModule), attributeValue ,true , parentModule);
                                        }
                                        else if (attributeName.getNameSpace() == null && attributeName.getPrefixName() == null && attributeName.getLocalName() != null && attributeName.getLocalName().equals(XMLNS))
                                        {
                                                namespaceContextStack.declarePrefix("", ((ValueString)attributeValue).getStringValue());
                                                attributeValuePair = factory.createAttributeValuePair(factory.createValueString("",parentModule), attributeValue, true, parentModule);
                                        }
                                        else
                                        {
                                                attributeValuePair = factory.createAttributeValuePair(attributeName, attributeValue, false, parentModule);
                                        }
                                        if (attributeList == null)
                                        {
                                                attributeList = new ArrayList(1);
                                        }
                                        attributeList.add(attributeValuePair);
                                }
                                catch (TypeException te)
                                {
                                        {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                                }
        break;
      default:
        jj_la1[151] = jj_gen;
        ;
      }
    }
                {if (true) return attributeList;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[111]    AttributeValue    ::=    ('"' (EscapeQuot | QuotAttrValueContent)* '"') | ("'" (EscapeApos | AposAttrValueContent)* "'")
***************************************************************************************/
  final public XQueryExpression AttributeValue() throws ParseException, TypeException, XQueryException {
        XQueryExpression expression = null;
        ArrayList valueList = new ArrayList(1);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_TAG_QUOT:
      currentToken = jj_consume_token(START_TAG_QUOT);
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case QUOT_ATTRIBUTE_CONTENT_L_BRACE:
        case QUOT_ATTRIBUTE_CONTENT_EscapeQuot:
        case QUOT_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
        case QUOT_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
        case QUOT_ATTRIBUTE_CONTENT_PredefinedEntityRef:
        case QUOT_ATTRIBUTE_CONTENT_CharRef:
        case QUOT_ATTRIBUTE_CONTENT_QuotAttContentChar:
          ;
          break;
        default:
          jj_la1[152] = jj_gen;
          break label_27;
        }
        expression = QuotAttrValueContent();
                                        valueList.add(expression);
      }
      currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_QUOT);
      break;
    case START_TAG_APOS:
      currentToken = jj_consume_token(START_TAG_APOS);
      label_28:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case APOS_ATTRIBUTE_CONTENT_L_BRACE:
        case APOS_ATTRIBUTE_CONTENT_EscapeApos:
        case APOS_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
        case APOS_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
        case APOS_ATTRIBUTE_CONTENT_PredefinedEntityRef:
        case APOS_ATTRIBUTE_CONTENT_CharRef:
        case APOS_ATTRIBUTE_CONTENT_AposAttContentChar:
          ;
          break;
        default:
          jj_la1[153] = jj_gen;
          break label_28;
        }
        expression = AposAttrValueContent();
                                        valueList.add(expression);
      }
      currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_APOS);
      break;
    default:
      jj_la1[154] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (valueList.isEmpty())
                {
                        try
                        {
                                {if (true) return factory.createValueString("", parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
                else if (valueList.size() == 1)
                {
                        {if (true) return expression;}
                }
                else
                {
                        try
                        {
                                {if (true) return new FunctionCONCAT(valueList, parentModule);}
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
                }
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[112]    QuotAttrValueContent    ::=    QuotAttContentChar | CharRef | "{{" | "}}" | EnclosedExpr | PredefinedEntityRef
[28]    QuotAttContentChar    ::=    Char - ["{}<&] 
***************************************************************************************/
  final public XQueryExpression QuotAttrValueContent() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case QUOT_ATTRIBUTE_CONTENT_EscapeQuot:
    case QUOT_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
    case QUOT_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
    case QUOT_ATTRIBUTE_CONTENT_PredefinedEntityRef:
    case QUOT_ATTRIBUTE_CONTENT_CharRef:
    case QUOT_ATTRIBUTE_CONTENT_QuotAttContentChar:
      label_29:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case QUOT_ATTRIBUTE_CONTENT_EscapeQuot:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_EscapeQuot);
                                        buf.append("\"");
          break;
        case QUOT_ATTRIBUTE_CONTENT_QuotAttContentChar:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_QuotAttContentChar);
                                        buf.append(currentToken.image);
          break;
        case QUOT_ATTRIBUTE_CONTENT_CharRef:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_CharRef);
                                        buf.append(parseCharRef(currentToken.image));
          break;
        case QUOT_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE);
                                        buf.append("{");
          break;
        case QUOT_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE);
                                        buf.append("}");
          break;
        case QUOT_ATTRIBUTE_CONTENT_PredefinedEntityRef:
          currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_PredefinedEntityRef);
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[155] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_10(2)) {
          ;
        } else {
          break label_29;
        }
      }
                        try
                        {
                                expression = factory.createValueString(buf.toString(), parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case QUOT_ATTRIBUTE_CONTENT_L_BRACE:
      currentToken = jj_consume_token(QUOT_ATTRIBUTE_CONTENT_L_BRACE);
      expression = Expr(true);

      currentToken = jj_consume_token(R_BRACE);
      break;
    default:
      jj_la1[156] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

/***************************************************************************************
[113]    AposAttrValueContent    ::=    AposAttContentChar | CharRef | "{{" | "}}" | EnclosedExpr | PredefinedEntityRef 
[29]    AposAttContentChar    ::=    Char - ['{}<&] 
***************************************************************************************/
  final public XQueryExpression AposAttrValueContent() throws ParseException, TypeException, XQueryException {
        StringBuffer buf = new StringBuffer();
        XQueryExpression expression = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case APOS_ATTRIBUTE_CONTENT_EscapeApos:
    case APOS_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
    case APOS_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
    case APOS_ATTRIBUTE_CONTENT_PredefinedEntityRef:
    case APOS_ATTRIBUTE_CONTENT_CharRef:
    case APOS_ATTRIBUTE_CONTENT_AposAttContentChar:
      label_30:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case APOS_ATTRIBUTE_CONTENT_EscapeApos:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_EscapeApos);
                                        buf.append("\"");
          break;
        case APOS_ATTRIBUTE_CONTENT_AposAttContentChar:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_AposAttContentChar);
                                        buf.append(currentToken.image);
          break;
        case APOS_ATTRIBUTE_CONTENT_CharRef:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_CharRef);
                                        buf.append(parseCharRef(currentToken.image));
          break;
        case APOS_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE);
                                        buf.append("{");
          break;
        case APOS_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE);
                                        buf.append("}");
          break;
        case APOS_ATTRIBUTE_CONTENT_PredefinedEntityRef:
          currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_PredefinedEntityRef);
                                        buf.append(parsePredefinedEntityRef(currentToken.image));
          break;
        default:
          jj_la1[157] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        if (jj_2_11(2)) {
          ;
        } else {
          break label_30;
        }
      }
                        try
                        {
                                expression = factory.createValueString(buf.toString(), parentModule);
                        }
                        catch (TypeException te)
                        {
                                {if (true) throw new TypeException(te.getMessage(), currentToken.beginLine, currentToken.beginColumn);}
                        }
      break;
    case APOS_ATTRIBUTE_CONTENT_L_BRACE:
      currentToken = jj_consume_token(APOS_ATTRIBUTE_CONTENT_L_BRACE);
      expression = Expr(true);

      currentToken = jj_consume_token(R_BRACE);
      break;
    default:
      jj_la1[158] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_3R_73() {
    if (jj_scan_token(QNAME_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_83()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_3R_169()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(ELEMENT_CONTENT_CharRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_245() {
    if (jj_scan_token(VALIDATE_CONTEXT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_263()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_scan_token(VALIDATE_GLOBAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_scan_token(ELEMENT_CONTENT_ESCAPE_R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_scan_token(ELEMENT_CONTENT_ESCAPE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_272() {
    if (jj_scan_token(KINDTEST_TYPE_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_237() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_244()) {
    jj_scanpos = xsp;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(VALIDATE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_scan_token(L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_scan_token(ELEMENT_CONTENT_Char)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_271() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_263() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_271()) {
    jj_scanpos = xsp;
    if (jj_3R_272()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_233() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_236()) {
    jj_scanpos = xsp;
    if (jj_3R_237()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_scan_token(ELEMENT_CONTENT_WhiteChar)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_scan_token(DoubleLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_scan_token(KINDTEST_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_scan_token(CLOSEKINDTEST_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_3R_234()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() {
    if (jj_scan_token(DecimalLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_227() {
    if (jj_3R_233()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_36()) {
    jj_scanpos = xsp;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() {
    Token xsp;
    if (jj_3_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_8()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_206() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_227()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_116() {
    if (jj_scan_token(IntegerLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() {
    if (jj_scan_token(TYPESWITCH_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) {
    jj_scanpos = xsp;
    if (jj_3R_158()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(KINDTEST_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_scan_token(CLOSEKINDTEST_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_scan_token(OPERATOR_EXCEPT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_scan_token(XML_COMMENT_CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_248() {
    if (jj_scan_token(OPERATOR_INTERSECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_scan_token(StringLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_3R_99()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_241() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_248()) {
    jj_scanpos = xsp;
    if (jj_3R_249()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_206()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_scan_token(KINDTEST_TYPE_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(CLOSEKINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_scan_token(ELEMENT_CONTENT_XMLCOMMENT_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_80()) {
    jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_scan_token(XMLCOMMENT_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_127()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(XML_COMMENT_END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_3R_206()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_241()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_3()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_scan_token(PROCESSING_INSTRUCTION_CONTENT_CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_scan_token(OPERATOR_BAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_scan_token(OPERATOR_UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_296() {
    if (jj_scan_token(L_BRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_scan_token(EVERY_$)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_scan_token(ELEMENT_CONTENT_XMLPROCESSING_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_scan_token(SOME_$)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_235() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_242()) {
    jj_scanpos = xsp;
    if (jj_3R_243()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_199()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_279() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_296()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_scan_token(XMLPROCESSING_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3R_129()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(PROCESSING_INSTRUCTION_NCNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_130()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(PROCESSING_INSTRUCTION_CONTENT_PROCESSING_INSTRUCTION_END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_322() {
    if (jj_scan_token(CLOSEKINDTEST_COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_312() {
    if (jj_scan_token(CLOSEKINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_311() {
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_320() {
    if (jj_scan_token(KINDTEST_STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(OPERATOR_IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_319() {
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_185() {
    if (jj_3R_199()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_235()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_scan_token(CDATA_SECTION_CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_316() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_319()) {
    jj_scanpos = xsp;
    if (jj_3R_320()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_322()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() {
    if (jj_scan_token(ELEMENT_CONTENT_CDATA_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_scan_token(CDATA_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_310() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_316()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_304() {
    if (jj_scan_token(STAR_NCNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_184() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_197()) {
    jj_scanpos = xsp;
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_197() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_scan_token(ATTRIBUTE_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_311()) {
    jj_scanpos = xsp;
    if (jj_3R_312()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_303() {
    if (jj_scan_token(NCNAME_STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_131()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_133()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CDATA_SECTION_END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_302() {
    if (jj_scan_token(STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_184()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_185()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_301() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) {
    jj_scanpos = xsp;
    if (jj_3R_304()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_300() {
    if (jj_3R_301()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_232() {
    if (jj_scan_token(OPERATOR_MOD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_309() {
    if (jj_scan_token(CLOSEKINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_308() {
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_scan_token(QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_scan_token(TEXT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_140()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_scan_token(OPERATOR_IDIV)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_321() {
    if (jj_scan_token(CLOSEKINDTEST_COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_230() {
    if (jj_scan_token(OPERATOR_DIV)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_318() {
    if (jj_scan_token(KINDTEST_STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_317() {
    if (jj_scan_token(KINDTEST_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_299() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_scan_token(OPERATOR_STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_298() {
    if (jj_3R_299()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_315() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_317()) {
    jj_scanpos = xsp;
    if (jj_3R_318()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_321()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_297() {
    if (jj_3R_183()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_229()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_181()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_307() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_315()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_283() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_297()) {
    jj_scanpos = xsp;
    if (jj_3R_298()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() {
    if (jj_scan_token(NAMESPACE_NCNAME_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_226() {
    if (jj_scan_token(KINDTEST_ELEMENT_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_225() {
    if (jj_scan_token(ELEMENT_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_225()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_1()) {
    jj_scanpos = xsp;
    if (jj_3R_307()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_308()) {
    jj_scanpos = xsp;
    if (jj_3R_309()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_3R_181()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_207()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_295() {
    if (jj_scan_token(ANCESTOR_OR_SELF_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_294() {
    if (jj_scan_token(PRECEDING_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_209() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_293() {
    if (jj_scan_token(PRECEDING_SIBLING_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_scan_token(COMMENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_208() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_292() {
    if (jj_scan_token(ANCESTOR_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_291() {
    if (jj_scan_token(PARENT_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_176()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() {
    if (jj_scan_token(NODE_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_270() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_291()) {
    jj_scanpos = xsp;
    if (jj_3R_292()) {
    jj_scanpos = xsp;
    if (jj_3R_293()) {
    jj_scanpos = xsp;
    if (jj_3R_294()) {
    jj_scanpos = xsp;
    if (jj_3R_295()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_314() {
    if (jj_scan_token(KINDTESTFORPI_StringLiteral)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_scan_token(TEXT_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_313() {
    if (jj_scan_token(KINDTESTFORPI_NCNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_306() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_313()) {
    jj_scanpos = xsp;
    if (jj_3R_314()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_3R_176()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_200()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_scan_token(PROCESSING_INSTRUCTION_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_scan_token(COMMENT_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_scan_token(PROCESSING_INSTRUCTION_NCNAME_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_305() {
    if (jj_3R_204()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() {
    if (jj_scan_token(OPERATOR_TO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_170()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_scan_token(PROCESSING_INSTRUCTION_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_306()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTESTFORPI_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_192() {
    if (jj_3R_205()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_269() {
    if (jj_scan_token(DOTDOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_143()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() {
    if (jj_3R_204()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_190() {
    if (jj_scan_token(DOCUMENT_NODE_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_305()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(KINDTEST_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_3R_170()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_186()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_262() {
    if (jj_3R_270()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_283()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) {
    jj_scanpos = xsp;
    if (jj_3R_192()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) {
    jj_scanpos = xsp;
    if (jj_3R_196()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_261() {
    if (jj_3R_269()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_224() {
    if (jj_scan_token(OPERATOR_GREATER_GREATER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_257() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_261()) {
    jj_scanpos = xsp;
    if (jj_3R_262()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_scan_token(ATTRIBUTE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_223() {
    if (jj_scan_token(OPERATOR_LESS_LESS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_scan_token(ATTRIBUTE_QNAME_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_222() {
    if (jj_scan_token(OPERATOR_IS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_3R_171()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() {
    if (jj_scan_token(ITEMTYPE_EMPTY_L_PAREN_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_290() {
    if (jj_scan_token(FOLLOWING_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_222()) {
    jj_scanpos = xsp;
    if (jj_3R_223()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_289() {
    if (jj_scan_token(FOLLOWING_SIBLING_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_137()) {
    jj_scanpos = xsp;
    if (jj_3R_138()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_139()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_288() {
    if (jj_scan_token(DESCENDANT_SELF_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_scan_token(LET_$)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_165()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(OPERATOR_COLON_EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_215() {
    if (jj_scan_token(OPERATOR_GE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_287() {
    if (jj_scan_token(SELF_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_scan_token(ITEMTYPE_ITEM_L_PAREN_R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_scan_token(OPERATOR_GT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_286() {
    if (jj_scan_token(ATTRIBUTE_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_213() {
    if (jj_scan_token(OPERATOR_LE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_285() {
    if (jj_scan_token(DESCENDANT_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_3R_183()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_284() {
    if (jj_scan_token(CHILD_DCOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_212() {
    if (jj_scan_token(OPERATOR_LT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_211() {
    if (jj_scan_token(OPERATOR_NE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_268() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_284()) {
    jj_scanpos = xsp;
    if (jj_3R_285()) {
    jj_scanpos = xsp;
    if (jj_3R_286()) {
    jj_scanpos = xsp;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) {
    jj_scanpos = xsp;
    if (jj_3R_289()) {
    jj_scanpos = xsp;
    if (jj_3R_290()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() {
    if (jj_scan_token(ITEMTYPE_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_scan_token(OPERATOR_EQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_282() {
    if (jj_scan_token(AROBASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) {
    jj_scanpos = xsp;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) {
    jj_scanpos = xsp;
    if (jj_3R_215()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_136() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_scan_token(OPERATOR_GREATER_EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_scan_token(OPERATOR_GREATER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_267() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_282()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_283()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_167() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_scan_token(ELEMENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_219() {
    if (jj_scan_token(OPERATOR_LESS_EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_scan_token(OPERATOR_LESS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_scan_token(ELEMENT_QNAME_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_scan_token(OPERATOR_NOT_EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_216() {
    if (jj_scan_token(OPERATOR_EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_171() {
    if (jj_scan_token(OPERATOR_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_3R_171()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_PredefinedEntityRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_260() {
    if (jj_3R_268()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_283()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_134()) {
    jj_scanpos = xsp;
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_136()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_216()) {
    jj_scanpos = xsp;
    if (jj_3R_217()) {
    jj_scanpos = xsp;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) {
    jj_scanpos = xsp;
    if (jj_3R_220()) {
    jj_scanpos = xsp;
    if (jj_3R_221()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_259() {
    if (jj_3R_267()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_3R_203()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_3R_202()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_256() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_259()) {
    jj_scanpos = xsp;
    if (jj_3R_260()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() {
    if (jj_scan_token(FOR_$)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_163()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_164()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(OPERATOR_IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_CharRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_AposAttContentChar)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_187()) {
    jj_scanpos = xsp;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_162()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(APOS_ATTRIBUTE_CONTENT_EscapeApos)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_scan_token(DOCUMENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() {
    if (jj_3R_144()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_49()) {
    jj_scanpos = xsp;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_159() {
    if (jj_3R_162()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_182()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_3R_72()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_scan_token(OPERATOR_CAST_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ITEMTYPE_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_scan_token(DOLLAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() {
    Token xsp;
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_95()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_PredefinedEntityRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_ESCAPE_R_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_ESCAPE_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() {
    if (jj_3R_159()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_177()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_CharRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_255() {
    if (jj_3R_257()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_3R_256()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_QuotAttContentChar)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_scan_token(QUOT_ATTRIBUTE_CONTENT_EscapeQuot)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_scan_token(START_TAG_GREATER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_147()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ELEMENT_CONTENT_ELT_LESS_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_scan_token(START_TAG_SLASH_GREATER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_scan_token(OPERATOR_CASTABLE_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_253() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3R_254()) {
    jj_scanpos = xsp;
    if (jj_3R_255()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_279()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3R_44()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) {
    jj_scanpos = xsp;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_3R_151()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_173()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_281() {
    if (jj_scan_token(SLASH_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() {
    if (jj_scan_token(ELEMENT_CONTENT_ELT_LESS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_280() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_scan_token(TAG_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_266() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_280()) {
    jj_scanpos = xsp;
    if (jj_3R_281()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_253()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_scan_token(OPERATOR_TREAT_AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_167()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(START_TAG_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_276() {
    if (jj_scan_token(OPERATOR_PRESERVE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_275() {
    if (jj_scan_token(OPERATOR_SKIP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_274() {
    if (jj_scan_token(OPERATOR_STRICT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() {
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_166()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_3R_112()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_247() {
    if (jj_3R_253()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_266()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_3R_111()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_264() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_273()) {
    jj_scanpos = xsp;
    if (jj_3R_274()) {
    jj_scanpos = xsp;
    if (jj_3R_275()) {
    jj_scanpos = xsp;
    if (jj_3R_276()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_273() {
    if (jj_scan_token(OPERATOR_LAX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_3R_109()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() {
    if (jj_3R_108()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_3R_107()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() {
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_scan_token(OPERATOR_INSTANCE_OF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_167()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_3R_105()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(SORTBY_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_3R_88()) {
    jj_scanpos = xsp;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_160()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() {
    if (jj_scan_token(OPERATOR_AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_115()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_3R_247()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) {
    jj_scanpos = xsp;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) {
    jj_scanpos = xsp;
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_3R_115()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_152()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_scan_token(START_TAG_QNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_239() {
    if (jj_scan_token(SLASH_SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_247()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_258() {
    if (jj_3R_247()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(START_TAG_S)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_42()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() {
    if (jj_scan_token(OPERATOR_OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_9()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_278() {
    if (jj_scan_token(KINDTEST_GLOBAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_258()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_149()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_265() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_277() {
    if (jj_scan_token(KINDTEST_CONTEXT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_3R_105()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_100() {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_119()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_101() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_234() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_238()) {
    jj_scanpos = xsp;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_3R_161()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_252() {
    if (jj_scan_token(VALIDATE_SKIP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_251() {
    if (jj_scan_token(VALIDATE_STRICT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(ELEMENT_CONTENT_PredefinedEntityRef)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_101()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_250() {
    if (jj_scan_token(VALIDATE_LAX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_scan_token(IF_L_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(R_PAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() {
    if (jj_scan_token(L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_scan_token(ELEMENT_CONTENT_L_BRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_246() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_250()) {
    jj_scanpos = xsp;
    if (jj_3R_251()) {
    jj_scanpos = xsp;
    if (jj_3R_252()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_264()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_265()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public XQueryParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[159];
  final private int[] jj_la1_0 = {0x0,0xfe000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfe000000,0x0,0x0,0xfe000000,0x2000000,0x0,0x0,0xfe000000,0x2000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfe000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfe000000,0x0,0x0,0x0,0x0,0x0,0xfe000000,0xfe000000,0x0,0x0,0xfe000000,0x0,0xfe000000,0x0,0x0,0x0,0x0,0xfe000000,0x0,0x0,0x0,0x0,0x0,0xfe000000,0x0,0xfe000000,0x0,0x0,0x0,0x0,0x0,0x0,0xfe000000,0x0,0xfe000000,0x0,0xfe000000,0xfe000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x8000000,0xe7ffffff,0x0,0x400042e,0x400042e,0x0,0x0,0x0,0x0,0x0,0x0,0x10000000,0x0,0x0,0x10000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe3fffbc1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000000,0x0,0x0,0x10000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe3fffbc1,0xe000,0x0,0x0,0xf800,0xf800,0xe3ff03c1,0xe3ff03c1,0x0,0x0,0xe0000001,0x3ff03c0,0x20000001,0x20000000,0x0,0xc0000000,0xc0000000,0x1,0x1,0x1,0x0,0x0,0x0,0xe3fffbc1,0x0,0xe3fffbc1,0x3ff03c0,0x200,0x3c0,0x0,0x0,0x30000,0xe3fffbc1,0xc0000,0xe3fffbc1,0x1800000,0xe3fffbc1,0xe3fffbc1,0x100,0x0,0x80,0x0,0x40,0x0,0x0,0x3c0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_2 = {0x0,0x1bff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x44000,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1bff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8000,0x0,0x0,0x0,0x0,0x0,0x0,0xffa00000,0xffa00000,0xa0200000,0x1f800000,0x40000000,0x0,0x0,0x0,0x80000,0x80000,0x0,0x0,0x0,0x0,0x400000,0x400000,0x13ff,0x0,0x0,0x0,0x0,0x0,0x13ff,0x13ff,0x0,0x0,0x3ff,0x1000,0x23f,0x0,0x23f,0x1c0,0x1c0,0x0,0x0,0x0,0x0,0x0,0x0,0x1bff,0x0,0x1bff,0x0,0x0,0x0,0x0,0x0,0x0,0x1bff,0x0,0x1bff,0x0,0x1bff,0x1bff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_3 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1e00000,0x0,0x0,0x0,0x0,0x0,0x0,0x200,0x200,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100000,0x1800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1800,0x0,0x0,0x0,0x0,0x0,0x2000,0x0,0x20000000,0x0,0x0,0x40000000,0x0,0x80000000,0x4f0,0x4f0,0x4a0,0x0,0x50,0x20000,0x0,0x0,0x301,0x301,0x0,0x0,0xc0000,0xc0000,0x4,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_4 = {0x0,0x6efef80,0x8000000,0x3e000,0x3e000,0x1000000,0x0,0xc000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x0,0x0,0x80,0x1000,0x10000000,0x8000000,0x4,0x0,0x800020,0x800020,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000000,0x8000000,0x6ec0f80,0x8000000,0xc0000000,0xc0000000,0x0,0x0,0x8,0x300,0x300,0x0,0x0,0x0,0x4,0x0,0x8000000,0x4,0x0,0x4,0x8000000,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0xc00,0x8000000,0x2,0x80,0x80,0x0,0x0,0x0,0x1,0x20,0x0,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc00000,0xc00000,0x0,0x0,0xc00000,0xc00000,0x0,0x0,0x0,0x0,0x6240080,0x0,0x0,0x0,0x0,0x40000,0x200080,0x6200080,0x6000000,0x6000000,0x0,0x200080,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x100000,0x0,0x0,0x6ec0f80,0x8000000,0x6ec0f80,0x0,0x0,0x10000000,0x0,0x0,0x0,0x6ec0f80,0x0,0x6ec0f80,0x0,0x6ec0f80,0x6ec0f80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_5 = {0x0,0x3cf8,0x0,0x0,0x0,0x0,0x0,0x0,0x80000000,0x80000000,0x48000000,0x0,0x80000000,0x48000000,0x0,0x0,0x0,0x0,0x0,0x100,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3cf8,0x0,0x1,0x1,0x6,0x6,0x0,0x0,0x0,0x3f8000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18000,0x18000,0x3c0000,0x3c0000,0x7c0000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3cf8,0x0,0x0,0x0,0x0,0x0,0x3cf8,0x3cf8,0x0,0x0,0x2c10,0x10e8,0x2c00,0x0,0x0,0x10,0x0,0x2c00,0xc00,0xc00,0x0,0x10c8,0xc8,0x3cf8,0x0,0x3cf8,0x0,0x0,0x0,0x0,0x0,0x0,0x3cf8,0x0,0x3cf8,0x0,0x3cf8,0x3cf8,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_6 = {0x0,0x1000,0x0,0x0,0x0,0x0,0x30,0x0,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1300,0x0,0x0,0x1380,0x1000,0xc00000,0xc00000,0x1000,0x1000,0xc0000,0xc0000,0x8000000,0x2000000,0xc0000,0x1000800,0xc0000,0xc0000,0x2000000,0xc0000,0x1000800,0x180000,0x10002000,0x10002000,0x0,0x0,0x1000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000,0x0,0x18000,0x18000,0x0,0x0,0x1000,0x1000,0x0,0x0,0x1000,0x0,0x1000,0x0,0x0,0x0,0x0,0x1000,0x0,0x0,0x0,0x0,0x0,0x1000,0x0,0x1000,0x0,0x0,0x0,0x0,0xc0000000,0x0,0x1000,0x0,0x1000,0x0,0x1000,0x1000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_7 = {0x0,0xe40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0xe40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe40,0x0,0x0,0x0,0x0,0x0,0xe40,0xe40,0x0,0x0,0x0,0xe40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe40,0x0,0xe40,0xe40,0x40,0x3fec0,0x100000,0x0,0x0,0xe40,0x0,0xe40,0x0,0xe40,0xe40,0x800,0x80000000,0x400,0x20000000,0x200,0x800000,0x3f000,0x3fec0,0x8,0x8,0x20,0x0,0x0,0x3,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_8 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfe,0xfe00,0x0,0xfc,0xfe,0xfc00,0xfe00,};
  final private JJCalls[] jj_2_rtns = new JJCalls[11];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public XQueryParser(java.io.InputStream stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new XQueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public XQueryParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new XQueryParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public XQueryParser(XQueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(XQueryParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 159; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[272];
    for (int i = 0; i < 272; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 159; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
          if ((jj_la1_6[i] & (1<<j)) != 0) {
            la1tokens[192+j] = true;
          }
          if ((jj_la1_7[i] & (1<<j)) != 0) {
            la1tokens[224+j] = true;
          }
          if ((jj_la1_8[i] & (1<<j)) != 0) {
            la1tokens[256+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 272; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 11; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
